/**
 * Created by Zack on 2017/10/12.
 */

var BgLayer = cc.Layer.extend({
    bgSp: null,
    ctor: function () {
        this._super();
        Logic.bgLayer = this;
        this.initData();
        this.initUI();
    },
    initData: function () {
        this.bgSp = [];
    },
    initUI: function () {
        var isNormal = BgSkinManger.isNormal();
        var winSize = wb.getWinSize();

        for (var i = 0; i < 1; i++) {
            var sp = new cc.Sprite(BgSkinManger.getBgImagePath());
            sp.setAnchorPoint(cc.p(0, 0));
            this.addChild(sp);
            sp.y = 1136 * i;
            this.bgSp.push(sp);
            sp.setVisible(!isNormal);

            sp.setScaleY(winSize.height / 1136);
            sp.setScaleX(winSize.width / 640);
        }

        //var sp = new cc.Sprite(BgSkinManger.getBgImagePath());
        //sp.setAnchorPoint(cc.p(0, 0));
        //sp.setPosition(cc.p(0,0));
        //this.addChild(sp);
        //wb.scaleToSize(sp,wb.getWinSize());
        //sp.setVisible(!isNormal);
    },
    flushImage: function () {
        for (var i = 0; i < this.bgSp.length; i++) {
            this.bgSp[i].setTexture(BgSkinManger.getBgImagePath());
            this.bgSp[i].setVisible(!BgSkinManger.isNormal());
        }
    },
    update: function () {
        // for (var i = 0; i < 3; i++) {
        //     var sp = this.bgSp[i];
        //     sp.y = sp.y - SnakeHelper.gameSpeed
        //     if (sp.y <= -1136) sp.y = 0;
        // }
    }
});

var MoveLayer = cc.Layer.extend({
    _goodsList: null,
    _goodsItemList: null,
    _createLastGoods: false,
    _crowIndex: 0,
    _layerIndex: 1,
    ctor: function (index) {
        this._super();
        this._goodsList = [];
        this._layerIndex = index;

        //if(index == 1){
        //    var colorLayer = new cc.LayerColor(cc.color(125, 132, 0), 640, 1136);
        //    this.addChild(colorLayer);
        //}

    },
    createLayerGoodsByRow: function (row) {
        for (var j = 0; j < Config.MAP_W; j++) {
            this.createGoodsByIndex(j, row);
        }
    },
    createLastLayerGoods: function () {
        for (var j = 0; j < Config.MAP_W; j++) {
            this.createGoodsByIndex(j, Config.MAP_H - 1);
        }
    },
    createGoodsByIndex: function (j, i) {
        var goodsTypeMap = Logic.getGoodsMapByIndex(this._layerIndex);
        var item = goodsTypeMap[i][j];
        var goods = this.createGoods(i, j);

        goods.setGoodsType(item.goodsType);
        //  goods.setGoodsType(ItemType.Line);
        goods.setGoodsNum(item.goodsNum);

        if (item.goodsType == ItemType.HoleExit) {
            SnakeHelper.bkLayer.holeExitGoods = goods;
        }

    },
    createGoods: function (i, j) {
        var index = i * Config.MAP_W + j;
        if (this._goodsList[index]) return this._goodsList[index];
        // var goods = new Goods();
        var goods = GoodsManger.createGoods();
        goods.initOriginP(j, i);
        goods.listIndex = this._goodsList.length;
        this.addChild(goods, Config.MAP_H - i);
        this._goodsList.push(goods);
        goods.layerIndex = this._layerIndex;
        goods.setScale(Config.blockScale);
        return goods;
    },
    getGoodsByIndex: function (i, j) {
        var index = i * Config.MAP_W + j;
        if (this._goodsList[index]) return this._goodsList[index];
        return null;
    },
    update: function (dt) {
        this.moveDown(dt);
    },
    moveDown: function (dt) {
        var cy = this.getPositionY() - Config.SNAKE_SPEED;
        if (cy <= -Config.MAP_MOVEMIN) {
            this._crowIndex = 0;
            cy = Tool.winSize.height + Config.BLOCK_WH;
        }

        var dcy = cy - Tool.winSize.height;
        if (this._crowIndex < Config.MAP_H && dcy <= -this._crowIndex * Config.BLOCK_WH + Config.BLOCK_WH) {
            if (this._crowIndex == 8) {
                // 直线行
                Logic.createLastRowItemType(this._layerIndex);
                this.createLastLayerGoods();
            } else {
                Logic.createGoodsByRow(this._crowIndex, this._layerIndex);
                this.createLayerGoodsByRow(this._crowIndex);
            }
            this._crowIndex = this._crowIndex + 1;
        }

        this.setPositionY(cy);
    },
    getCurrentGood: function (p) {
        var cpy = this.getPosition();
        var csnakeP = p;
        var dy = csnakeP.y - cpy.y;
        if (dy < 0 || dy > Config.MAP_MOVEMIN) return null;

        var j = Math.floor(csnakeP.x / Config.BLOCK_WH);
        var i = Math.floor(dy / Config.BLOCK_WH);
        var index = j + i * Config.MAP_W;
        if (index > this._goodsList.length - 1 || index < 0) return null;
        return this._goodsList[index];
    },
    setGoodsSpecialType: function (type) {
        for (var i = 0; i < this._goodsList.length; i++) {
            var goods = this._goodsList[i];
            if (goods) goods.setSpecialType(type);
        }
    }
});

// 背景层
var BkLayer = wb.BaseLayer.extend({
    _moveLayer1: null,
    _moveLayer2: null,
    _windLayer: null,
    isGaming: false,
    isMoveEnable: true,
    isSnakeRuning: true,
    isGoodsRuning: true,
    itemLayer: null,
    cScoreLabel: null,
    timeLabel: null,
    timeN: -1,
    isFrozen: false,
    isGetCoin: false,
    holeExitGoods: null, // 出口洞
    // decelerateV: -1,// 匀减速，直到到指定y轴
    holeRect: null, // 虫洞掩盖区域
    holeRectMoveY: 0,
    holeRect2: null,
    ctor: function () {
        this._super(res.gameScene_json);
        cc.log("BkLayer init~~~~~~~");

        this.initData();
        this.initUI();

        this.scheduleUpdate();
      //  this.schedule(this.update, 0.01);
        this.schedule(this.timeSub, 1.0);

    },
    // 超越好友
    drawCyhyScore: function () {
        var cyPanel = wb.FW(this.rootNode, "cyPanel");
        var cyPanellSize = cyPanel.getContentSize();

        var winSize = wb.getWinSize();

        var wxHeadPanel = wb.FW(cyPanel, "wxHeadPanel");
        var wxNamePanel = wb.FW(cyPanel, "wxNamePanel");
        var wxScorePanel = wb.FW(cyPanel, "wxScorePanel");
        var wxJjcyPanel = wb.FW(cyPanel, "wxJjcyPanel");
        var cydiImage = wb.FW(cyPanel, "cydiImage");
        cydiImage.setVisible(false);

        //  var wxHeadPanelP = cyPanel.convertToNodeSpace(wb.convertToWP(wxHeadPanel));
        // var wxNamePanelP = cyPanel.convertToNodeSpace(wb.convertToWP(wxNamePanel));
        // var wxScorePanelP = cyPanel.convertToNodeSpace(wb.convertToWP(wxScorePanel));

        var wxHeadPanelP = wxHeadPanel.getPosition();
        var wxHeadPanelSize = wxHeadPanel.getContentSize();

        var wxNamePanelP = wxNamePanel.getPosition();
        var wxNamePanelSize = wxNamePanel.getContentSize();

        var wxScorePanelP = wxScorePanel.getPosition();
        var wxScorePanelSize = wxScorePanel.getContentSize();

        var wxJjcyPanelP = wxJjcyPanel.getPosition();
        var wxJjcyPanelSize = wxJjcyPanel.getContentSize();

        var cydiImageP = cydiImage.getPosition();
        var cydiImageSize = cydiImage.getContentSize();

        var data = {
            funcName: "drawCyhyScore",
            score: Logic.score,
            caSize: {w: cyPanellSize.width, h: 0},
            wxHeadPanelP: cc.p(wxHeadPanelP.x, winSize.height - wxHeadPanelP.y - wxHeadPanelSize.height),
            wxNamePanelP: cc.p(wxNamePanelP.x + wxNamePanelSize.width / 2, winSize.height - wxNamePanelP.y),
            wxScorePanelP: cc.p(wxScorePanelP.x + wxScorePanelSize.width / 2, winSize.height - wxScorePanelP.y),
            wxJjcyPanelP: cc.p(wxJjcyPanelP.x + wxJjcyPanelSize.width / 2, winSize.height - wxJjcyPanelP.y),
            cydiImageP: cc.p(cydiImageP.x, winSize.height - cydiImageP.y - cydiImageSize.height)
        };

        var canvas = wb.wx.getOpenDataCanvas();
        if (!canvas) return;

        canvas.width = 640;
        canvas.height = 1136;
        //   wb.wx.postMessage(data);
        var cySp = new cc.Sprite();
        cySp.setAnchorPoint(cc.p(0, 0));
        cyPanel.addChild(cySp, 10);
        // var texture = new cc.Texture2D();
        // texture.initWithElement(canvas);
        // texture.handleLoadedTexture();
        // cySp.setTexture(texture);
        this.cySp = cySp;
        this.cyData = data;
        wb.wx.postMessage(data);
        // this.flushCySp();
        this.unschedule(this.flushCySp);
        this.scheduleOnce(this.flushCySp, 1, "flushCySp");
    },
    flushCySp: function () {
        if (!this.cySp || !this.cySp.isVisible()) return;

        var texture = new cc.Texture2D();
        texture.initWithElement(wb.wx.getOpenDataCanvas());
        texture.handleLoadedTexture();
        this.cySp.setTexture(texture);
    },
    flushBanner: function () {
        if (!this.isGaming) return;
        Tool.showBanner(Config.bannerId4);
    },
    initData: function () {
        // this.initSnake();
        wb.wx.postMessage({
            funcName: "setCyScore",
            score: 0
        });
        this.cySp = null;
        SnakeHelper.bkLayer = this;
        this.rootNode.setLocalZOrder(40);

        wb.EventManager.addCustomEventListener("flushBk", function () {
            this.flushUI();
        }.bind(this), this);
    },
    flushUI: function () {
        var isDarkStyle = BgSkinManger.isDarkStyle();
        if (isDarkStyle) {
            this.pauseBtn.loadTextures("res/gameNew/bzt.png", "res/gameNew/bzt.png");
            this.cScoreLabel.setColor(Config.WHITE_COLOR);
            //SnakeHelper.snakeHead._numLabel.setColor(Config.WHITE_COLOR);
        }
        else {
            this.pauseBtn.loadTextures("res/gameNew/zt.png", "res/gameNew/zt.png");
            this.cScoreLabel.setColor(Config.BK_COLOR);
            // SnakeHelper.snakeHead._numLabel.setColor(Config.BK_COLOR);
        }
    },
    initUI: function () {

        this.bgLayer = new BgLayer();
        this.addChild(this.bgLayer);

        this._moveLayer1 = new MoveLayer(1);
        this._moveLayer1.setPositionY(Tool.winSize.height + Config.BLOCK_WH);
        this.addChild(this._moveLayer1, 1);

        this._moveLayer2 = new MoveLayer(2);
        this._moveLayer2.setPositionY(Tool.winSize.height + Config.MAP_MOVEMIN + Config.BLOCK_WH);
        this.addChild(this._moveLayer2, 1);

        this.cScoreLabel = wb.FW(this.rootNode, "scoreText");

        this.timeLabel = wb.FW(this.rootNode, "timeText");
        this.timeLabel.setVisible(false);

        this.toastLabel = wb.FW(this.rootNode, "toastText");
        this.toastLabel.setVisible(false);
        this.pauseBtn = wb.FW(this.rootNode, "pauseBtn");
        this.pauseBtn.setTouchEnabled(false);

        wb.FW(this.rootNode, "pausePanel", function () {
            SceneManger.showPause();
        }.bind(this));


        this.itemLayer = wb.FW(this.rootNode, "uiPanel");
        this.itemLayer.setVisible(false);

        // 雪花倒计时
        var xhPanel = wb.FW(this.rootNode, "xhPanel");
        var xhLoading = new cc.ProgressTimer(new cc.Sprite("res/gameNew/time_02.png"));
        xhLoading.type = cc.ProgressTimer.TYPE_RADIAL;
        xhPanel.addChild(xhLoading);
        this.xhLoading = xhLoading;
        this.xhPanel = xhPanel;
        this.xhPanel.setVisible(false);

        // 星星倒计时
        var xxPanel = wb.FW(this.rootNode, "xxPanel");
        var xxLoading = new cc.ProgressTimer(new cc.Sprite("res/gameNew/time_02.png"));
        xxLoading.type = cc.ProgressTimer.TYPE_RADIAL;
        xxPanel.addChild(xxLoading);
        this.xxLoading = xxLoading;
        this.xxPanel = xxPanel;
        this.xxPanel.setVisible(false);

        this.djList = [this.xhPanel, this.xxPanel];
        //var to = cc.progressFromTo(10, 100, 0);
        //loading.runAction(cc.sequence(to, cc.callFunc(function (tag) {
        //    //this._circlebg.runAction(cc.scaleTo(0.2, 1));
        //}, this)));

    },
    timeSub: function (dt) {
        if (this.isFrozen) this.frozenTimeSub(dt);
        if (this.isGetCoin) this.coinTimeSub(dt);
    },
    frozenTimeSub: function (dt) {
        if (this.timeN <= 0) {
            this.timeLabel.setVisible(false);
            Config.SNAKE_SPEED = Config.NORMAL_SPEED;
            this.isFrozen = false;
            this.setGoodsSpecialType(SpecialType.None);
            return;
        } else {
            this.timeLabel.setString("" + this.timeN);
            this.timeN = this.timeN - 1;
            this.timeLabel.runAction(cc.sequence(cc.scaleTo(0.1, 1.2), cc.scaleTo(0.1, 1.0)));


        }
    },
    coinTimeSub: function (dt) {
        if (this.timeN <= 0) {
            this.isGetCoin = false;
            this.timeLabel.setVisible(false);
            Config.SNAKE_SPEED = Config.NORMAL_SPEED;
            if (this._windLayer) this._windLayer.removeFromParent();
        } else {
            this.timeLabel.setString("" + this.timeN);
            this.timeN = this.timeN - 1;
            this.timeLabel.runAction(cc.sequence(cc.scaleTo(0.1, 1.2), cc.scaleTo(0.1, 1.0)));
        }
    },
    setTimeN: function (t) {
        this.timeN = t;
        //if (t > 0) this.timeLabel.setVisible(true);
        //else this.timeLabel.setVisible(false);

        if (this.isFrozen) {
            this.xhPanel.setVisible(true);
            var to = cc.progressFromTo(t, 100, 0);
            this.xhLoading.runAction(cc.sequence(to, cc.callFunc(function (tag) {
                this.xhPanel.setVisible(false);
                this.flushDjPosition();

            }, this)));
        } else if (this.isGetCoin) {
            this.xxPanel.setVisible(true);
            var to = cc.progressFromTo(t, 100, 0);
            this.xxLoading.runAction(cc.sequence(to, cc.callFunc(function (tag) {
                this.xxPanel.setVisible(false);
                this.flushDjPosition();
            }, this)));
        }

        //this.xhPanel.setVisible(true);
        //this.xxPanel.setVisible(true);
        this.flushDjPosition();
    },
    // 刷新道具位置
    flushDjPosition: function () {
        var list = [];
        for (var i = 0; i < this.djList.length; i++) {
            if (this.djList[i].isVisible()) list.push(this.djList[i]);
        }
        var cX = 320;
        var dw = 80;
        cX = cX - parseInt(list.length / 2) * dw / 2;
        cc.log(cX);
        for (var i = 0; i < list.length; i++) {
            list[i].x = cX + i * dw;
        }
    },
    initSnake: function () {
        SnakeHelper.snakeHead = SnakeHelper.createSnake(Config.beganSnakeL, this);

    },
    update: function (dt) {
        if (!this.isGaming) return;

        this.updateSnake(dt);
        this.updateGoodsLayer(dt);
        this.updateHoleRect(dt);
    },
    updateSnake: function (dt) {
        if (!this.isSnakeRuning) return;
        if (!SnakeHelper.snakeHead) return;
        // 先减再增
        SnakeHelper.adjustP();
        SnakeHelper.addPath(cc.p(0, Config.SNAKE_SPEED));
    },
    updateHoleRect: function (dt) {
        if (this.holeRect) {
            this.holeRect.y = this.holeRect.y - Config.SNAKE_SPEED;
            this.holeHideSnake();
            if (this.holeRect.y <= -this.holeRect.height) {
                this.holeRect = null;
                var node = SnakeHelper.snakeHead;
                do {
                    if (!node) break;
                    node.setVisible(true);
                    node = node.getNextSnakeNode();
                } while (true);
            }
        }
    },
    updateGoodsLayer: function (dt) {
        if (!this.isGoodsRuning) return;
        this._moveLayer1.update(dt);
        this._moveLayer2.update(dt);
    },
    getCurrentGood: function (p) {
        var goods = this._moveLayer1.getCurrentGood(p);
        if (!goods) return this._moveLayer2.getCurrentGood(p);
        return goods;
    },
    gameOver: function () {
        if (Logic.reviveNum >= 2 || Config.isAllUnLock) {
            SceneManger.showEnd();
            if (this.cySp) {
                this.cySp.setVisible(false);
                this.cySp.removeFromParent();
            }
        } else {
            SceneManger.showRevive();
        }
    },
    flushCScoreLabel: function (num) {
        var n = 1;
        if (num) n = num;
        var sum = this.getCScore() + n;
        this.cScoreLabel.setString(sum);
        Logic.changeGPer();
        Logic.coinScore = Logic.coinScore + n;
        Logic.checkGetCoinMode();

        Logic.score = sum;

        SnakeLevelManger.dealSnakeLevel(Logic.score);

        // 超越好友
        if (this.cyData) {
            cc.log("this.cyData ~~~~~~~~~~~");
            this.cyData.score = Logic.score;
            wb.wx.postMessage(this.cyData);
            this.unschedule(this.flushCySp);
            this.scheduleOnce(this.flushCySp, 1, "flushCySp");
        }
        //if(!this.isFrozen && !this.isGetCoin){
        //    Logic.addSnakeSpeed(this.getCScore());
        //}
    },
    getCScore: function () {
        return parseInt(this.cScoreLabel.getString());
    },
    setGoodsSpecialType: function (type) {
        this._moveLayer1.setGoodsSpecialType(type);
        this._moveLayer2.setGoodsSpecialType(type);
    },

    holeHideSnake: function () {
        var snakeHeade = SnakeHelper.snakeHead;
        var node = snakeHeade.getNextSnakeNode();
        do {
            if (!node) break;
            // 隐藏
            if (cc.rectContainsPoint(this.holeRect, node.getPosition())) node.setVisible(false);
            else node.setVisible(true);
            node = node.getNextSnakeNode();
        } while (true);

        // 从洞口钻出
        if (snakeHeade.getPositionY() > this.holeRect.y + this.holeRect.height) {
            snakeHeade.setVisible(true);
            // 可移动
            SnakeHelper.bkLayer.isMoveEnable = true;
            SnakeHelper.isHoleing = false;
        } else {
            snakeHeade.setVisible(false);
        }
    },
    showToast: function (type) {
        return;

        //cc.log("showToast" + type);
        this.toastLabel.stopAllActions();
        this.toastLabel.setString("");
        this.toastLabel.setOpacity(255);

        var action = null;
        var action1 = cc.sequence(cc.scaleTo(0.08, 1.2),
            cc.scaleTo(0.08, 1.0),
            cc.delayTime(2),
            cc.fadeOut(1)
        );

        if (type == SpecialType.Ice) {
            this.toastLabel.setString("冰冻");
            this.toastLabel.setColor(cc.color(85, 148, 232));
            action = action1;
        } else if (type == SpecialType.Shield) {
            this.toastLabel.setString("护盾");
            this.toastLabel.setColor(cc.color(252, 250, 62));
            action = action1;
        } else if (type == SpecialType.Coin) {
            this.toastLabel.setString("+2");
            this.toastLabel.setColor(cc.color(252, 249, 129));
            action = cc.sequence(cc.scaleTo(0.05, 1.2), cc.scaleTo(0.05, 1.0), cc.fadeOut(0.5));
        } else if (type == SpecialType.CoinTip) {
            var label = new cc.LabelTTF("获取星星吧!", res.Hk7_font, 75);
            label.setPosition(cc.p(Config.CENTER_P.x, Config.WINSIZEF().height - 230));
            label.setColor(cc.color(236, 225, 49));
            this.addChild(label, 10);
            label.runAction(cc.sequence(cc.blink(2, 8), cc.removeSelf()));
            action = null;
        } else if (type == SpecialType.Hole) {
            this.toastLabel.setString("虫洞");
            this.toastLabel.setColor(cc.color(62, 147, 243));
            action = action1;
        }

        if (action) {
            this.toastLabel.setVisible(true);
            this.toastLabel.runAction(action);
        }
    },
    showGuide: function (item) {

        if (this.iskk) return;
        this.iskk = true;
        var good = new Goods();
        good.setGoodsType(ItemType.Block);
        good.setGoodsNum(item.getGoodsNum());
        good.setPosition(cc.p(200, 200));
        this.addChild(good, 10);
    },
    createBreakSp: function (str, moveLayer) {
        if (!this[str]) {
            this[str] = GameSpine.createSsSp(cc.p(0, 0), moveLayer);
        }
        return this[str];
    },
    showSsSpine: function (goods, func) {
        var spine = null;
        //  cc.log("goods.layerIndex " + goods.layerIndex);
        if (goods.layerIndex == 1) {
            if (this.isFrozen) {
                if (!this.ssSpineFrozen1) this.ssSpineFrozen1 = GameSpine.createSsSp(cc.p(0, 0), this._moveLayer1);
                //   this.ssSpineFrozen1.setAnimation(0, "action2", false);
                spine = this.ssSpineFrozen1;
            } else {
                if (!this.ssSpineNormal1) this.ssSpineNormal1 = GameSpine.createSsSp(cc.p(0, 0), this._moveLayer1);
                //   this.ssSpineNormal1.setAnimation(0, "action1", false);
                spine = this.ssSpineNormal1;
            }
        } else {
            if (this.isFrozen) {
                if (!this.ssSpineFrozen2) this.ssSpineFrozen2 = GameSpine.createSsSp(cc.p(0, 0), this._moveLayer2);
                this.ssSpineFrozen2.setAnimation(0, "action2", false);
                spine = this.ssSpineFrozen2;
            } else {
                if (!this.ssSpineNormal2) this.ssSpineNormal2 = GameSpine.createSsSp(cc.p(0, 0), this._moveLayer2);
                //  this.ssSpineNormal2.setAnimation(0, "action1", false);
                spine = this.ssSpineNormal2;
            }
        }
        spine.setPosition(goods.getPosition());

        if (this.isFrozen) {
            cc.log("action2");
            spine.setAnimation(0, "action2", false);
        } else {
            cc.log("action1");
            spine.setAnimation(0, "action1", false);
        }
        //

    },
    showXssSpine: function (goods) {

        var spine = null;
        if (goods.layerIndex == 1) {
            if (!this.xssSpine1) {
                this.xssSpine1 = GameSpine.createXssSp(cc.p(0, 0), this._moveLayer1);
                this.xssSpine1.setCompleteListener(function (traceIndex, loopCount) {
                    this.xssSpine1.setVisible(false);
                }.bind(this));
                this.xssSpine1.setVisible(false);
            }
            spine = this.xssSpine1;
        } else {
            if (!this.xssSpine2) {
                this.xssSpine2 = GameSpine.createXssSp(cc.p(0, 0), this._moveLayer2);
                this.xssSpine2.setCompleteListener(function (traceIndex, loopCount) {
                    this.xssSpine2.setVisible(false);
                }.bind(this));
                this.xssSpine2.setVisible(false);
            }
            spine = this.xssSpine2;
        }
        if (!spine.isVisible()) {
            spine.x = goods.x;
            spine.y = goods.y - 30;

            if (this.isFrozen) {
                spine.setAnimation(0, "action5", false);
            } else {
                var index = parseInt(goods._goodsNum / 15) + 1;
                spine.setAnimation(0, "action" + index, false);
            }
            spine.setVisible(true);
        }

        spine.setLocalZOrder(-1);

        //if (!this.xssSpine) this.xssSpine = GameSpine.createXssSp(cc.p(0, 0), parent);
        //this.xssSpine.setParent(parent);
        //var index = parseInt(parent._goodsNum / 15) + 1;
        //this.xssSpine.setAnimation(0, "0" + index, true);

    }
});
