/**
 * Created by 13075 on 2017/11/13.
 */
var EndLayer = wb.BaseLayer.extend({
    ctor: function () {
        this._super(res.endScene_json);
        this.initData();
        this.initUI();
    },
    onEnter: function () {
        this._super();
        Tool.showBanner();
        wb.ADManager.openAd("level_fail");
    },
    initData: function () {
        this.schedule(this.flushRank, 1);

        wb.EventManager.addCustomEventListener("rankLayerClose", function (event) {
            this.initFr();
        }.bind(this), this);
    },
    initUI: function () {

        wb.FW(this.rootNode, "xyBtn", function () {
            wb.wxTool.fxMessage("account");
            // wb.wxHelper.tj("button", "tap-gameEnd-xyBtn");
        }.bind(this));

        wb.FW(this.rootNode, "fhBtn", function () {
            SceneManger.gameMain(false);
            wb.wxHelper.tj("button", "FanHui", "JieSuan ");
        }.bind(this));

        //wb.FW(this.rootNode, "zwBtn", function () {
        //    SceneManger.gameMain(true);
        //    Tool.showBanner();
        //}.bind(this));

        this.moreBtn = wb.FW(this.rootNode, "moreBtn", function () {
        }.bind(this));
        this.moreBtn.setVisible(false);

        wb.FW(this.rootNode, "wzphText", function () {
            cc.log("wzphText");
            SceneManger.showRank();
            wb.wxHelper.tj("button", "JinRuPaiHang", "JieSuan");
        }.bind(this));

        var cScore = SnakeHelper.bkLayer.getCScore();
        if (cScore >= 150) {
            Tool.rewardNum++;
            if (Tool.rewardNum >= 3) {
                SceneManger.showTip(Config.TipStr.hdszs_tip);
                Tool.addDiamond(10);
                Tool.rewardNum = 0;
            }
        }
        if (cScore > Tool.bestScore) {
            this.sendHttpRequest(cScore);
            Tool.saveBestScore(cScore);
        }
        Tool.flushCScore();

        var scoreText = wb.FW(this.rootNode, "scoreText");
        scoreText.setString(cScore);
        var lszgScoreText = wb.FW(this.rootNode, "lszgScoreText");
        lszgScoreText.setString(Tool.bestScore);
        cc.log("Tool.bestScore" + Tool.bestScore);

        this.kImage = wb.FW(this.rootNode, "kImagePanel");
        this.wxPanel = wb.FW(this.rootNode, "wxPanel");
        this.wxPanel.setVisible(false);

        //  cScore = 250;
        var zsNum = Math.round(cScore / 100);
        wb.FW(this.rootNode, "zhzsText").setString(zsNum);
        wb.FW(this.rootNode, "jhdText").setString("将获得" + zsNum + "钻石");
        Tool.addDiamond(zsNum);

        var sbBtn = wb.FW(this.rootNode, "sbBtn", function () {
            cc.log("sbBtn");
            if(!wb.ADManager.isAdReady("double_mfzs")){
                SceneManger.showTip("视频未准备好~");
                return;
            }

            wb.wxHelper.tj("video ", "ShuangBeiFenShu", "JieSuan ");
            sbBtn.setTouchEnabled(false);
            wb.ADManager.openAdC("double_mfzs", function (a, result) {
                sbBtn.setTouchEnabled(true);

                if (result == 0) {
                    Tool.addDiamond(zsNum);
                    scoreText.setString(cScore * 2);
                    SceneManger.showTip("获得钻石" + zsNum, function () {
                        SceneManger.gameMain(false);
                    });
                    Tool.saveBestScore(cScore * 2);

                    lszgScoreText.setString(Tool.bestScore);
                } else {
                    SceneManger.showTip("视频未播放完~");
                }
            }.bind(this));
        });
        if (Config.isAllUnLock) sbBtn.setVisible(false);

        this.initFr();
        this.showBottomBtn();
    },
    initFr: function () {
        var hhImage1 = wb.FW(this.rootNode, "hhImage1");
        var hhImage2 = wb.FW(this.rootNode, "hhImage2");

        var scoreTextP = wb.FW(this.rootNode, "scoreText1").getPosition();
        var nameTextP = wb.FW(this.rootNode, "nameText1").getPosition();

        var hgDwT = hhImage2.getPositionX() - hhImage1.getPositionX();

        var wxPanelSize = this.wxPanel.getContentSize();
        var hg1ImageP = hhImage1.getPosition();
        var tx1PanelP = wb.FW(this.rootNode, "rankPanel1").getPosition();

        var data = {
            funcName: "gameOverRankSelf",
            hgDw: hgDwT,
            caSize: {w: wxPanelSize.width, h: wxPanelSize.height},
            hg1ImageP: cc.p(hg1ImageP.x, wxPanelSize.height - hg1ImageP.y),
            tx1PanelP: cc.p(tx1PanelP.x, wxPanelSize.height - tx1PanelP.y),
            scoreTextP: cc.p(scoreTextP.x, wxPanelSize.height - scoreTextP.y),
            nameTextP: cc.p(nameTextP.x, wxPanelSize.height - nameTextP.y),
            openid: Tool.userId
        };
        this.initRank(data);

    },
    sendHttpRequest: function (cScore) {
        var data = {
            user_id: Tool.userId,
            user_name: Tool.nickname,
            user_score: "" + cScore,
            project_id: Config.PRJID,
            user_icon: Tool.headurl
        };
        wb.wxHelper.httpRequest("https://api.vzhifu.net/superm/postscore", data);
    },
    httpFunc: function (responseText) {
        cc.log("end httpFunc");
    },
    rankSp: null,
    initRank: function (data) {

        var canvas = wb.wx.getOpenDataCanvas();
        if (!canvas) return;

        canvas.width = 640;
        canvas.height = 1136;

        if (this.rankSp) {
            this.rankSp.removeFromParent();
            this.rankSp = null;
        }
        wb.wx.postMessage(data);

        var rankSp = new cc.Sprite();
        rankSp.setContentSize(cc.size(data.caSize.w, data.caSize.h));
        rankSp.setAnchorPoint(cc.p(0, 1));
        rankSp.setPositionY(data.caSize.h);
        this.rankSp = rankSp;
        this.kImage.addChild(rankSp);
    },
    flushRank: function () {
        if (!this.rankSp) return;

        var texture = new cc.Texture2D();
        texture.initWithElement(wb.wx.getOpenDataCanvas());
        texture.handleLoadedTexture();
        this.rankSp.setTexture(texture);
    },
    showBottomBtn: function () {
        var diImage = wb.FW(this.rootNode, "htImage");
        diImage.setVisible(false);

        if (!wb.isWX()) return;
        if (!wb.wxData.pushData) return;
        if (this.isShowBottomBtn) return;

        this.isShowBottomBtn = true;

        var mBtn = wb.createPushAdBtn(null, null, cc.size(70, 70));
        if (mBtn) {
            mBtn.setPlacement("gameEnd");
            mBtn.setPosition(this.moreBtn.getPosition());
            this.moreBtn.getParent().addChild(mBtn, 4);
            mBtn.runAction(cc.sequence(cc.scaleTo(0.2, 1.35), cc.scaleTo(0.2, 1.2), cc.delayTime(2)).repeatForever());
        }

        //var diImage = wb.FW(this.rootNode, "htImage");
        //diImage.setVisible(false);
        var pushAdLayer = wb.createPushAdLayer("gameEnd");
        if (pushAdLayer) {
            pushAdLayer.setPosition(diImage.getPosition());
            diImage.getParent().addChild(pushAdLayer);
        }

        var plaqueLayer = wb.createPushPlaqueWs();
        if (plaqueLayer) this.addChild(plaqueLayer, 100);
    }
});