/**
 * Created by Zack on 2017/10/11.
 */

wb.wx.onShow(function () {
    cc.log("wb.wx.onShow");
    Logic.isTouching = false;

    Tool.playDefaultMusic();
});


wb.wx.onHide(function () {
    cc.log("wb.wx.onHide");
});


var GradientLayer = cc.Layer.extend({
    ctor: function () {
        this._super();
        var shadeLayer = new cc.LayerColor(cc.color(37, 37, 37));
        this.addChild(shadeLayer);
    }
});

var GameMainLayer = cc.Layer.extend({
    sprite: null,
    bkLayer: null,
    beganLayer: null,
    //isTouching: false,
    ctor: function () {
        this._super();
        cc.log("GameMainLayer ctor");
        SnakeHelper.gameMain = this;

        var gradientLayer = new GradientLayer();
        this.addChild(gradientLayer);

        this.bkLayer = new BkLayer();
        this.addChild(this.bkLayer);


        if (!Logic.dStartGame) {
            this.beganLayer = new BeganLayer();
            this.addChild(this.beganLayer);
        } else {
            this.bkLayer.initSnake();
            SnakeHelper.bkLayer.isGaming = true;
            SnakeHelper.bkLayer.itemLayer.setVisible(true);
            SnakeHelper.bkLayer.drawCyhyScore();
        }


        this.addTouchListener();

        Tool.playMusic(res.bk1_mp3, true);
        return true;
    },
    onExit: function () {
        this._super();
        cc.log("onExit~~~~~~~~~");
    },
    addTouchListener: function () {

        cc.eventManager.addListener({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: this.onTouchBegan,
            onTouchMoved: this.onTouchMoved,
            onTouchEnded: this.onTouchEnded,
            onTouchCancelled: this.onTouchCancelled
        }, this);
    },
    onTouchBegan: function (touch, event) {
        cc.log("onTouchBegan");
        if (Logic.isTouching) return false;
        //  cc.log("onTouchBegan2");
        var tag = event.getCurrentTarget();
        var pos = touch.getLocation();
        tag._startPoint = pos;
        Logic.isTouching = true;
        return true;
    },
    onTouchMoved: function (touch, event) {
        // cc.log("onTouchMoved");
        if (!SnakeHelper.bkLayer.isGaming) return;
        if (!SnakeHelper.bkLayer.isMoveEnable) return;
        var tag = event.getCurrentTarget();
        var pos = touch.getLocation();
        //  var dp = cc.p(pos.x - tag._startPoint.x, pos.y - tag._startPoint.y);
        var dp = cc.p(pos.x - tag._startPoint.x, 0);
        SnakeHelper.addPath(dp);
        tag._startPoint = pos;
    },
    onTouchEnded: function (touch, event) {
        //cc.log("onTouchEnded");
        var tag = event.getCurrentTarget();
        tag._startPoint = touch.getLocation();
        Logic.isTouching = false;
    },
    onTouchCancelled: function (touch, event) {
        //cc.log("onTouchCancelled");
        var tag = event.getCurrentTarget();
        tag._startPoint = touch.getLocation();
        Logic.isTouching = false;
    }
});

var GameMainScene = cc.Scene.extend({
    onEnter: function () {
        this._super();
        Logic.init();
        SnakeHelper.init();
        GuideManger.init();
        var layer = new GameMainLayer();
        this.addChild(layer);
    }
});
