/**
 * Created by 13075 on 2017/11/13.
 */


var GameOverLayer = cc.Layer.extend({
    _scoreLabel: null,
    _loading: null,
    _infoLabel: null,
    _circlebg: null,
    _scoreLayer: null,
    _circleLayer: null,
    _replayMenuItem: null,
    _reviveMenuItem: null,
    ctor: function () {
        this._super();

        var bkLayer = new cc.LayerColor(cc.color(0, 0, 0, 200));
        this.addChild(bkLayer);

        this.createScoreLayer();
        var fadeTime = 0.5;
        var replayMenuItem = new cc.MenuItemImage(res.btnReplay_png, res.btnReplay_png, res.btnReplay_png,
            function () {
                // 直接重来
                Logic.dStartGame = true;
                cc.director.runScene(new GameMainScene());
                //SnakeHelper.gameMain.beganLayer.remove();
            }, this);
        replayMenuItem.setPosition(cc.p(187, 356));
        replayMenuItem.runAction(cc.fadeIn(fadeTime));
        this._replayMenuItem = replayMenuItem;

        // 视频复活
        var reviveMenuItem = new cc.MenuItemImage(res.btnFh_png, res.btnFh_png, res.btnFh_png, this.reviveGame, this);
        reviveMenuItem.setPosition(cc.p(454, 356));
        reviveMenuItem.runAction(cc.fadeIn(fadeTime));
        reviveMenuItem.setVisible(false);
        this._reviveMenuItem = reviveMenuItem;

        // 金币复活
        var reviveByCoinMenuItem = new cc.MenuItemImage(res.btnFhByCoin_png, res.btnFhByCoin_png, res.btnFhByCoin_png, function () {
            Logic.reviveGame();
        }, this);
        reviveByCoinMenuItem.setVisible(true);
        reviveByCoinMenuItem.setPosition(cc.p(454, 356));
        reviveByCoinMenuItem.runAction(cc.fadeIn(fadeTime));
        //this._reviveMenuItem = reviveMenuItem;

        //var isReady = wb.JADManager.isAdReady("qq_level_fail_mfzs");
        var isReady = false;
        var coin = 100;

        if (isReady) {
            reviveMenuItem.setVisible(true);
            reviveByCoinMenuItem.setVisible(false);
        } else if (coin < 10) {
            reviveByCoinMenuItem.setVisible(false);
            replayMenuItem.setPositionX(320);
        }


        var closeMenuItem = new cc.MenuItemImage(res.closeBtn_png, res.closeBtn_png, res.closeBtn_png,
            function () {
                Logic.dStartGame = false;
                cc.director.runScene(new GameMainScene());
            }, this);
        closeMenuItem.setPosition(cc.p(608, 1108));
        closeMenuItem.runAction(cc.fadeIn(fadeTime));
        // closeMenuItem.setScale(1.1);

        var mu = new cc.Menu(replayMenuItem, closeMenuItem, reviveMenuItem, reviveByCoinMenuItem);
        mu.setPosition(cc.p(0, 0));
        this.addChild(mu);

        this.scheduleOnce(this.showCircleLayer, 1.0);
        this.addTouchListener();

        SnakeHelper.gameOverLayer = this;
    },
    onEnter: function () {
        this._super();
        cc.log("GameOverLayer onEnter");
        Tool.hideBanner();
    },
    reviveGame: function () {
        cc.audioEngine.stopMusic();
    },
    showCircleLayer: function (dt) {
        var action = cc.spawn(cc.scaleTo(0.2, 0.0), cc.fadeTo(0.2, 0));
        this._scoreLayer.runAction(action);
        this.createCircleLayer();
    },
    createScoreLayer: function () {
        var scoreLayer = new cc.Layer();
        this.addChild(scoreLayer, 1);
        this._scoreLayer = scoreLayer;

        var fadeTime = 0.5;
        var crownSprite = new cc.Sprite(res.Crown_png);
        crownSprite.setPosition(cc.p(287, 666));
        scoreLayer.addChild(crownSprite);
        crownSprite.setOpacity(0);
        crownSprite.runAction(cc.fadeIn(fadeTime));

        var score = SnakeHelper.bkLayer.getCScore();
        var scoreLabel = new cc.LabelTTF("" + score, res.Hk7_font, 200);
        scoreLabel.setPosition(cc.p(320, 826));
        scoreLabel.setColor(cc.color(233, 96, 69));
        scoreLayer.addChild(scoreLabel);
        scoreLabel.setOpacity(0);
        scoreLabel.runAction(cc.fadeIn(fadeTime));

        var bestScore = Tool.getBestScore();
        var bestLabel = new cc.LabelTTF("" + bestScore, res.Hk7_font, 60);
        bestLabel.setAnchorPoint(cc.p(0, 0.5));
        bestLabel.setPosition(cc.p(320, 666));
        // bestLabel.setColor(cc.color(0, 0, 0));
        scoreLayer.addChild(bestLabel);
        bestLabel.setOpacity(0);
        bestLabel.runAction(cc.fadeIn(fadeTime));


    },
    addTouchListener: function () {
        cc.eventManager.addListener({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function () {
                return true;
            }
        }, this);
    },
    createCircleLayer: function () {
        var circleLayer = new cc.Layer();
        this.addChild(circleLayer, 1);
        this._circleLayer = circleLayer;

        var fadeTime = 0.5;
        var score = SnakeHelper.bkLayer.getCScore();
        var randScore = 999 + Tool.randN(1, 100);
        score = parseInt(score / randScore * 100);
        if (score <= 0) score = 1;
        var time = score / (200 / 10);

        var circlebg = new cc.Sprite(res.circle_png);
        circlebg.setColor(cc.color(0, 0, 0));
        circlebg.setPosition(cc.p(320, 766));
        circlebg.setOpacity(180);
        circleLayer.addChild(circlebg);
        this._circlebg = circlebg;

        var circle = new cc.Sprite(res.circle_png);
        circle.setColor(cc.color(233, 96, 69));
        var loading = new cc.ProgressTimer(circle);
        loading.type = cc.ProgressTimer.TYPE_RADIAL;
        loading.setPosition(cc.p(128.5, 128.5));
        var to = cc.progressFromTo(time, 0, score);
        loading.runAction(cc.sequence(to, cc.callFunc(function (tag) {
            this._circlebg.runAction(cc.scaleTo(0.2, 1));

        }, this)));
        circlebg.addChild(loading);

        //var scaleAction = cc.sequence(cc.scaleTo(0.1, 1.05), cc.scaleTo(0.1, 1.0));
        circlebg.runAction(cc.scaleTo(0.2, 1.2));
        this._loading = loading;

        var scoreLabel = new cc.LabelTTF("0%", res.Hk_font, 90);
        scoreLabel.setPosition(cc.p(320, 766));
        circleLayer.addChild(scoreLabel);
        scoreLabel.setOpacity(0);
        scoreLabel.runAction(cc.fadeIn(fadeTime));
        this._scoreLabel = scoreLabel;

        var infoLabel = new cc.LabelTTF("", res.Hk7_font, 36);
        infoLabel.setString("打败了全国0%的玩家");
        infoLabel.setPosition(cc.p(320, 500));
        circleLayer.addChild(infoLabel);
        this._infoLabel = infoLabel;

        var bestScoreLabel = new cc.LabelTTF("历史最佳: " + Tool.getBestScore(), res.Hk_font, 36);
        bestScoreLabel.setPosition(cc.p(320, 580));
        circleLayer.addChild(bestScoreLabel);
        bestScoreLabel.setOpacity(0);
        bestScoreLabel.runAction(cc.fadeIn(fadeTime));

        this.schedule(this.flushLabel, 0.02);
    },
    flushLabel: function () {
        var str = parseInt(this._loading.getPercentage()) + "%";
        this._scoreLabel.setString(str);

        this._infoLabel.setString("打败了全国" + str + "的玩家");
    }
})