/**
 * Created by Zack on 2017/10/13.
 */
var Goods = cc.Node.extend({
    _bindSprite: null,
    _bindSpriteD: null,
    _size: null,
    _goodsNum: 1,
    _rect: null,
    goodsType: null,
    _numLabel: null,
    isEnable: true,
    ctor: function () {
        this._super();

        // this._bindSpriteD = new cc.Sprite(res.BlockD_png);
        //  this._bindSpriteD = new cc.Sprite(BgSkinManger.getBlockDImagePath());
        //this._bindSpriteD.setPositionY(-Config.BLOCK_WH2 + 5);
        // this._bindSpriteD.setVisible(false);
        //  this.addChild(this._bindSpriteD, 1);

        //  this._bindSprite = new cc.Sprite(res.SnakeDot_png);
        this._bindSprite = new cc.Sprite(BgSkinManger.getBlockImagePath());
        this.addChild(this._bindSprite);

        var blockFontRes = BgSkinManger.getBlockFont();
        this._numLabel = new cc.LabelAtlas("1", blockFontRes.path, blockFontRes.w, blockFontRes.h, "0");
        this._numLabel.setAnchorPoint(cc.p(0.5, 0.5));
        this._numLabel.y = 20;
        this.addChild(this._numLabel, 1);

        this._size = cc.size(Config.SNAKE_RADIUS, Config.SNAKE_RADIUS);
        this._rect = cc.rect(0, 0, 0, 0);
        this.goodsType = ItemType.Dot;

    },
    initOriginP: function (j, i) {
        this.setPositionX(Config.BLOCK_WH2 + j * Config.BLOCK_WH);
        this.setPositionY(Config.BLOCK_WH2 + i * Config.BLOCK_WH);
    },
    getGoodsNum: function () {
        return this._goodsNum;
    },
    setGoodsNum: function (num) {
        if (num <= 0) {
            this.removeSelf();
            return;
        }
        this._goodsNum = num;
        this._numLabel.setString("" + num);
        this.setGoodsType(this.goodsType);
    },
    subGoodsNum: function (num) {
        this.setGoodsType(this.goodsType);
        this.setGoodsNum(this._goodsNum - num);
        SnakeHelper.flushCScoreLabel();

        SnakeHelper.bkLayer.showXssSpine(this);
    },
    getBBox: function () {
        var p = this.getBindSpriteP();
        this._rect.x = p.x - this._size.width / 2;
        this._rect.y = p.y - this._size.height / 2;
        return this._rect;
    },
    getBindSpriteP: function () {
        return this.convertToWorldSpace(this._bindSprite.getPosition());
    },
    check: function () {
        return SnakeHelper.snakeHead.check(this);
    },
    setGoodsType: function (goodsType) {

        this.isEnable = true;
        //this._bindSpriteD.setVisible(false);
        this.setVisible(true);
        this._numLabel.setVisible(true);
        this._bindSprite.setPosition(cc.p(0, 0));
        this._bindSprite.stopAllActions();
        this._bindSprite.setRotation(0);
        this._bindSprite.setScale(1);
        this.goodsType = goodsType;
        this._bindSprite.setColor(Config.WHITE_COLOR);

        this._numLabel.x = 0;
        this._numLabel.y = 10;
        this._numLabel.setScale(1);
        this._numLabel.setColor(Config.BLOCK_NUM_COLOR);

        //this._bindSpriteD.stopAllActions();
        //this._bindSpriteD.setRotation(0);
        //this._bindSpriteD.setScale(1);

        if (goodsType == ItemType.None) {
            this.setVisible(false);
        }
        else if (goodsType == ItemType.Dot) {
            var skinObj = Config.Skin[SnakeHelper.skinIndex];

            this._bindSprite.setTexture(skinObj.bodyPng);
            this._bindSprite.setColor(skinObj.bodyColor2);

            if (skinObj.isSpecial) {
                var randN = Tool.randN(0, skinObj.specialColor.length - 1);
                this._bindSprite.setColor(skinObj.specialColor[randN]);
            }

            this._numLabel.setPosition(cc.p(0, 45));
            this._numLabel.setScale(0.6);
            //this._numLabel.setColor(BgSkinManger.getDotColor());

            if (BgSkinManger.isDarkStyle()) {
                this._numLabel.setColor(Config.WHITE_COLOR);
            }
            else {
                this._numLabel.setColor(Config.BK_COLOR);
            }


            GuideManger.pushGuide("guid_dot", SnakeHelper.bkLayer, 5, 1, ItemType.Dot);
        }
        else if (goodsType == ItemType.Block) {

            //this._bindSpriteD.setVisible(false);
            // this._bindSpriteD.setTexture(BgSkinManger.getBlockDImagePath());

            // this._bindSprite.setTexture(BgSkinManger.getBlockImagePath());
            // var index = Tool.getBlockColorIndex(this._goodsNum);
            var index = parseInt(this._goodsNum / 15) + 1;
            if (index > 4) index = 4;
            // cc.log("index " + index);
            this._bindSprite.setTexture("res/scene/block/" + index + ".png");

            //if (BgSkinManger.isFrameColorChange()) {
            //    this._bindSpriteD.setColor(BgSkinManger.getBlockColor(index));
            //} else {
            //    this._bindSprite.setColor(BgSkinManger.getBlockColor(index));
            //}
            //this._numLabel.setPosition(cc.p(0, 0));
            //this._numLabel.setColor(BgSkinManger.getBlockFontColor());

            GuideManger.pushGuide("guid_block", SnakeHelper.bkLayer, 5, 1, ItemType.Block);
        }
        else if (goodsType == ItemType.Line) {
            this._bindSprite.setTexture(BgSkinManger.getLineImage());
            // this._bindSprite.setColor(BgSkinManger.getLineColor());
            this._bindSprite.setPosition(cc.p(-(Config.BLOCK_WH2 - Config.LINE_W2), 0));
            this._numLabel.setVisible(false);
        }
        else if (goodsType == ItemType.Shield) {
            this._bindSprite.setTexture(BgSkinManger.getShieldImagePath());
            this._bindSprite.setColor(Config.WHITE_COLOR);
            this._numLabel.setVisible(false);

            GuideManger.pushGuide("guid_shield", SnakeHelper.bkLayer, 5, 1, ItemType.Shield);
        }
        else if (goodsType == ItemType.Frozen) {
            this._bindSprite.setTexture(BgSkinManger.getFrozenImagePath());
            this._bindSprite.setColor(Config.WHITE_COLOR);
            this._numLabel.setVisible(false);

            GuideManger.pushGuide("guid_frozen", SnakeHelper.bkLayer, 5, 1, ItemType.Frozen);
        }
        else if (goodsType == ItemType.Coin) {
            this._bindSprite.setTexture(BgSkinManger.getCoinImagePath());
            // this._bindSprite.setColor(Config.WHITE_COLOR);
            this._numLabel.setVisible(false);

            // if (BgSkinManger.isNormal()) {
            this._bindSprite.runAction(cc.rotateBy(0.1, 15).repeatForever());
            // this._bindSprite.setColor(cc.color(255, 252, 31));
            //  }

        }
        else if (goodsType == ItemType.Hole) {
            this._bindSprite.setTexture(BgSkinManger.getHoleImage());
            this._numLabel.setVisible(false);
            // this._bindSprite.setColor(Config.WHITE_COLOR);
            this._bindSprite.runAction(cc.rotateBy(0.1, 15).repeatForever());

            GuideManger.pushGuide("guid_hole", SnakeHelper.bkLayer, 5, 1, ItemType.Hole);
        }
        else if (goodsType == ItemType.HoleExit) {
            this._bindSprite.setTexture(BgSkinManger.getHoleImage());
            this._numLabel.setVisible(false);
            //   this._bindSprite.setColor(Config.WHITE_COLOR);
            this.isEnable = false;
            this._bindSprite.runAction(cc.rotateBy(0.1, 15).repeatForever());
        }
        else if (goodsType == ItemType.Box) {
            this._bindSprite.setTexture(BgSkinManger.getBoxImage());
            this._numLabel.setVisible(false);
            this._bindSprite.setColor(Config.WHITE_COLOR);
            this._bindSprite.setScale(1.5);
            //  this._bindSpriteD.setColor(Config.WHITE_COLOR);

            //this._bindSpriteD.setVisible(true);
            //this._bindSpriteD.setTexture(res.boxLight_png);
            //this._bindSpriteD.setScale(0.4);
            //this._bindSpriteD.runAction(cc.rotateBy(0.1, 5).repeatForever());
        }

        this._size = this._bindSprite.getContentSize();
        if (goodsType == ItemType.Hole) {
            this._size = cc.size(Config.HoleSize.width, Config.HoleSize.height);
        }
        this._rect.width = this._size.width;
        this._rect.height = this._size.height;
        // 冰冻
        if (SnakeHelper.bkLayer.isFrozen && goodsType == ItemType.Block) {
            this.setSpecialType(SpecialType.Ice);
        }

    },
    removeSelf: function () {
        this.setVisible(false);
        SnakeHelper.reSetGoodRuning(true);
        //Tool.blockExplosion(this.getBindSpriteP(), SnakeHelper.bkLayer);

        if (this.goodsType == ItemType.Block) {
            //SnakeHelper.bkLayer.showSsSpine(this, function () {
            //}.bind(this));

            SnakeHelper.bkLayer.showSsSpine(this);
        }
    },
    setSpecialType: function (type) {

        if (type == SpecialType.None && this.isVisible()) {
            this.setGoodsType(this.goodsType);
            return;
        }
        if (type == SpecialType.Ice && this.goodsType == ItemType.Block) {

            //if (BgSkinManger.isNormal()) {
            //    // this._bindSpriteD.setVisible(false);
            //    var index = Tool.getBlockColorIndex(this._goodsNum);
            //    this._bindSprite.setTexture(res.block_special_png);
            //    this._bindSprite.setColor(BgSkinManger.getBlockColor(index));
            //} else {
            //
            //    //  if (BgSkinManger.isFrameColorChange()) this._bindSpriteD.setVisible(false);
            //    this._bindSprite.setColor(BgSkinManger.getIceColor());
            //    this._numLabel.setColor(Config.WHITE_COLOR);
            //}

            this._bindSprite.setTexture(res.block_special_png);
            this._numLabel.setColor(Config.BLOCK_ICE_COLOR);

        }
    }
});

var GoodsManger = {
    _goods: [],
    _index: 0,
    init: function () {
        this._goods = [];

        var row = Config.MAP_H * 2;
        var line = Config.MAP_W;

        for (var i = 0; i < row; i++) {
            for (var j = 0; j < line; j++) {
                var good = new Goods();
                good.retain();
                this._goods.push(good);
            }
        }
    },
    createGoods: function () {
        var good = this._goods[this._index++];
        return good;
    },
    reSet: function () {
        this._index = 0;
        for (var i = 0; i < this._goods.length; i++) {
            this._goods[i].removeFromParent();
        }
    }
};
