/**
 * Created by 13075 on 2017/11/13.
 */
var GroupLayer = wb.BaseLayer.extend({
    ctor: function (shareTickets) {
        this._super(res.groupScene_json);
        this.shareTickets = shareTickets;
        this.initData();
        this.initUI();
    },
    initData: function () {

        this.addKeyBoard();
        this.setKeyBoardFunc(function () {
            this.closeLayer();
        }.bind(this));
        this.popUI("uiPanel", 0);

        this.schedule(this.flushFriendRnak, 0.6);
    },
    onEnter: function () {
        this._super();
        this.scheduleOnce(this.initFr,1);
        Tool.showBanner(Config.bannerId2);
    },
    onExit: function () {
        this._super();
        Tool.hideBanner();
    },
    initUI: function () {

        wb.FW(this.rootNode, "closeBtn", function () {
            this.closeLayer();
            wb.EventManager.dispatchCustomEvent("rankLayerClose", {});
        }.bind(this));

        wb.FW(this.rootNode, "syyPanel", function () {
            wb.wx.postMessage({
                funcName: "prePanel"
            });
        }.bind(this));

        wb.FW(this.rootNode, "xyyPanel", function () {
            wb.wx.postMessage({
                funcName: "nextPanel"
            });
        }.bind(this));

        this.itemPanel = wb.FW(this.rootNode, "itemPanel");
        this.itemPanel1 = wb.FW(this.rootNode, "itemPanel1");
        this.dy = this.itemPanel.y - this.itemPanel1.y;
        this.itemPanel.setVisible(false);
        this.itemPanel1.setVisible(false);

        this.qgPanel = wb.FW(this.rootNode, "qgPanel");
        this.hyPanel = wb.FW(this.rootNode, "hyPanel");
        this.hyPanel.setVisible(true);
        this.qgPanel.setVisible(false);
    },
    initFr: function () {

        var wxPanelSize = this.hyPanel.getContentSize();
        var hgImage = wb.FW(this.itemPanel, "hgImage");
        var rankText = wb.FW(this.itemPanel, "rankText");
        var nameText = wb.FW(this.itemPanel, "nameText");
        var scoreText = wb.FW(this.itemPanel, "scoreText");
        var headPanel = wb.FW(this.itemPanel, "headPanel");

        var hgImageP = this.hyPanel.convertToNodeSpace(wb.convertToWP(hgImage));
        var rankTextP = this.hyPanel.convertToNodeSpace(wb.convertToWP(rankText));
        var nameTextP = this.hyPanel.convertToNodeSpace(wb.convertToWP(nameText));
        var scoreTextP = this.hyPanel.convertToNodeSpace(wb.convertToWP(scoreText));
        var headPanelP = this.hyPanel.convertToNodeSpace(wb.convertToWP(headPanel));

        var data = {
            shareTickets: this.shareTickets,
            funcName: "gameGroupRank",
            hgDh: this.dy,
            caSize: {w: wxPanelSize.width, h: wxPanelSize.height},
            hg1ImageP: cc.p(hgImageP.x, wxPanelSize.height - hgImageP.y),
            txPanelP: cc.p(headPanelP.x, wxPanelSize.height - headPanelP.y),
            nameTextP: cc.p(nameTextP.x, wxPanelSize.height - nameTextP.y),
            scoreTextP: cc.p(scoreTextP.x, wxPanelSize.height - scoreTextP.y)
        };
        this.initFriendRank(data);
    },
    rankSp: null,
    initFriendRank: function (data) {

        var canvas = wb.wx.getOpenDataCanvas();
        if (!canvas) return;

        if (rankSp) rankSp.removeFromParent();

        canvas.width = 640;
        canvas.height = 1136;
        wb.wx.postMessage(data);
        var rankSp = new cc.Sprite();
        rankSp.setContentSize(cc.size(data.caSize.w, data.caSize.h));
        rankSp.setAnchorPoint(cc.p(0, 1));
        rankSp.setPositionY(data.caSize.h);
        this.rankSp = rankSp;
        this.hyPanel.addChild(rankSp);

    },
    flushFriendRnak: function () {
        if (!this.rankSp || !this.rankSp.isVisible()) return;

        var texture = new cc.Texture2D();
        texture.initWithElement(wb.wx.getOpenDataCanvas());
        texture.handleLoadedTexture();
        this.rankSp.setTexture(texture);
    }
});