/**
 * Created by 13075 on 2017/11/13.
 */
var GuideLayer = wb.BaseLayer.extend({
    ctor: function (parent, index) {
        this._super(res.guideLayer_json);
        Logic.guideLayer = this;
        this.initData();
        this.initUI();

        var n = index;
        if (!n) n = 0;
        parent.addChild(this, n);
        // cc.log("parent.y " + parent.y);
        // this.y = parent.y
    },
    onExit: function () {
        this._super();
        SceneManger.resumeGame();
    },
    initData: function () {

    },
    initUI: function (str) {
        this.uiPanel = wb.FW(this.rootNode, "uiPanel", function () {
            cc.log("uiPanel");
            this.hide();
            SnakeHelper.bkLayer.isGaming = true;
        }.bind(this));

        this.tipText = wb.FW(this.rootNode, "tipText");
        this.jtPanel = wb.FW(this.rootNode, "jtPanel");
    },
    show: function (str, time) {
        this.unscheduleAllCallbacks();
        this.showStr = str;
        if (time && time > 0) {
            this.scheduleOnce(this.callFunc, time, "callFunc");
        } else {
            this.callFunc();
        }
    },
    callFunc: function () {
        this.setVisible(true);
        SceneManger.pauseGame();
        this.tipText.setContentSize(cc.size(500, 400));
        if (this.showStr) this.tipText.setString(this.showStr);

        this.uiPanel.setOpacity(0);
        this.uiPanel.runAction(cc.fadeIn(0.5));
    },
    hide: function () {
        this.setVisible(false);
        //this.closeLayer();
        // this.scheduleOnce(function () {
        GuideManger.isGuide = false;
        this.closeLayer();
        GuideManger.completeGuide();
        GuideManger.nextGuide();
        //   }.bind(this), 0, "nextGuide");

    },
    setGoodsItem: function (type) {
        if (!type) return;

        var good = new Goods();
        good.setGoodsType(type);
        good.setGoodsNum(2);
        good.setPosition(this.jtPanel.getPosition());
        good._numLabel.setColor(Config.BLOCK_NUM_COLOR);
        this.addChild(good, 10);

        this.jtPanel.setVisible(false);
    }
});

var GuideManger = {
    isGuide: false,
    cGuideType: null, // 当前类型
    guideType: {
        guid_control: 0,   // 操作引导
        guid_info: 0,      // 操作引导
        guid_block: 0,     // 方块说明
        guid_shield: 0,     // 护盾
        guid_frozen: 0,      // 雪花
        guid_hole: 0,         // 虫洞
        guid_dot: 0         // 食物
    },  // 引导类型
    guideStr: {
        guid_control: "左右滑动来操控球球",
        guid_info: "避开数字大的块儿，选择数字小的方块吃掉~",
        guid_block: "在撞到块儿后，球球的长度会相应减少，并获得相应分数",
        guid_shield: "护盾能够帮助球球抵挡一次方块碰撞",
        guid_frozen: "雪花能够减慢球球的移动速度",
        guid_hole: "虫洞能够让球球穿越到洞口另一端",
        guid_dot: "吃食物可以增加蛇身的长度",
    },
    guideList: [],
    guideDjNum: {        // 道具引导出随分数出现  冰冻，虫洞，盾
        guid_control: 0,   // 操作引导
        guid_info: 0,      // 操作引导
        guid_block: 0,     // 方块说明
        guid_shield: 15,     // 护盾
        guid_frozen: 5,      // 雪花
        guid_hole: 10,         // 虫洞
        guid_dot: 0         // 食物
    },
    init: function () {
        this.flushGuide();
    },
    flushGuide: function () {
        for (var item in this.guideType) {
            cc.log(item);
            this.guideType[item] = wb.getItem(item, 0);
            if (this.guideType[item] == 1) this.guideDjNum[item] = 0;
        }
    },
    pushGuide: function (type, parent, index, time, goodsType) {
        if (this.guideType[type] == 1) return;

        var obj = {
            type: type,
            parent: parent,
            index: index,
            time: time,
            goodsType: goodsType
        };
        this.guideList.unshift(obj);
        this.guideType[type + ""] = 1;
        if (!this.isGuide) this.nextGuide();
    },
    nextGuide: function () {
        if (this.guideList.length <= 0) return;
        var item = this.guideList.pop();
        this.showGuide(item.type, item.parent, item.index, item.time, item.goodsType);
    },
    showGuide: function (type, parent, index, time, goodsType) {
        // if (this.guideType[type] == 1 || this.isGuide) return;  // 已引导过
        this.isGuide = true;

        var guideLayer = new GuideLayer(parent, index);
        guideLayer.setVisible(false);
        guideLayer.show(this.guideStr[type], time);
        guideLayer.setGoodsItem(goodsType);
        this.cGuideType = type;
    },
    completeGuide: function () {
        if (!this.cGuideType) return;
        wb.setItem(this.cGuideType, 1);
    }
};