/**
 * Created by Zack on 2017/10/12.
 */

var Logic = {
    isFirstRowLine: true, // 第一次的第一行
    cGPercent: 80, // 生成物品的概率 max 100
    goodsPeType: [ItemType.Dot, ItemType.Block, ItemType.Line, ItemType.Shield, ItemType.Frozen],
    goodsPeNum: [21, 30, 40, 2, 4],
    goodsPeNumSum: 0,
    dStartGame: false,  // 直接开始游戏
    goodsTypeMap1: null,
    goodsTypeMap2: null,
    coinScore: 0,       // 到达分数后，获取金币模式
    isCoinType: false, // 复活后金币模式
    isHole: false,
    holeExitIndex: 0,  // 虫洞出口下标
    reviveNum: 0,      // 复活的次数

    score: 0,
    isFirstBeganGame: true, // 记录第一次开始游戏

    rowItemNum: [],
    init: function () {
        Config.SNAKE_SPEED = Config.NORMAL_SPEED;
        Config.FROZEN_SPEED = Config.SNAKE_SPEED - 2;
        // Config.FROZEN_SPEED =  1;
        Config.GETSTART_SPEED = Config.SNAKE_SPEED + 4;
        Config.DGETCoinScore = 60;
        // Config.DGETCoinScore = 10;
        this.coinScore = 0;
        this.cGPercent = 80;
        this.isFirstRowLine = true;
        this.isHole = false;
        this.isCoinType = false;
        this.goodsTypeMap1 = [];
        this.reviveNum = 0;
        this.score = 0;
        for (var i = 0; i < Config.MAP_H; i++) {
            this.goodsTypeMap1.push([]);
        }

        this.goodsTypeMap2 = [];
        for (var i = 0; i < Config.MAP_H; i++) {
            this.goodsTypeMap2.push([]);
        }

        this.goodsPeNumSum = 0;
        for (var i = 0; i < this.goodsPeNum.length; i++) {
            this.goodsPeNumSum = this.goodsPeNumSum + this.goodsPeNum[i];
        }

        // 100 分时出一次宝箱
        // this.isBoxOnly = false;
        this.boxTargetNum = 100; // 得到宝箱的目标分

        GoodsManger.reSet();
        SnakePool.reSet();
        SnakeLevelManger.init();
    },
    getGoodsMapByIndex: function (layerIndex) {
        var goodsTypeMap = this.goodsTypeMap1;
        if (layerIndex == 2) goodsTypeMap = this.goodsTypeMap2;
        return goodsTypeMap;
    },
    // 随着分数改变概率
    changeGPer: function () {
        if (this.cGPercent < 10) return;
        this.cGPercent = this.cGPercent - 0.2;
        // this.cGPercent = this.cGPercent - 0.5;
        // cc.log("cGPercent " + this.cGPercent);
    },
    GoodsItem: function (type, num) {
        return {goodsType: type, goodsNum: num};
    },
    getPercentNum: function (num, percentMin, percentMax) {
        var n = Tool.randN(0, num);
        if (n >= percentMin && n <= percentMax) return true;
        return false;
    },
    createGoods: function () {
        for (var i = 0; i < Config.MAP_H - 1; i++) {
            this.createRowItemType(i);
        }
    },
    createGoodsByRow: function (row, layerIndex) {
        this.createRowItemType(row, layerIndex);
    },
    createLastRowItemType: function (layerIndex) {
        var goodsType = ItemType.Block;
        // var goodsType = ItemType.None;

        if (SnakeHelper.bkLayer.isGetCoin) goodsType = ItemType.Coin;
        // 计算范围值
        if (!this.isFirstRowLine) {
            // 创建范围随机数
            var snakeLength = SnakeHelper.snakeHead.snakeLength;

            var blNum = SnakeLevelManger.getBlockNum();
            if (snakeLength < blNum[0].blockMin) snakeLength = blNum[0].blockMin;
            this.rowItemNum[0] = Tool.randN(blNum[0].blockMin, snakeLength);
            this.rowItemNum[1] = Tool.randN(blNum[1].blockMin, blNum[1].blockMax);
            this.rowItemNum[2] = Tool.randN(blNum[2].blockMin, blNum[2].blockMax);
            this.rowItemNum[3] = Tool.randN(blNum[3].blockMin, blNum[3].blockMax);
            this.rowItemNum[4] = Tool.randN(blNum[4].blockMin, blNum[4].blockMax);
            this.rowItemNum[5] = Tool.randN(blNum[5].blockMin, blNum[5].blockMax);

            // var rowItemNum = [rand1, rand2, rand3, rand4, rand5];
            // 打乱顺序
            this.rowItemNum.sort(function (a, b) {
                return 0.5 - Math.random();
            });
            for (var i = 0; i < this.rowItemNum.length; i++) {
                this.pushToGoodsMap(Config.MAP_H - 1, i, goodsType, this.rowItemNum[i], layerIndex);
            }
        } else {
            // 第一次的直线行
            for (var i = 0; i < Config.MAP_W; i++) {
                this.pushToGoodsMap(Config.MAP_H - 1, i, goodsType, Tool.randN(1, 2), layerIndex);
            }
            this.isFirstRowLine = false;
        }
    },
    createRowItemType: function (row, layerIndex) {
        for (var i = 0; i < Config.MAP_W; i++) {
            var type = this.createItemType(row, i, layerIndex);
            var num = this.createLabelNumByType();
            this.pushToGoodsMap(row, i, type, num, layerIndex);
        }
    },
    pushToGoodsMap: function (i, j, type, num, layerIndex) {
        //cc.log("i " + i + " j " + j);
        var goodsTypeMap = this.goodsTypeMap1;
        if (layerIndex == 2) goodsTypeMap = this.goodsTypeMap2;

        if (goodsTypeMap[i][j]) {
            goodsTypeMap[i][j].goodsType = type;
            goodsTypeMap[i][j].goodsNum = num;
        } else {
            goodsTypeMap[i][j] = this.GoodsItem(type, num);
        }
    },
    getGoodsByPercent: function () {

        var goodsPe = this.goodsPeNum;
        var randN = Tool.randN(0, this.goodsPeNumSum);
        var sum = 0;
        for (var i = 0; i < goodsPe.length; i++) {
            if (randN <= sum + goodsPe[i]) {
                return this.goodsPeType[i];
            }
            sum = sum + goodsPe[i];
        }
        return ItemType.None;
    },
    createLabelNumByType: function (type) {
        var maxN = 5;
        if (ItemType.Block == type) maxN = Config.BLOCK_MAXNUM;
        return Tool.randN(1, maxN);
    },
    createItemType: function (row, i, layerIndex) {

        // return ItemType.Box;
        //var type = this.isCreateHole(row, i, layerIndex);
        //if (type)  return type;
        //return ItemType.None;

        // 洞
        if (!SnakeHelper.bkLayer.isGetCoin || this.isHole) {
            // if (!this.isBoxOnly && Logic.score > 100) {
            //     this.isBoxOnly = true;
            //     return ItemType.Box;
            // }

            var type = this.isCreateHole(row, i, layerIndex);
            if (type) {
                if (Logic.score < 20) return ItemType.None;
                return type;
            }
        }
        if (!SnakeHelper.bkLayer.isGetCoin) {
            if (GuideManger.guideDjNum.guid_frozen > 0 && GuideManger.guideDjNum.guid_frozen <= this.score) {
                GuideManger.guideDjNum.guid_frozen = 0;
                return ItemType.Frozen;
            }
            //if(GuideManger.guideDjNum.guid_hole >0 && GuideManger.guideDjNum.guid_frozen<= this.score) return ItemType.Hole;
            if (GuideManger.guideDjNum.guid_shield > 0 && GuideManger.guideDjNum.guid_shield <= this.score) {
                GuideManger.guideDjNum.guid_shield = 0;
                return ItemType.Shield;
            }
        }

        //return ItemType.None;
        var isRoad = this.getPercentNum(100, 0, this.cGPercent);
        // 可通过路径
        if (isRoad) return ItemType.None;

        if (!Config.isAllUnLock && !SnakeHelper.bkLayer.isGetCoin && this.score >= this.boxTargetNum) {
            this.boxTargetNum = this.boxTargetNum * 3;
            return ItemType.Box;
        }

        var type = this.getGoodsByPercent();

        // 方块不能挨着一条直线方块
        if ((row == 0 || row == 7) && ItemType.Block == type) return ItemType.None;
        // 得金币
        if (SnakeHelper.bkLayer.isGetCoin) {
            if (type == ItemType.Line) return type;
            return ItemType.Coin;
        } else {
            if (SnakeHelper.snakeHead.snakeLength > 50 && type == ItemType.Shield) {
                return ItemType.None;
            }
        }

        return type;
    },
    isCreateHole: function (row, column, layerIndex) {
        // 洞
        if (row == 7 && !this.isHole) {

            var flag = false;
            if (GuideManger.guideDjNum.guid_hole > 0 && GuideManger.guideDjNum.guid_hole <= this.score) {
                GuideManger.guideDjNum.guid_hole = 0;
                flag = true;
            }

            var randN = Tool.randN(0, 100);
            if (randN < 5 || flag) {  // %6 的概率
                this.isHole = true;
                this.holeExitIndex = Tool.randN(0, Config.MAP_W - 1);
                SnakeHelper.bkLayer.holeExitGoods = null;
                return ItemType.Hole;
            }
        }
        if (row == 0 && this.isHole && column == this.holeExitIndex) {
            this.isHole = false;
            return ItemType.HoleExit;
        }
        return null;
    },
    checkGetCoinMode: function () {
        // 触发得金币模式
        var bkLayer = SnakeHelper.bkLayer;
        if (!bkLayer.isGetCoin && Logic.coinScore >= Config.DGETCoinScore || this.isCoinType) {
            this.isCoinType = false;

            bkLayer.isGetCoin = true;
            bkLayer.isFrozen = false;
            Logic.coinScore = 0;
            Config.SNAKE_SPEED = Config.GETSTART_SPEED;
            bkLayer.setTimeN(8);
            if (bkLayer._windLayer) bkLayer._windLayer.removeFromParent();
            var windLayer = new WindLayer();
            bkLayer.addChild(windLayer, 0);
            bkLayer._windLayer = windLayer;
            bkLayer.showToast(SpecialType.CoinTip);
            Config.DGETCoinScore = Config.DGETCoinScore * 4;
        }
    },
    addSnakeSpeed: function (score) {
        //Config.SNAKE_SPEED = parseInt(Config.NORMAL_SPEED + score / 100);
        //Config.FROZEN_SPEED = Config.SNAKE_SPEED - 1;
        //Config.GETSTART_SPEED = Config.SNAKE_SPEED + 4;
        ////cc.log("Config.SNAKE_SPEED " + Config.SNAKE_SPEED);
        ////Config.SNAKE_SPEED = Config.SNAKE_SPEED + 0.01;
    },
    reviveGame: function () {

        SnakeHelper.bkLayer.isGaming = true;
        SnakeHelper.addSnakeNodeByNum(14);
        if (SnakeHelper.gameOverLayer) SnakeHelper.gameOverLayer.removeFromParent();

        var shield = SnakeHelper.snakeHead.getChildByName("shield");
        if (shield) shield.removeFromParent();
        var shield = new cc.Sprite(res.Shield_png);
        SnakeHelper.snakeHead.addChild(shield, 1, "shield");
        SnakeHelper.snakeHead.haveShield = true;

        SceneManger.showDjsLayer();
    },
    getSectionNum: function (num) {
        for (var i = 0; i < Config.consumeNumScetion.length; i++) {
            if (num < Config.consumeNumScetion[i]) {
                return Config.consumeNum[i];
            }
        }
    }
};


