/**
 * Created by zack on 2018/7/13.
 */
var LotteryLayer = wb.BaseLayer.extend({
    dotList: [],

    lightCT: 0.5, // 灯转换的时间
    lightN: 0, // 累加时间

    ctor: function () {
        this._super(res.lotteryScene_json);
        this.initData();
        this.initUI();

        this.scheduleUpdate();
    },
    onEnter: function () {
        this._super();
        wb.EventManager.dispatchCustomEvent("userBtnState", "hide");
        if (Tool.ticketNum > 0 && Tool.lotteryPlShowNum < Config.lotteryPlNum) {
            var plaque = wb.createPushPlaqueWs(null, null, true);
            if (plaque) {
                this.addChild(plaque, 100);
                Tool.flushLotteryPlShowNum(1);
            }
        }

    },
    onExit: function () {
        this._super();
        wb.EventManager.dispatchCustomEvent("userBtnState", "show");
    },
    initData: function () {
        this.dotList = [];
        this.lightCT = 0.5;
        this.lightN = 0;

        this.sumPe = 0;
        for (var i = 0; i < Config.cjData.length; i++) {
            this.sumPe = this.sumPe + Config.cjData[i].pe;
        }
    },
    flushData: function () {
        this.peIndex = 2;
        var randN = wb.randNum(0, this.sumPe);
        var sum = 0;
        for (var i = 0; i < Config.cjData.length; i++) {
            if (randN <= sum + Config.cjData[i].pe) {
                this.peIndex = i;
                break;
            }
            sum = sum + Config.cjData[i].pe;
        }

        // this.peIndex = 0;
        cc.log("this.peIndex " + this.peIndex);
        cc.log("randN " + randN);
        var zpImageR = wb.angleNormal(this.zpImage.getRotation());
        this.rotateAngle = 360 * 10 + (360 - this.peIndex * 36) - zpImageR;
    },
    update: function (dt) {
        this.lightN = this.lightN + dt;
        if (this.lightN >= this.lightCT) {
            this.lightN = 0;
            this.flushLight();
        }
    },
    flushLight: function () {
        for (var i = 0; i < 16; i++) {
            var item = this.dotList[i];
            if (item.isShaung) {
                item.setVisible(true);
            } else {
                item.setVisible(false);
            }
            item.isShaung = !item.isShaung;
        }
    },
    flushStartImage: function () {
        // 有抽奖券
        if (Tool.ticketNum > 0) {
            this.startImage.loadTexture("res/lotteryNew/mscj_01.png");
        } else {
            if (!Config.isAllUnLock) {
                this.startImage.loadTexture("res/lotteryNew/mscj_02.png");
            } else {
                this.startImage.loadTexture("res/lotteryNew/mscj_01.png");
            }
        }

    },
    initUI: function () {
        this.popUI("uiPanel", 0.1);

        // var cjText = wb.FW(this.rootNode, "cjText");
        // cjText.setString(Tool.ticketNum);

        var zpImage = wb.FW(this.rootNode, "zpImage");
        this.zpImage = zpImage;

        this.closeBtn = wb.FW(this.rootNode, "closeBtn", function () {
            cc.log("closeBtn");
            wb.wxHelper.tj("button", "GuanBi", "ZhuanPan");
            this.closeLayer();
        }.bind(this));

        this.startImage = wb.FW(this.rootNode, "startImage", function () {
            cc.log("startImage");
            wb.wxHelper.tj("button", "ChouJiang", "ZhuanPan");
            wb.DataTJManager.event2("video_DaoJuMoShi_ZhuanPan","video_DaoJuMoShi_ZhuanPan");

            if (Tool.ticketNum > 0) {
                Tool.flushTicket(-1);
                this.zpRotated();
                this.flushCjBtn(false);
            } else {
                if (Config.isAllUnLock) {
                    SceneManger.showTip("抽奖券不足~");
                } else {

                    if(!wb.ADManager.isAdReady("rotary_mfzs")){
                        SceneManger.showTip("视频未准备好~");
                        return;
                    }

                    this.flushCjBtn(false);
                    this.startImage.setTouchEnabled(false);
                    wb.ADManager.openAdC("rotary_mfzs", function (a, result) {
                        this.startImage.setTouchEnabled(true);

                        if (result == 0) {
                            this.zpRotated();
                        } else {
                            SceneManger.showTip("视频未播放完~");
                        }
                    }.bind(this));
                }
            }
        }.bind(this));


        var lightdotPanel = wb.FW(this.rootNode, "lightdotPanel");
        for (var i = 1; i <= 16; i++) {
            var dot = wb.FW(lightdotPanel, "dot" + i);
            if (i % 2 == 0) dot.isShaung = true;
            else dot.isShaung = false;
            this.dotList.push(dot);
        }

        this.zpImage = wb.FW(this.rootNode, "zpImage");
        var zpImageSize = this.zpImage.getContentSize();

        // 初始化物品
        var goodsPanel = wb.FW(this.rootNode, "goodsPanel");
        var goods = wb.FW(goodsPanel, "goods");

        var dAngle = 360 / 10;
        for (var i = 0; i < 10; i++) {
            var item = goods.clone();
            var data = Config.cjData[i];

            var numLabel = wb.FW(item, "numLabel");
            var yjImage = wb.FW(item, "yjImage");
            var goodsImage = wb.FW(item, "goodsImage");
            goodsImage.ignoreContentAdaptWithSize(true);
            numLabel.setString(":" + data.num);

            yjImage.setVisible(false);
            // 钻石
            if (data.type == -1) {
                goodsImage.loadTexture(data.goodsImage);
            } else if (data.type == -2) {
                goodsImage.loadTexture(data.goodsImage);
            } else {
                // 皮肤
                yjImage.setVisible(true);
                var snakeHead = new SnakeSimple(data.type);
                goodsImage.setVisible(false);
                numLabel.setVisible(false);
                snakeHead.setPosition(goodsImage.getPosition());
                snakeHead.setScale(0.7);
                item.addChild(snakeHead);
            }

            item.setRotation(i * dAngle);
            item.setPosition(cc.p(zpImageSize.width / 2, zpImageSize.height / 2));
            this.zpImage.addChild(item)
        }
        goods.setVisible(false);

        this.flushStartImage();
        this.flushLight();
    },
    zpRotated: function () {
        this.lightCT = 0.2;
        this.flushData();
        this.flushCjBtn(false);
        this.zpImage.runAction(cc.sequence(cc.rotateBy(4, this.rotateAngle).easing(cc.easeSineInOut()),
            cc.callFunc(function () {
                this.rewarad();
            }.bind(this))
        ));
    },
    flushCjNum: function () {
        this.cjDotText.setString(Tool.ticketNum);
        this.videoDotText.setString(Tool.cjVideoNum);
    },
    flushCjBtn: function (flag) {
        this.startImage.setTouchEnabled(flag);
    },
    closeRewarad: function () {
        var shadePanel2 = wb.FW(this.rootNode, "shadePanel2");
        shadePanel2.setTouchEnabled(false);
        shadePanel2.setVisible(false);

        var rewardPanel = wb.FW(this.rootNode, "rewardPanel");
        rewardPanel.setVisible(false);
    },
    rewarad: function () {
        cc.log("rewarad");
        this.lightCT = 0.5;
        this.flushStartImage();
        SceneManger.showRewardLayer(this.peIndex, function () {
            this.flushCjBtn(true);
        }.bind(this));
    }
});