/**
 * Created by 13075 on 2017/11/13.
 */
var RankLayer = wb.BaseLayer.extend({
    rankData: null,
    qgPageIndex: 0,
    rankItemList: [],
    ishyRank: true,
    ctor: function () {
        this._super(res.rankScene_json);
        this.initData();
        this.initUI();
        this.initRankData();

    },
    onEnter: function () {
        this._super();
        Tool.showBanner();
        this.qgPanel.setVisible(false);
        this.scheduleOnce(function () {
            this.switchRank(false);
        }.bind(this), 0.1);
        wb.EventManager.dispatchCustomEvent("userBtnState", "hide");

        this.showBottomBtn();
    },
    onExit: function () {
        this._super();
        wb.EventManager.dispatchCustomEvent("rankLayerClose", {});
        Tool.showBanner();
        wb.EventManager.dispatchCustomEvent("userBtnState", "show");
    },
    initRankData: function () {
        var rankRemberData = wb.wxHelper["https://api.vzhifu.net/superm/top"];
        if (rankRemberData) {
            this.httpFunc(rankRemberData);
        }

        wb.EventManager.addCustomEventListener(wb.HTTPRE, function (event) {
            var data = event.getUserData();
            this.httpFunc(data);
        }.bind(this), this);

        this.sendHttpRequest();
        this.schedule(this.flushFriendRnak, 1);
    },
    initData: function () {
        this.rankItemList = [];
        this.qgPageIndex = 0;
        this.rankData = null;

        this.popUI("uiPanel", 0);
    },
    sendHttpRequest: function () {
        var data = {
            top_num: "50",
            user_id: Tool.userId,
            project_id: Config.PRJID
        };
        wb.wxHelper.httpRequest("https://api.vzhifu.net/superm/top", data);
    },
    httpFunc: function (responseText) {
        var reData = wb.parse(responseText);
        this.rankData = reData.top_list;
        cc.log("this.rankData.length : " + this.rankData.length);

        // var tets = [];
        // for (var i = 0; i < 20; i++) {
        //     var item = {
        //         "user_score": 4,
        //         "user_name": "test",
        //         "user_icon": "http://www.vigame.cn/img/sina.jpg",
        //         "user_rank": i + 1
        //     };
        //     tets.push(item);
        // }
        // this.rankData = tets;
        this.flushRank();
    },
    initUI: function () {

        wb.FW(this.rootNode, "closeBtn", function () {
            wb.wxHelper.tj("button", "GuanBi", "PaiHang");
            this.closeLayer();

        }.bind(this));

        this.topImage1 = wb.FW(this.rootNode, "topImage1", function () {
            wb.wxHelper.tj("button", "QuanGuoPaiHang", "PaiHang");
            this.switchRank(true);
        }.bind(this));

        this.topImage2 = wb.FW(this.rootNode, "topImage2", function () {
            wb.wxHelper.tj("button", "HaoYouPaiHang", "PaiHang");
            this.switchRank(false);
        }.bind(this));
        this.topImage1.topzImage = wb.FW(this.topImage1, "topzImage");
        this.topImage2.topzImage = wb.FW(this.topImage2, "topzImage");

        wb.FW(this.rootNode, "qphText", function () {
            wb.wxTool.fxMessage("account", function (data) {
                cc.log(data.shareTickets);
                this.closeLayer();
                SceneManger.showGroup(data.shareTickets);
            }.bind(this));

        }.bind(this));

        wb.FW(this.rootNode, "syyPanel", function () {
            cc.log("syyPanel");
            wb.wxHelper.tj("button", "ShangYiYe", "PaiHang");
            if (!this.ishyRank) {
                if (this.qgPageIndex > 0) {
                    this.qgPageIndex--;
                    this.flushRank();
                }
            } else {
                wb.wx.postMessage({
                    funcName: "prePanel"
                });
            }

        }.bind(this));

        wb.FW(this.rootNode, "xyyPanel", function () {
            cc.log("xyyPanel");
            wb.wxHelper.tj("button", "XiaYiYe", "PaiHang");
            if (!this.ishyRank) {
                if (this.rankData.length > ((this.qgPageIndex + 1) * 6)) {
                    this.qgPageIndex++;
                    this.flushRank();
                }
            } else {
                wb.wx.postMessage({
                    funcName: "nextPanel"
                });
            }

            if (!this.ishyRankPl) {
                var plaque = wb.createPushPlaqueWs(null, null, true);
                if (plaque) {
                    this.addChild(plaque, 100);
                }
                this.nextFlag = true;
            }

        }.bind(this));

        var diPanel = wb.FW(this.rootNode, "diPanel");
        var rankdiPanel = wb.FW(diPanel, "rankdiPanel");
        this.itemPanel = wb.FW(rankdiPanel, "itemPanel");
        this.itemPanel1 = wb.FW(rankdiPanel, "itemPanel1");
        this.dy = this.itemPanel.y - this.itemPanel1.y;
        this.itemPanel.setVisible(false);
        this.itemPanel1.setVisible(false);

        this.qgPanel = wb.FW(this.rootNode, "qgPanel");
        this.hyPanel = wb.FW(this.rootNode, "hyPanel");
        this.hyPanel.setVisible(false);

        for (var i = 0; i < 5; i++) {
            var item = this.itemPanel.clone();
            item.setVisible(true);
            item.setPosition(cc.p(this.itemPanel.x, this.itemPanel.y - i * this.dy));
            this.rankItemList.push(item);
            this.qgPanel.addChild(item);

            item.hgImage = wb.FW(item, "hgImage");
            item.rankText = wb.FW(item, "rankText");
            item.nameText = wb.FW(item, "nameText");
            item.scoreText = wb.FW(item, "scoreText");
            item.headPanel = wb.FW(item, "headPanel");
            item.setVisible(false);
        }

        var itemImage = wb.FW(this.itemPanel, "itemImage");
        // 创建底图
        for (var i = 0; i < 5; i++) {
            var item = itemImage.clone();
            item.setVisible(true);
            item.setPosition(cc.p(this.itemPanel.x, this.itemPanel.y - i * this.dy));
            rankdiPanel.addChild(item);
        }


    },
    initFr: function () {

        var wxPanelSize = this.hyPanel.getContentSize();
        var hgImage = wb.FW(this.itemPanel, "hgImage");
        var rankText = wb.FW(this.itemPanel, "rankText");
        var nameText = wb.FW(this.itemPanel, "nameText");
        var scoreText = wb.FW(this.itemPanel, "scoreText");
        var headPanel = wb.FW(this.itemPanel, "headPanel");

        var hgImageP = this.hyPanel.convertToNodeSpace(wb.convertToWP(hgImage));
        var rankTextP = this.hyPanel.convertToNodeSpace(wb.convertToWP(rankText));
        var nameTextP = this.hyPanel.convertToNodeSpace(wb.convertToWP(nameText));
        var scoreTextP = this.hyPanel.convertToNodeSpace(wb.convertToWP(scoreText));
        var headPanelP = this.hyPanel.convertToNodeSpace(wb.convertToWP(headPanel));

        var data = {
            funcName: "gameFriendRank",
            hgDh: this.dy,
            caSize: {w: wxPanelSize.width, h: wxPanelSize.height},
            hg1ImageP: cc.p(hgImageP.x, wxPanelSize.height - hgImageP.y),
            txPanelP: cc.p(headPanelP.x, wxPanelSize.height - headPanelP.y),
            nameTextP: cc.p(nameTextP.x, wxPanelSize.height - nameTextP.y),
            scoreTextP: cc.p(scoreTextP.x + scoreText.getContentSize().width / 2, wxPanelSize.height - scoreTextP.y)
        };
        this.initFriendRank(data);
    },
    flushRank: function () {
        if (!this.rankData) return;
        var startIndex = this.qgPageIndex * 5;
        var endIndex = (this.qgPageIndex + 1) * 5;
        var playerDataArray = this.rankData.slice(startIndex, endIndex);

        for (var i = 0; i < this.rankItemList.length; i++) {
            this.rankItemList[i].setVisible(false);
        }

        for (var i = 0; i < playerDataArray.length; i++) {
            var item = this.rankItemList[i];
            item.setVisible(true);
            var data = playerDataArray[i];

            item.hgImage.setVisible(true);
            item.rankText.setVisible(true);

            if (parseInt(data.user_rank) <= 3) {
                item.rankText.setVisible(false);
                item.hgImage.loadTexture("res/rankNew/hg" + data.user_rank + ".png");
            } else {
                item.hgImage.setVisible(false);
                item.rankText.setString(data.user_rank);
            }

            item.nameText.setString(wb.subStr(data.user_name, 10));
            item.scoreText.setString(wb.subScore(data.user_score));

            if (item.head) item.head.removeFromParent();

            var head = new PlayerHeadNormal(data.user_icon, item.headPanel.getContentSize());
            head.setPosition(wb.getNodeCenterP(item.headPanel));
            item.headPanel.addChild(head);
            item.head = head;
        }
    },
    showPushPlaque: function () {
        var plaque = wb.createPushPlaqueWs(null, null, true);
        if (plaque) {
            this.addChild(plaque, 100);
        }
    },
    switchRank: function (flag) {

        if (flag && !this.ishyRankPl) {
            this.showPushPlaque();
            this.ishyRankPl = true;
        }

        //if (!flag && !this.isqgRankPl) {
        //    this.showPushPlaque();
        //    this.isqgRankPl = true;
        //}

        this.ishyRank = flag;

        this.qgPanel.setVisible(!this.ishyRank);
        this.hyPanel.setVisible(this.ishyRank);

        this.topImage1.loadTexture("res/rankNew/background_05.png");
        this.topImage2.loadTexture("res/rankNew/background_05.png");

        this.topImage1.topzImage.loadTexture("res/rankNew/hyphzt.png");
        this.topImage2.topzImage.loadTexture("res/rankNew/qgphz.png");

        if (this.ishyRank) {
            this.topImage1.loadTexture("res/rankNew/background_04.png");
            this.topImage1.topzImage.loadTexture("res/rankNew/hyph.png");
        } else {
            this.topImage2.loadTexture("res/rankNew/background_04.png");
            this.topImage2.topzImage.loadTexture("res/rankNew/qgphzt.png");
        }

        if (this.ishyRank && !this.rankSp) {
            this.initFr();
        }
    },
    rankSp: null,
    initFriendRank: function (data) {

        var canvas = wb.wx.getOpenDataCanvas();
        if (!canvas) return;

        if (rankSp) rankSp.removeFromParent();

        canvas.width = 640;
        canvas.height = 1136;
        wb.wx.postMessage(data);
        var rankSp = new cc.Sprite();
        rankSp.setContentSize(cc.size(data.caSize.w, data.caSize.h));
        rankSp.setAnchorPoint(cc.p(0, 1));
        rankSp.setPositionY(data.caSize.h);
        this.rankSp = rankSp;
        this.hyPanel.addChild(rankSp);

    },
    flushFriendRnak: function () {
        if (!this.rankSp || !this.rankSp.isVisible()) return;

        var texture = new cc.Texture2D();
        texture.initWithElement(wb.wx.getOpenDataCanvas());
        texture.handleLoadedTexture();
        this.rankSp.setTexture(texture);
    },
    showBottomBtn: function () {
        var diImage = wb.FW(this.rootNode, "htImage");
        diImage.setVisible(false);

        if(!wb.isWX()) return;
        if (!wb.wxData.pushData) return;
        if (this.isShowBottomBtn) return;
        this.isShowBottomBtn = true;



        var pushAdLayer = wb.createPushAdLayer("rank");
        if (pushAdLayer) {
            pushAdLayer.setPosition(diImage.getPosition());
            diImage.getParent().addChild(pushAdLayer);
        }
    }
});