/**
 * Created by 13075 on 2017/11/13.
 */
var ReviveLayer = wb.BaseLayer.extend({
    ctor: function () {
        this._super(res.reviveScene_json);
        this.initData();
        this.initUI();
        this.schedule(this.flushTime, 1);
    },
    onEnter: function () {
        this._super();
        Tool.showBanner(Config.bannerId1);
        this.popUI("uiPanel", 0.1);
    },
    flushTime: function () {
        if (this.isPlayVideo) return;
        if (this.timeNum < 0) return;

        this.timeText.setString(this.timeNum);
        this.timeNum--;

        this.timeText.runAction(
            cc.sequence(cc.scaleTo(0.1, 1.3),
                cc.scaleTo(0.1, 1.0)
            ));
        // 倒计时结束
        if (this.timeNum < 0) {
            this.showBreak();
        } else {
            this.spine.setAnimation(0, "" + (6 - this.timeNum), false);
        }
    },
    // 判断是否弹出插屏
    judgeIsShowTime: function () {
        if (Tool.isToDayFlag) {
            return false;
        }

        // 上局显示过插屏
        if (Tool.revivePlFlag) return false;

        // 复活第二次，第一次没弹出 ，第二次必弹出
        if (Logic.reviveNum == 1) {
            return !Logic.reviveTimeIsShow;
        }

        var randNum = wb.randNum(0, 100);
        if (randNum <= Config.reviveProbability) {
            return true;
        }
        return false;
    },
    initData: function () {
        this.timeNum = 6;
        this.isPlayVideo = false;
    },
    initUI: function () {

        this.videoBtn = wb.FW(this.rootNode, "videoBtn", function () {
            //this.reLive();
            wb.wxHelper.tj("video", "MianFeiFuHuo", "FuHuo");
            cc.log("videoBtn");
            //if (!wb.ADManager.isVideoEnable) {
            //    SceneManger.showTip("视频未加载好~");
            //    return;
            //}

            if(!wb.ADManager.isAdReady("level_fail_mfzs")){
                SceneManger.showTip("视频未准备好~");
                return;
            }

            this.isPlayVideo = true;
            this.videoBtn.setTouchEnabled(false);
            wb.ADManager.openAdC("level_fail_mfzs", function (a, result) {
                this.videoBtn.setTouchEnabled(true);

                if (result == 0) {
                    this.reLive();
                    Tool.addDiamond(10);
                } else {
                    SceneManger.showTip("视频未播放完~");
                }
                this.isPlayVideo = false;
            }.bind(this));
        }.bind(this));

        var djtgText = wb.FW(this.rootNode, "djtgText", function () {
            cc.log("djtgText");
            wb.wxHelper.tj("video", "DianJiTiaoGuo", "FuHuo");
            SceneManger.showEnd();
            this.closeLayer();
        }.bind(this));
        //djtgText.setVisible(false);
        //this.scheduleOnce(function () {
        //    djtgText.setVisible(true);
        //}.bind(this), 2);

        wb.FW(this.rootNode, "scoreText").setString(SnakeHelper.bkLayer.getCScore());

        this.timeText = wb.FW(this.rootNode, "timeText");
        this.circleImage = wb.FW(this.rootNode, "circleImage");
        this.fhImage = wb.FW(this.rootNode, "fhImage");
        this.fhImage.runAction(cc.rotateBy(0.02, -4).repeatForever());

        var circlePanel = wb.FW(this.rootNode, "circlePanel");
        this.spine = GameSpine.createDjsSp(cc.p(0, 0), circlePanel);
        this.flushTime();

        // 复活界面   插屏几率弹出
        if (this.judgeIsShowTime()) {
            Logic.reviveTimeIsShow = true;
            var plaque = wb.createPushPlaqueWs(null, null, true, function () {
                this.isPlayVideo = false;
            }.bind(this));
            if (plaque) {
                this.isPlayVideo = true;
                this.addChild(plaque, 100);
            }
        }

        //if (!this.isShowTimeFlag) {
        //    this.fhImage.setVisible(false);
        //    this.spine.setVisible(false);
        //    this.timeText.setVisible(false);
        //
        //    var titleImage = wb.FW(this.rootNode, "titleImage");
        //    titleImage.y = titleImage.y - 100;
        //
        //    var scoreText = wb.FW(this.rootNode, "scoreText");
        //    scoreText.y = scoreText.y - 200;
        //
        //}
    },
    showBreak: function () {

        this.videoBtn.setTouchEnabled(false);
        this.fhImage.setVisible(false);
        this.timeText.setVisible(false);
        var uiPanel = wb.FW(this.rootNode, "uiPanel");
        this.circleImage.setVisible(false);

        this.spine.setAnimation(0, "action", false);
        this.spine.setCompleteListener(function (traceIndex, loopCount) {
            this.callBreak();
        }.bind(this));

    },
    callBreak: function () {
        this.scheduleOnce(function () {
            SceneManger.showEnd();
            this.closeLayer();
        }, 0.1);
    },
    reLive: function () {
        Logic.reviveGame();
        this.closeLayer();
        Logic.isCoinType = true;
        Logic.checkGetCoinMode();
        Tool.createBanner(Config.bannerId4);

    }
});