/**
 * Created by Administrator on 2018/11/27.
 */
var ShaderManger = {
    _shaderMap: {},
    setWidgetColorEffect: function (widget) {
        var shader = new cc.GLProgram(res.ui_color_vsh, res.ui_color_fsh);
        shader.addAttribute(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
        shader.addAttribute(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
        shader.addAttribute(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);

        shader.link();
        shader.updateUniforms();
        shader.use();
        // 255,214,103
        shader.setUniformLocationWith1f(shader.getUniformLocationForName('u_threshold'), 5);
        shader.setUniformLocationWith3f(shader.getUniformLocationForName('u_outlineColor'), 1, 1, 0);
        widget.getVirtualRenderer().setShaderProgram(shader);

        widget.getVirtualRenderer().getGLProgramState().setUniformFloat("u_radius", 0.01);
        widget.setColor(cc.color(255, 214, 103));
    },
    setWidgetNormalEffect: function (widget) {
        widget.setColor(cc.color(255, 255, 255));
        this.setShader(widget, "ui_normal");
    },
    setWidgetGrayEffect: function (widget) {
        this.setShader(widget, "ui_gray");
    },
    setWidgetOutLineEffect: function (widget) {
        var shader = new cc.GLProgram(res.ui_outline_vsh, res.ui_outline_fsh);
        shader.addAttribute(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
        shader.addAttribute(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
        shader.addAttribute(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);

        shader.link();
        shader.updateUniforms();
        shader.use();
        shader.setUniformLocationWith1f(shader.getUniformLocationForName('u_threshold'), 1.0);
        shader.setUniformLocationWith3f(shader.getUniformLocationForName('u_outlineColor'), 0 / 255, 255 / 255, 0 / 255);
        // shader.setUniformLocationWith3f(shader.getUniformLocationForName('u_outlineColor'), 1, 0.84, 0.404);

        widget.shaderProgram = shader;
        //shader.use();
        //shader.setUniformLocationWith1f(shader.getUniformLocationForName('u_radius'), 2);
        //shader.updateUniforms();
        // widget.getVirtualRenderer().setShaderProgram(shader);
    },
    setShader: function (widget, type) {
        if (!widget) return;
        var shader = this.getShaderMap(type);
        if (widget) {
            var children = widget.getChildren();
            for (var i in children) {
                this.setShader(children[i], type);
            }

            if (!widget.getString) {
                widget.setShaderProgram(shader);
            }

            if (widget.getVirtualRenderer) {
                var children = widget.getVirtualRenderer().getChildren();
                for (var i in children) {
                    this.setShader(children[i], type);
                }

                if (!widget.getVirtualRenderer().getString) {
                    widget.getVirtualRenderer().setShaderProgram(shader);
                }
            }
        }
        return shader;
    },
    getShaderMap: function (type) {
        var _s = this._shaderMap[type];
        if (_s) {
            //cc.log("LayoutConfig.getShaderMap: " + n + " Cache");
            return _s;
        }

        var v_n = res[type + "_vsh"];
        var f_n = res[type + "_fsh"];

        _s = new cc.GLProgram(v_n, f_n);
        _s.addAttribute(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
        _s.addAttribute(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);
        _s.addAttribute(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
        _s.link();
        _s.updateUniforms();

        this._shaderMap[type] = _s;

        //cc.log("LayoutConfig.getShaderMap: " + n + " New");
        return _s;
    }
};