/**
 * Created by 13075 on 2017/11/13.
 */
var SkinLayer = wb.BaseLayer.extend({
    lockList: null,
    selectIndex: 0, // 选中的下标
    ctor: function () {
        this._super(res.skinScene_json);
        this.initData();
        this.initUI();

        this.createItems();

        this.flushUnlock();
        this.flushSelectBk(SnakeHelper.skinIndex);
    },
    onEnter: function () {
        this._super();
        Tool.showBanner(Config.bannerId5);
    },
    onExit: function () {
        this._super();
        // Tool.hideBanner();
        Tool.showBanner(Config.bannerId4);
    },
    initData: function () {
        this.skinItems = [];
        this.lockList = [];
        SnakeHelper.initSkin();
    },
    flushUnlock: function () {
        var cTime = new Date().getTime();
        for (var i = 0; i < 12; i++) {
            var tag = wb.getItem("skinlock" + i, 0);
            if (i < 3) tag = 1;
            this.lockList[i] = tag;
            if (Config.isAllUnLock) this.lockList[i] = 1;

            var node = this.skinItems[i];
            var timeText = wb.FW(node, "timeText");
            var newImage = wb.FW(node, "newImage");
            var lockImage = wb.FW(node, "lockImage");
            var shadeImage = wb.FW(node, "shadeImage");
            timeText.setVisible(false);

            if (i < 9) {
                newImage.setVisible(false);
                lockImage.loadTexture("res/start/video.png");
                lockImage.setColor(cc.color(254, 185, 56));
                lockImage.setContentSize(cc.size(67, 63));
                lockImage.setScale(0.7);
            }

            if (this.lockList[i] == 1) {
                if (i < 9) {
                    shadeImage.setVisible(false);
                    lockImage.setVisible(false);
                } else {
                    var time = wb.getItem("skinlocktime" + i, cTime);

                    // 时间小于0 ，代表永久
                    if (time && time < 0) {
                        shadeImage.setVisible(false);
                        lockImage.setVisible(false);
                    } else {
                        // 剩余的小时数
                        var hour = 24 - Tool.getDHour(time);
                        if (hour > 0) {
                            shadeImage.setVisible(false);
                            lockImage.setVisible(false);
                            timeText.setString(hour + "小时");
                            timeText.setVisible(true);
                        } else {
                            wb.setItem("skinlock" + i, 0);
                        }
                    }
                }
            } else {
                wb.FW(node, "shadeImage").setVisible(true);
                wb.FW(node, "lockImage").setVisible(true);
            }
        }
    },
    initUI: function () {
        this.popUI("uiPanel", 0.1);

        wb.FW(this.rootNode, "closeBtn", function () {
            cc.log("closeBtn");
            this.closeLayer();
        }.bind(this));

        this.uiPanel = wb.FW(this.rootNode, "uiPanel");

        var item1 = wb.FW(this.rootNode, "item1");
        var item2 = wb.FW(this.rootNode, "item2");
        var item3 = wb.FW(this.rootNode, "item3");
        item1.setVisible(false);
        item2.setVisible(false);
        item3.setVisible(false);

        this.originP = item1.getPosition();
        this.dx = item2.x - item1.x;
        this.dy = item1.y - item3.y;
        this.skinItem = item1;

    },
    isLock: function (index) {
        return wb.FW(this.skinItems[index], "lockImage").isVisible();
    },
    flushSelectBk: function (index) {
        cc.log("flushSelectBk " + index);

        for (var i = 0; i < this.skinItems.length; i++) {
            wb.FW(this.skinItems[i], "lightImage").setVisible(false);
        }
        wb.FW(this.skinItems[index], "lightImage").setVisible(true);

        SnakeHelper.skinIndex = index;
        //SnakeHelper.snakeHead.setSnakeSkin(index);
        if (Logic.beganLayer) Logic.beganLayer.flushHeadImage();
    },
    createItems: function () {
        for (var i = 0; i < 4; i++) {
            for (var j = 0; j < 3; j++) {
                var node = this.createItem(i, j);
                this.uiPanel.addChild(node, 1);
                //this.skinItems.push(wb.FW(node, "lightImage"));
                this.skinItems.push(node);
            }
        }
    },
    createItem: function (i, j) {
        var node = this.skinItem.clone();
        node.setVisible(true);
        node.setPosition(cc.p(this.originP.x + j * this.dx, this.originP.y - i * this.dy));
        var index = i * 3 + j;
        var snakeNode = new cc.Node();
        // var snakeHead = SnakeHelper.createSnake(3, snakeNode, cc.p(65, 90), true, index);
        // snakeHead.setSnakeSkin(index);

        var snakeHead = new SnakeSimple(index);
        snakeHead.setPosition(cc.p(65, 75));
        snakeNode.addChild(snakeHead);

        wb.FW(node, "snakePanel").addChild(snakeNode);
        // node.addChild(snakeNode);
        snakeNode.setScale(0.9);

        node.skinIndex = index;
        node.addClickEventListener(function () {
            cc.log("node.skinIndex " + node.skinIndex);
            this.selectIndex = node.skinIndex;
            if (this.isLock(node.skinIndex)) {
                if (node.skinIndex >= 9) {
                    var lockLayer2 = new LockLayer2(this.unlock, this);
                    this.addChild(lockLayer2, 100);

                } else {
                    // var lockLayer = new LockLayer(this.unlock, this);
                    // this.addChild(lockLayer, 100);

                    if (!wb.ADManager.isVideoEnable) {
                        SceneManger.showTip("视频未加载好~");
                        return;
                    }

                    wb.ADManager.openAdC("video", function (a, result) {
                        if (!wb.ADManager.isVideoEnable) {
                            SceneManger.showTip("视频未加载好~");
                            return;
                        }

                        if (result == 0) {
                            this.unlock();
                            SceneManger.showTip("解锁成功~");
                        } else {
                            SceneManger.showTip("视频未播放完~");
                        }
                    }.bind(this));
                }

            } else {
                this.flushSelectBk(node.skinIndex);
            }
        }.bind(this));

        return node;
    },
    unlock: function () {
        wb.setItem("skinlock" + this.selectIndex, 1);
        this.flushUnlock();
        this.flushSelectBk(this.selectIndex);

        if (this.selectIndex >= 9) {
            var timeText = wb.FW(this.skinItems[this.selectIndex], "timeText");
            timeText.setVisible(true);
            timeText.setString("24小时");
            var time = new Date().getTime();
            // 存储时间
            wb.setItem("skinlocktime" + this.selectIndex, time);
        }
    }
});