/**
 * Created by Zack on 2017/10/11.
 */
var SnakeDot = cc.Node.extend({
    _preNode: null,
    _nextNode: null,
    _lastNode: null,
    _numLabel: null,
    _image: null,
    _rect: null,
    isDotActivate: false, // 激活状态
    index: 1,  // 下标
    snakeLength: 1, // 蛇身长度
    isSkin: false,
    skinIndex: 0,
    haveShield: false, // 盾
    throughHole: false,
    ctor: function () {
        this._super();
        var skinObj = SnakeHelper.getSkin();
        this._rect = cc.rect(0, 0, Config.SNAKE_RADIUS, Config.SNAKE_RADIUS);
        this._image = new cc.Sprite(skinObj.bodyPng);
        this.addChild(this._image, 0);
        // this._image.setScale(Config.SNAKE_RADIUS / this._image.getBoundingBox().width);
        //this._image.setColor(Config.SNAKE_COLOR);

        //this._numLabel = new cc.LabelTTF("1", res.Hk7_font, 36);
        //this._numLabel.setPositionY(50);

        this._numLabel = new cc.LabelAtlas("1", "res/numNew/number2.png", 30, 42, "0");
        this._numLabel.setAnchorPoint(cc.p(0.5, 0.5));
        this._numLabel.setPositionY(55);
        this._numLabel.setScale(0.7);

        this.addChild(this._numLabel, 1);

        if (BgSkinManger.isDarkStyle()) {
            this._numLabel.setColor(Config.WHITE_COLOR);
        }
        else {
            this._numLabel.setColor(Config.BK_COLOR);
        }

        this._numLabel.setVisible(false);
        this._lastNode = this;
    },
    setSnakeSkin: function (index) {
        var skinObj = Config.Skin[index];
        //this._image.setTexture(skinObj.headPng);
        //this._image.setAnchorPoint(cc.p(0.5, Config.SNAKE_RADIUS2 / skinObj.headSize.height));
        //// 特殊随机颜色
        //if (skinObj.isSpecial) {
        //    var randN = Tool.randN(0, skinObj.specialColor.length - 1);
        //    this._image.setColor(skinObj.specialColor[randN]);
        //} else {
        //    if (skinObj.headColor) this._image.setColor(skinObj.headColor);
        //}

        var nextNode = this._nextNode;
        do {
            if (!nextNode) break;
            // nextNode._image.setTexture(skinObj.bodyPng);
            //if (skinObj.isSpecial) {
            //    var randN = Tool.randN(0, skinObj.specialColor.length - 1);
            //    nextNode._image.setColor(skinObj.specialColor[randN]);
            //} else {
            if (nextNode.index % 2 == 0) {
                // nextNode._image.setColor(skinObj.bodyColor1);
                this._image.setTexture(skinObj.bodyPng);
            }
            else {
                // nextNode._image.setColor(skinObj.bodyColor2);
                this._image.setTexture(skinObj.bodyPng2);
            }
            //  }
            nextNode = nextNode.getNextSnakeNode();

        } while (true);

        this._image.setTexture(skinObj.headPng);
        this._image.setAnchorPoint(cc.p(0.5, Config.SNAKE_RADIUS2 / skinObj.headSize.height));
    },
    setLastNode: function (node) {
        this._lastNode = node;
    },
    getBSize: function () {
        return cc.size(Config.SNAKE_RADIUS, Config.SNAKE_RADIUS);
    },
    getContentSize: function () {
        return this.getBSize();
    },
    getBBox: function () {
        var p = this.getPosition();
        this._rect.x = p.x - Config.SNAKE_RADIUS2;
        this._rect.y = p.y - Config.SNAKE_RADIUS2;
        return this._rect;
    },
    initHead: function () {
        if (!this.isHead()) return;
        this._numLabel.setVisible(true);
        var skinObj = SnakeHelper.getSkin();
        this._image.setTexture(skinObj.headPng);
    },
    setPreSnakeNode: function (node) {
        this._preNode = node;
    },
    setNextSnakeNode: function (node) {
        this._nextNode = node;
    },
    getPreSnakeNode: function () {
        return this._preNode;
    },
    getNextSnakeNode: function () {
        return this._nextNode;
    },
    getLastNode: function () {
        return this._lastNode;
    },
    setIndex: function (index) {
        this.index = index;
        var skinObj = SnakeHelper.getSkin();
        if (index % 2 == 0) {
            //this._image.setColor(skinObj.bodyColor1);
            this._image.setTexture(skinObj.bodyPng);
        }
        else {
            // this._image.setColor(skinObj.bodyColor2);
            this._image.setTexture(skinObj.bodyPng2);
        }
    },
    addSnakeNode: function () {

        var snakeDot = SnakePoolM.popSnakeNode();
        if (!snakeDot) return;

        this.snakeLength = this.snakeLength + 1;
        this.flushNumLabel();
        //  if (this.snakeLength >= Config.SNAKE_MAXL) return;

        snakeDot.setVisible(true);
        var lastNodeP = this._lastNode.getPosition();
        snakeDot.setPreSnakeNode(this._lastNode);
        this._lastNode.setNextSnakeNode(snakeDot);
        snakeDot.setPosition(lastNodeP);
        // snakeDot.index = this._lastNode.index + 1;
        snakeDot.setIndex(this._lastNode.index + 1);
        this.getParent().addChild(snakeDot, 3);
        this._lastNode = snakeDot;
        // 添加路径到尾
        SnakeHelper.addFrontPath(cc.p(0, -Config.SNAKE_RADIUS), this.isSkin, this.skinIndex);

        this.setSnakeSkin(SnakeHelper.skinIndex);
        return snakeDot;
    },

    subSnakeNode: function () {
        var preNode = this._lastNode.getPreSnakeNode();
        if (!preNode) {
            this._lastNode = this;
            return;
        }
        this.snakeLength = this.snakeLength - 1;
        this._lastNode.setVisible(false);
        this._lastNode.removeFromParent();
        SnakePoolM.pushSnakeNode(this._lastNode);

        this._lastNode = null;
        SnakeHelper.removeSnakeNode(this._lastNode);
        this._lastNode = preNode;
        this._lastNode.setNextSnakeNode(null);
    },
    isHead: function () {
        if (!this._preNode) return true;
        return false;
    },
    initDotP: function (p) {
        this.setPosition(p);
        if (this._nextNode) this._nextNode.initDotP(p);
    },
    adjustP: function (moveSpeed) {
        this.setPosition(cc.pSub(this.getPosition(), cc.p(0, moveSpeed)));
        if (this._nextNode) this._nextNode.adjustP(moveSpeed);
    },
    flushDotP: function (index, sankePath) {
        if (index < 0) return;

        this.setPosition(sankePath[index]);
        if (this._nextNode) {
            if (!this._nextNode.isDotActivate) {
                var nextNodeP = this._nextNode.getPosition();
                var dlength = cc.pDistanceSQ(this.getPosition(), nextNodeP);
                if (dlength >= Config.SNAKE_RADIUSSQ) this._nextNode.isDotActivate = true;
                SnakeHelper.downSnakeDots(this._nextNode);
            }

            if (this._nextNode.isDotActivate) {
                this._nextNode.flushDotP(index - Config.SNAKE_RADIUS, sankePath);
            }
        }
    },
    flushNumLabel: function () {
        this._numLabel.setString("" + this.snakeLength);
    },
    addShield: function () {
        var shield = this.getChildByName("shield");
        if (shield) shield.removeFromParent();
        var shield = new cc.Sprite(res.Shield_png);
        SnakeHelper.snakeHead.addChild(shield, 1, "shield");
        this.haveShield = true;
        SnakeHelper.bkLayer.showToast(SpecialType.Shield);
    },
    // 检测物品
    checkGoods: function (goodsNode, nextP) {
        // return false;

        var snakeRect = SnakeHelper.throughRect;
        var goodsRect = goodsNode.getBBox();


        switch (goodsNode.goodsType) {
            case ItemType.Dot :
                var foodNum = goodsNode.getGoodsNum();
                for (var i = 0; i < foodNum; i++) this.addSnakeNode();
                goodsNode.setVisible(false);
                Tool.playEffect(res.eat_mp3);
                return true;
                break;
            case ItemType.Block:
                if (snakeRect.y + Config.SNAKE_RADIUS2 >= goodsRect.y) return false;

                // 盾
                if (this.haveShield) {
                    goodsNode.removeSelf();
                    SnakeHelper.flushCScoreLabel(goodsNode.getGoodsNum());
                    this.haveShield = false;
                    var shield = this.getChildByName("shield");
                    if (shield) shield.removeFromParent();
                    return true;
                }

                if (this.snakeLength <= 1) {
                    cc.log("game over");
                    SnakeHelper.bkLayer.isGaming = false;
                    SnakeHelper.bkLayer.gameOver();
                    return false;
                }


                var num = Logic.getSectionNum(SnakeHelper.snakeHead.snakeLength);
                if (goodsNode.getGoodsNum() <= 1) {
                    SnakeHelper.reSetGoodRuning(true);
                    SnakeHelper.removeLast();
                }
                else {
                    SnakeHelper.reSetGoodRuning(false);
                    SnakeHelper.removeHead(num);
                }
                goodsNode.runAction(cc.sequence(cc.moveBy(0.06, cc.p(0, 15)), cc.moveBy(0.06, cc.p(0, -15))));
                goodsNode.subGoodsNum(num);
                this.flushNumLabel();
                Tool.playEffect(res.bobo_mp3, false);
                return false;
                break;
            case ItemType.Line:
                if (snakeRect.y >= goodsRect.y) return false;
                var goodsP = goodsNode.getBindSpriteP();
                // 调整坐标
                var dx = goodsRect.width / 2 + Config.SNAKE_RADIUS2 + 1;
                if (goodsP.x >= nextP.x) nextP.x = goodsP.x - dx;
                else nextP.x = goodsP.x + dx;
                return true;
                break;
            case ItemType.Shield:
                goodsNode.setVisible(false);
                var shield = this.getChildByName("shield");
                if (shield) shield.removeFromParent();
                var shield = new cc.Sprite(res.Shield_png);
                SnakeHelper.snakeHead.addChild(shield, 1, "shield");
                this.haveShield = true;
                SnakeHelper.bkLayer.showToast(SpecialType.Shield);
                return true;
                break;
            case ItemType.Frozen:
                goodsNode.setVisible(false);
                if (!SnakeHelper.bkLayer.isGetCoin) {
                    Config.SNAKE_SPEED = Config.FROZEN_SPEED;
                    SnakeHelper.bkLayer.isFrozen = true;
                    SnakeHelper.bkLayer.setTimeN(4);
                    SnakeHelper.bkLayer.setGoodsSpecialType(SpecialType.Ice);
                    SnakeHelper.bkLayer.showToast(SpecialType.Ice);
                }
                return true;
                break;
            case ItemType.Coin:
                goodsNode.setVisible(false);
                SnakeHelper.bkLayer.showToast(SpecialType.Coin);
                SnakeHelper.flushCScoreLabel(2);
                Tool.playEffect(res.coin_mp3);
                return true;
                break;
            case ItemType.Hole:
                if (goodsNode.isEnable) {
                    goodsNode.isEnable = false;
                    SnakeHelper.isHoleing = true;
                    SnakeHelper.bkLayer.isMoveEnable = false;
                    SnakeHelper.bkLayer.showToast(SpecialType.Hole);
                    var holeExitGoods = SnakeHelper.bkLayer.holeExitGoods;
                    if (!holeExitGoods) return true;
                    var holeExitGoodsP = holeExitGoods.getBindSpriteP();
                    var goodsNodeP = goodsNode.getBindSpriteP();
                    var dy = holeExitGoodsP.y - goodsNodeP.y;
                    // 改变到出口的X坐标
                    SnakeHelper.specialPath.push(cc.p(holeExitGoodsP.x, goodsNodeP.y + 1));
                    // 隐藏区域
                    SnakeHelper.bkLayer.holeRect = cc.rect(0, goodsNodeP.y - Config.SNAKE_RADIUS, Config.WINSIZEF().width, dy + Config.SNAKE_RADIUS);
                    return false;
                }
                break;
            case ItemType.HoleExit:
                goodsNode.isEnable = false;
                return true;
                break;
            case ItemType.Box:
                goodsNode.isEnable = false;
                goodsNode.setVisible(false);
                SceneManger.showBox();
                return true;
        }

        //// 是食物
        //if (ItemType.Dot == goodsNode.goodsType) {
        //    var foodNum = goodsNode.getGoodsNum();
        //    for (var i = 0; i < foodNum; i++) this.addSnakeNode();
        //    goodsNode.setVisible(false);
        //    Tool.playEffect(res.eat_mp3);
        //    return true;
        //} else if (ItemType.Block == goodsNode.goodsType) {
        //    if (snakeRect.y + Config.SNAKE_RADIUS2 >= goodsRect.y) return false;
        //
        //    // 盾
        //    if (this.haveShield) {
        //        goodsNode.removeSelf();
        //        SnakeHelper.flushCScoreLabel(goodsNode.getGoodsNum());
        //        this.haveShield = false;
        //        var shield = this.getChildByName("shield");
        //        if (shield) shield.removeFromParent();
        //        return true;
        //    }
        //
        //    if (this.snakeLength <= 1) {
        //        cc.log("game over");
        //        SnakeHelper.bkLayer.isGaming = false;
        //        SnakeHelper.bkLayer.gameOver();
        //        return false;
        //    }
        //
        //
        //    var num = Logic.getSectionNum(SnakeHelper.snakeHead.snakeLength);
        //    if (goodsNode.getGoodsNum() <= 1) {
        //        SnakeHelper.reSetGoodRuning(true);
        //        SnakeHelper.removeLast();
        //    }
        //    else {
        //        SnakeHelper.reSetGoodRuning(false);
        //        SnakeHelper.removeHead(num);
        //    }
        //    goodsNode.runAction(cc.sequence(cc.moveBy(0.06, cc.p(0, 15)), cc.moveBy(0.06, cc.p(0, -15))));
        //    goodsNode.subGoodsNum(num);
        //    this.flushNumLabel();
        //    Tool.playEffect(res.bobo_mp3, false);
        //    return false;
        //} else if (ItemType.Line == goodsNode.goodsType) {
        //    if (snakeRect.y >= goodsRect.y) return false;
        //    var goodsP = goodsNode.getBindSpriteP();
        //    // 调整坐标
        //    var dx = goodsRect.width / 2 + Config.SNAKE_RADIUS2 + 1;
        //    if (goodsP.x >= nextP.x) nextP.x = goodsP.x - dx;
        //    else nextP.x = goodsP.x + dx;
        //    return true;
        //} else if (ItemType.Shield == goodsNode.goodsType) {
        //    goodsNode.setVisible(false);
        //    var shield = this.getChildByName("shield");
        //    if (shield) shield.removeFromParent();
        //    var shield = new cc.Sprite(res.Shield_png);
        //    SnakeHelper.snakeHead.addChild(shield, 1, "shield");
        //    this.haveShield = true;
        //    SnakeHelper.bkLayer.showToast(SpecialType.Shield);
        //
        //    // SnakeHelper.throughRect.height = SnakeHelper.throughRect.height + 20;
        //    return true;
        //} else if (ItemType.Frozen == goodsNode.goodsType) {
        //    goodsNode.setVisible(false);
        //    if (!SnakeHelper.bkLayer.isGetCoin) {
        //        Config.SNAKE_SPEED = Config.FROZEN_SPEED;
        //        SnakeHelper.bkLayer.isFrozen = true;
        //        SnakeHelper.bkLayer.setTimeN(4);
        //        SnakeHelper.bkLayer.setGoodsSpecialType(SpecialType.Ice);
        //        SnakeHelper.bkLayer.showToast(SpecialType.Ice);
        //    }
        //    return true;
        //
        //} else if (ItemType.Coin == goodsNode.goodsType) {
        //    goodsNode.setVisible(false);
        //    SnakeHelper.bkLayer.showToast(SpecialType.Coin);
        //    SnakeHelper.flushCScoreLabel(2);
        //    Tool.playEffect(res.coin_mp3);
        //    return true;
        //} else if (ItemType.Hole == goodsNode.goodsType && goodsNode.isEnable) {
        //    goodsNode.isEnable = false;
        //    SnakeHelper.isHoleing = true;
        //    SnakeHelper.bkLayer.isMoveEnable = false;
        //    SnakeHelper.bkLayer.showToast(SpecialType.Hole);
        //    var holeExitGoods = SnakeHelper.bkLayer.holeExitGoods;
        //    if (!holeExitGoods) return true;
        //    var holeExitGoodsP = holeExitGoods.getBindSpriteP();
        //    var goodsNodeP = goodsNode.getBindSpriteP();
        //    var dy = holeExitGoodsP.y - goodsNodeP.y;
        //    // 改变到出口的X坐标
        //    SnakeHelper.specialPath.push(cc.p(holeExitGoodsP.x, goodsNodeP.y + 1));
        //    // 隐藏区域
        //    SnakeHelper.bkLayer.holeRect = cc.rect(0, goodsNodeP.y - Config.SNAKE_RADIUS, Config.WINSIZEF().width, dy + Config.SNAKE_RADIUS);
        //    return false;
        //} else if (ItemType.HoleExit == goodsNode.goodsType) {
        //    goodsNode.isEnable = false;
        //    return true;
        //} else if (ItemType.Box == goodsNode.goodsType) {
        //    goodsNode.isEnable = false;
        //    goodsNode.setVisible(false);
        //    cc.log("ItemType.Box~~~~~~~~~");
        //    SceneManger.showBox();
        //    return true;
        //}

        return false;
    },
    check: function (goods, nextP) {
        if (!goods.isVisible() || !goods.isEnable) return true;
        var snakeRect = SnakeHelper.throughRect;
        var goodsRect = goods.getBBox();
        if (cc.rectIntersectsRect(snakeRect, goodsRect)) {
            return this.checkGoods(goods, nextP)
        }
        return true;
    }
});

var SnakeHelper = {
    skinIndex: 0,
    snakePath: null,
    snakeHead: null,
    bkLayer: null,
    gameOverLayer: null,
    gameMain: null,
    throughRect: cc.rect(0, 0, 0, 0),
    dl: 1,
    snakeSkinPaths: null,
    snakeSkinHeads: null,
    isHoleing: false, // 钻洞
    specialPath: null,
    init: function () {
        this.snakePath = [];
        this.specialPath = [];
        this.isHoleing = false;
    },
    initSkin: function () {
        this.snakeSkinPaths = [];
        this.snakeSkinHeads = [];
    },
    getSkin: function () {
        return Config.Skin[this.skinIndex];
    },
    createSnake: function (num, node, originP) {
        var snakePath = this.snakePath;

        var snakeHead = SnakePoolM.createNode();
        snakeHead.initHead();

        var headP = cc.p(Config.SNAKE_P.x, Config.SNAKE_P.y - 300);
        if (originP) headP = originP;
        snakePath.push(cc.p(headP.x, headP.y));

        node.addChild(snakeHead, 3);
        for (var i = 1; i < num; i++) {
            snakeHead.addSnakeNode();
        }
        snakeHead.initDotP(headP);
        return snakeHead;
    },
    addSnakeNodeByNum: function (num) {
        if (!this.snakeHead) return;

        for (var i = 0; i < num; i++) {
            this.snakeHead.addSnakeNode();
        }
    },
    hideSnakeDots: function (node) {
        node.setVisible(false);
        var nextNode = node.getNextSnakeNode();
        if (nextNode) {
            this.hideSnakeDots(nextNode);
        }
    },
    // 下移
    downSnakeDots: function (node) {
        node.setPositionY(node.getPositionY() - Config.SNAKE_SPEED);
        var nextNode = node.getNextSnakeNode();
        if (nextNode) {
            this.downSnakeDots(nextNode);
        }
    },
    addPath: function (dp) {
        var snakePath = this.snakePath;

        var dpNormalize = cc.pNormalize(dp);
        var length = cc.pLength(dp);
        if (length < this.dl) return;
        var frontP = snakePath[snakePath.length - 1];
        for (var i = 0; i < length; i++) {
            var tp = this.limitP(cc.pAdd(frontP, dpNormalize));
            if (!this.checkThrough(tp, dpNormalize)) break;
            snakePath.push(tp);
            snakePath.shift();
            frontP = tp;
        }

        this.addSpecialPath();
        this.move();
    },
    addSpecialPath: function () {
        var index = this.snakePath.length - 1;
        for (var i = 0; i < this.specialPath.length; i++) {
            this.snakePath[index].x = this.specialPath[i].x;
            index = index - 1;
        }
        this.specialPath = [];
    },
    limitP: function (p) {
        if (p.x < Config.SNAKE_RADIUS2) p.x = Config.SNAKE_RADIUS2;
        else if (p.x > Config.SNAKE_MAXX) p.x = Config.SNAKE_MAXX;
        return p;
    },
    addFrontPath: function (dp, isSkin, skinIndex) {
        var snakePath = this.snakePath;

        var dpNormalize = cc.pNormalize(dp);
        var length = cc.pLength(dp);
        if (length < this.dl) return;
        var frontP = snakePath[0];
        for (var i = 0; i < length; i++) {
            var tp = this.limitP(cc.pAdd(frontP, dpNormalize));
            snakePath.unshift(tp);
            frontP = tp;
        }
    },
    adjustP: function () {
        var lastSnakeP = this.snakePath[this.snakePath.length - 1];
        if (!lastSnakeP) return;
        if (lastSnakeP.y < Config.SNAKE_P.y) return;
        for (var i = 0; i < this.snakePath.length; i++) {
            this.snakePath[i].y = this.snakePath[i].y - Config.SNAKE_SPEED;
        }
        SnakeHelper.reSetGoodRuning(true);
    },
    adjustPByNum: function (num) {
        for (var i = 0; i < this.snakePath.length; i++) {
            this.snakePath[i].y = this.snakePath[i].y - num;
        }
    },
    move: function () {
        this.snakeHead.flushDotP(this.snakePath.length - 1, this.snakePath);
    },
    // 检测是否可通过
    checkThrough: function (nextP, dir) {
        // return true;
        // cc.log("checkThrough  " + p.x);
        // 钻洞中
        // return true;
        if (this.isHoleing) return true;

        var cP = cc.p(nextP.x, nextP.y);

        this.throughRect.x = nextP.x - Config.SNAKE_RADIUS2;
        this.throughRect.y = nextP.y - Config.SNAKE_RADIUS2;
        this.throughRect.width = Config.SNAKE_RADIUS;
        this.throughRect.height = Config.SNAKE_RADIUS + Config.SNAKE_SPEED;


        if (dir.x < 0) cP.x = cP.x - Config.SNAKE_RADIUS2;
        else if (dir.x > 0) cP.x = cP.x + Config.SNAKE_RADIUS2;
        else if (dir.y > 0) cP.y = cP.y + Config.SNAKE_RADIUS2;

        if (this.snakeHead.haveShield) {
            this.throughRect.height = this.throughRect.height + 20;
            cP.y = cP.y + 50;
        }

        var cgoods = this.bkLayer.getCurrentGood(cP);
        if (!cgoods || !cgoods.isVisible()) return true;

        // 判断类型，处理食物,和碰撞
        return SnakeHelper.snakeHead.check(cgoods, nextP);
    },
    removeHead: function (num) {
        // num = num < this.snakeHead.length ? num : this.snakeHead.length;

        this.snakeHead.subSnakeNode();
        // 头部路径减去
        this.snakePath.splice(this.snakePath.length - Config.SNAKE_RADIUS, Config.SNAKE_RADIUS);

        for (var i = 0; i < num - 1; i++) {
            this.removeLast();
        }
    },
    removeLast: function () {
        this.snakeHead.subSnakeNode();
        this.snakePath.splice(0, Config.SNAKE_RADIUS);
        for (var i = 0; i < this.snakePath.length; i++) {
            this.snakePath[i].y = this.snakePath[i].y - 2;
        }
        //this.move();
    },
    removeSnakeNode: function () {
        this.dotExplosion(this.snakeHead.getPosition());
    },
    reSetGoodRuning: function (flag) {
        this.bkLayer.isGoodsRuning = flag;
    },
    dotExplosion: function (p) {
        Tool.explosion(p, this.bkLayer);
    },
    flushCScoreLabel: function (num) {
        this.bkLayer.flushCScoreLabel(num);
    }
};
