/**
 * Created by zack on 2018/10/31.
 */
var wb = wb || {};
wb.UserInfoLayer = wb.BaseLayer.extend({
    shadeLayer: null,
    callFunc: null,
    data: null,
    ctor: function (func, data) {
        this._super();
        this.initData(func, data);
        this.initUI();
    },
    onExit: function () {
        this._super();
        this.wxStartButton.hide();
        this.wxStartButton.destroy();
    },
    initData: function (func, data) {
        this.callFunc = func;
        this.data = data ? data : {};

        wb.EventManager.addCustomEventListener("userBtnState", function (data) {
            cc.log("userBtnState");
            if (data.getUserData() == "hide") {
                this.wxStartButton.hide();
            } else {
                this.wxStartButton.show();
            }

        }.bind(this), this);
    },
    initUI: function () {
        if (!wb.isWX()) return;
        //var winSize = cc.director.getWinSize();
        //this.shadeLayer = new ccui.Layout();
        //this.shadeLayer.setContentSize(winSize);
        //this.shadeLayer.setBackGroundColor(cc.color.BLACK);
        //this.shadeLayer.setBackGroundColorType(ccui.Layout.BG_COLOR_SOLID);
        //this.shadeLayer.setBackGroundColorOpacity(0);
        //this.shadeLayer.setTouchEnabled(true);
        //this.addChild(this.shadeLayer);

        this.showGetUserBtn();
    },
    showGetUserBtn: function () {
        if (!wb.isWX()) return;
        var winW = wb.wx.getSystemInfoSync().windowWidth;
        var winH = wb.wx.getSystemInfoSync().windowHeight;
        var btnW = this.data.btnW ? this.data.btnW : 320;
        var btnH = this.data.btnH ? this.data.btnH : 119;
        btnW = btnW * winW / 640;
        btnH = btnH * winH / 1136;
        var backgroundColor = this.data.btnBackgroundColor ? this.data.btnBackgroundColor : '#feb938';
        var color = this.data.fontColor ? this.data.fontColor : '#000000';
        var fontSize = this.data.fontSize ? this.data.fontSize : 20;
        var btnText = this.data.btnText ? this.data.btnText : '获取用户信息';

        var wxStartButton = wb.wx.createUserInfoButton({
            type: 'image',
            image: "res/btn_dl.png",
            style: {
                left: winW / 2 - btnW / 2,
                top: winH - winH * 0.3888 - btnH / 2,
                width: btnW,
                height: btnH,
                lineHeight: btnH,
                backgroundColor: backgroundColor,
                color: color,
                textAlign: 'center',
                fontSize: fontSize,
                borderRadius: 0
            }
        });

        wxStartButton.onTap(function (res) {
            // ELSGameData.getInstance().setLoadDay();
            if (!res.rawData) {
                wxStartButton.hide();
                this.removeFromParent();
                return;
            }
            cc.log("wxStartButton.onTap~~~~~~~~~");
            cc.log(res);
            wb.setItem("wxUserInfos", res.rawData);
            var userInfos = JSON.parse(res.rawData);
            cc.log(userInfos);
            this.callLogin(res);
            wxStartButton.hide();
            if (this.callFunc) this.callFunc(userInfos);
            this.removeFromParent();
        }.bind(this));
        wxStartButton.show();
        this.wxStartButton = wxStartButton;
    },
    callLogin: function (resUser) {
        wb.wx.login({
            success: function (res) {
                var requestData = "js_code=" + res.code + "&pid=" + wb.wxConfig.pid;
                cc.log("callLogin " + requestData);
                wb.wxTool.httpRequest(wb.wxConfig.wxLoginUrl, requestData, function (data) {
                    cc.log("wb.wxData.initLoginData4");
                    var sessionKey = data.session_key;
                    wb.wxData.openid = data.openid;
                    cc.log("wxOpenid=" + wb.wxData.openid);
                    cc.log("sessionKey " + sessionKey);
                    wb.setItem("wxOpenid", "" + wb.wxData.openid);
                    this.initUnionid(resUser, sessionKey);
                }.bind(this), false);
            }.bind(this),
            fail: function () {
                cc.log("login fail");
                // if (callFunc) callFunc(null);
            }.bind(this)
        });
    },
    // 获取unionid
    initUnionid: function (resUser, sessionKey) {
        // ELSGameData.getInstance().setLoadDay();
        var strData = {
            iv: resUser.iv,
            encryptedData: resUser.encryptedData,
            sessionKey: sessionKey
        };
        wb.wx.request({
            url: wb.wxConfig.wxUnionidUrl,
            method: 'POST',
            data: strData,
            header: {
                'content-type': 'application/x-www-form-urlencoded'
            },
            success: function (res) {
                cc.log("====wxDeCrypt===");
                cc.log(res.data.unionId);
                if (res.data.unionId) {
                    wb.wxData.unionId = res.data.unionId;
                    wb.setItem("wxUnionId", "" + res.data.unionId);
                }
            }
        })
    }
});

wb.createUserInfoLayer = function (callFunc, data) {
    var wxUserInfos = wb.getItem("wxUserInfos", "");
    wb.wxData.unionId = wb.getItem("wxUnionId", "");
    if (wxUserInfos.length > 0) {
        if (callFunc) callFunc(wb.parse(wxUserInfos));
        return;
    }
    return new wb.UserInfoLayer(callFunc, data);
};