/**
 * Created by Zack on 2017/10/12.
 */

var BgLayer = cc.Layer.extend({
    bgSp: null,
    ctor: function () {
        this._super();
        this.initData();
        this.initUI();
    },
    initData: function () {
        this.bgSp = [];
    },
    initUI: function () {
        for (var i = 0; i < 2; i++) {
            var sp = new cc.Sprite(BgSkinManger.getBgImagePath());
            sp.setAnchorPoint(cc.p(0, 0));
            this.addChild(sp);
            sp.y = 1136 * i;
            this.bgSp.push(sp);
        }
    },
    update: function () {
        // for (var i = 0; i < 3; i++) {
        //     var sp = this.bgSp[i];
        //     sp.y = sp.y - SnakeHelper.gameSpeed
        //     if (sp.y <= -1136) sp.y = 0;
        // }
    }
});

var MoveLayer = cc.Layer.extend({
    _goodsList: null,
    _goodsItemList: null,
    _createLastGoods: false,
    _crowIndex: 0,
    _layerIndex: 1,
    ctor: function (index) {
        this._super();

        this.initData(index);
        this.initUI();
    },
    initData: function (index) {
        this._goodsList = [];
        this._layerIndex = index;
    },
    initUI: function () {
    },
    createLayerGoodsByRow: function (row) {
        for (var j = 0; j < Config.MAP_W; j++) {
            this.createGoodsByIndex(j, row);
        }
    },
    createLastLayerGoods: function () {
        for (var j = 0; j < Config.MAP_W; j++) {
            this.createGoodsByIndex(j, Config.MAP_H - 1);
        }
    },
    createGoodsByIndex: function (j, i) {
        var goodsTypeMap = Logic.getGoodsMapByIndex(this._layerIndex);
        var item = goodsTypeMap[i][j];
        var goods = this.createGoods(i, j);
        goods.setGoodsType(item.goodsType);
        //  goods.setGoodsType(ItemType.Line);
        goods.setGoodsNum(item.goodsNum);

        if (item.goodsType == ItemType.HoleExit) {
            SnakeHelper.bkLayer.holeExitGoods = goods;
        }
    },
    createGoods: function (i, j) {
        var index = i * Config.MAP_W + j;
        if (this._goodsList[index]) return this._goodsList[index];
        var goods = new Goods();
        goods.initOriginP(j, i);
        goods.listIndex = this._goodsList.length;
        this.addChild(goods, Config.MAP_H - i);
        this._goodsList.push(goods);
        return goods;
    },
    getGoodsByIndex: function (i, j) {
        var index = i * Config.MAP_W + j;
        if (this._goodsList[index]) return this._goodsList[index];
        return null;
    },
    update: function (dt) {
        this.moveDown(dt);
    },
    moveDown: function (dt) {
        var cy = this.getPositionY() - SnakeHelper.gameSpeed;//SnakeHelper.bkLayer.gameSpeed;//Config.SNAKE_SPEED;
        if (cy <= -Config.MAP_MOVEMIN) {
            this._crowIndex = 0;
            cy = Config.WINSIZEF().height + Config.BLOCK_WH;
        }

        var dcy = cy - Config.WINSIZEF().height;
        if (dcy <= -this._crowIndex * Config.BLOCK_WH + Config.BLOCK_WH && this._crowIndex < Config.MAP_H) {
            if (this._crowIndex == Config.MAP_H - 1) {
                // 直线行
                Logic.createLastRowItemType(this._layerIndex);
                this.createLastLayerGoods();
            } else {
                Logic.createGoodsByRow(this._crowIndex, this._layerIndex);
                this.createLayerGoodsByRow(this._crowIndex);
            }
            this._crowIndex = this._crowIndex + 1;
        }

        this.setPositionY(cy);
    },
    getCurrentGood: function (p) {
        var cpy = this.getPosition();
        var csnakeP = p;
        var dy = csnakeP.y - cpy.y;
        if (dy < 0 || dy > Config.MAP_MOVEMIN) return null;

        var j = Math.floor(csnakeP.x / Config.BLOCK_WH);
        var i = Math.floor(dy / Config.BLOCK_WH);
        var index = j + i * Config.MAP_W;
        if (index > this._goodsList.length - 1 || index < 0) return null;
        return this._goodsList[index];
    },
    setGoodsSpecialType: function (type) {
        for (var i = 0; i < this._goodsList.length; i++) {
            var goods = this._goodsList[i];
            if (goods) goods.setSpecialType(type);
        }
    }
});

// 背景层
var BkLayer = cc.Layer.extend({
    _moveLayer1: null,
    _moveLayer2: null,
    _windLayer: null,
    isGaming: false,
    isMoveEnable: true,
    isSnakeRuning: true,
    isGoodsRuning: true,
    itemLayer: null,
    cScoreLabel: null,
    timeLabel: null,
    timeN: -1,
    isFrozen: false,
    isGetCoin: false,
    holeExitGoods: null, // 出口洞
    // decelerateV: -1,// 匀减速，直到到指定y轴
    holeRect: null, // 虫洞掩盖区域
    holeRectMoveY: 0,
    holeRect2: null,
    //gameSpeed:0,
    testLabelSpeed: null,
    ctor: function () {
        this._super();
        this.addKeyBoard();

        var colorLayer = new cc.LayerColor(cc.color(36, 35, 35));
        this.addChild(colorLayer);

        if (!BgSkinManger.isNormal()) {
            this.bgLayer = new BgLayer();
            this.addChild(this.bgLayer);
        }

        this.initSnake();
        this._moveLayer1 = new MoveLayer(1);
        this._moveLayer1.setPositionY(Config.WINSIZEF().height + Config.BLOCK_WH);
        this.addChild(this._moveLayer1, 1);

        this._moveLayer2 = new MoveLayer(2);
        this._moveLayer2.setPositionY(Config.WINSIZEF().height + Config.MAP_MOVEMIN + Config.BLOCK_WH);
        this.addChild(this._moveLayer2, 1);

        var itemLayer = new cc.Layer();
        this.itemLayer = itemLayer;
        this.addChild(itemLayer, 10);
        this.cScoreLabel = new cc.LabelTTF("0", res.Hk7_font, 50);
        this.cScoreLabel.setAnchorPoint(cc.p(0, 0.5));
        this.cScoreLabel.setPosition(cc.p(20, Config.WINSIZEF().height - 40));
        this.cScoreLabel.setColor(BgSkinManger.getNormalColor());
        //this.cScoreLabel.setVisible(false);
        itemLayer.addChild(this.cScoreLabel);

        this.timeLabel = new cc.LabelTTF("0", res.Hk7_font, 70);
        this.timeLabel.setPosition(cc.p(Config.CENTER_P.x, Config.WINSIZEF().height - 50));
        this.timeLabel.setColor(cc.color(233, 96, 69));
        this.timeLabel.setVisible(false);
        this.addChild(this.timeLabel, 1);

        this.toastLabel = new cc.LabelTTF("冰冻", res.Hk7_font, 75);
        this.toastLabel.setPosition(cc.p(Config.CENTER_P.x, Config.WINSIZEF().height - 150));
        this.toastLabel.setColor(cc.color(233, 96, 69));
        this.toastLabel.setVisible(false);
        this.addChild(this.toastLabel, 10);

        var pauseMenuItem = new cc.MenuItemImage(res.icon_pause_png, res.icon_pause_png, "", this.onPause, this);
        pauseMenuItem.setPosition(cc.p(Config.WINSIZEF().width - 45, Config.WINSIZEF().height - 40));
        pauseMenuItem.setScale(1.5);
        pauseMenuItem.setColor(BgSkinManger.getNormalColor());
        var mu = new cc.Menu(pauseMenuItem);
        mu.setPosition(cc.p(0, 0));
        itemLayer.addChild(mu, 10);

        itemLayer.setVisible(false);

        this.scheduleUpdate();
        this.schedule(this.timeSub, 1.0);
        //  this.schedule(this.decelerateSub, 0.2);
        SnakeHelper.bkLayer = this;

        SnakeHelper.gameSpeed = Config.SNAKE_SPEED;

        /*this.testLabelSpeed = new cc.LabelTTF("0", res.Hk7_font, 50);
         this.testLabelSpeed.setPosition(cc.p(320, Config.WINSIZEF().height - 140));
         this.testLabelSpeed.setColor(cc.color(255, 255, 255));
         //this.cScoreLabel.setVisible(false);
         itemLayer.addChild(this.testLabelSpeed);*/
    },
    addKeyBoard: function () {
        // cc.eventManager.addListener({
        //     event: cc.EventListener.KEYBOARD,
        //     onKeyReleased: function (key, event) {
        //         if (key == cc.KEY.back) {
        //             var target = event.getCurrentTarget();
        //             if (target.getChildByTag(99)) {
        //                 return;
        //             }
        //             target.onPause(null);
        //         }
        //     }
        // }, this);
    },
    onPause: function (sender) {
        SnakeHelper.gameSpeed = 0;//Config.SNAKE_SPEED = 0;
        var pauseLayer = new PauseLayer();
        this.addChild(pauseLayer, 11, 99);
    },
    timeSub: function (dt) {
        if (this.isFrozen) this.frozenTimeSub(dt);
        if (this.isGetCoin) this.coinTimeSub(dt);
    },
    frozenTimeSub: function (dt) {
        if (this.timeN <= 0) {
            this.timeLabel.setVisible(false);
            SnakeHelper.gameSpeed = Config.SNAKE_SPEED;//Config.SNAKE_SPEED = Config.NORMAL_SPEED;
            this.isFrozen = false;
            this.setGoodsSpecialType(SpecialType.None);
            return;
        } else {
            this.timeLabel.setString("" + this.timeN);
            this.timeN = this.timeN - 1;
            this.timeLabel.runAction(cc.sequence(cc.scaleTo(0.1, 1.2), cc.scaleTo(0.1, 1.0)));
        }
    },
    coinTimeSub: function (dt) {
        if (this.timeN <= 0) {
            this.isGetCoin = false;
            this.timeLabel.setVisible(false);
            SnakeHelper.gameSpeed = Config.SNAKE_SPEED;//Config.SNAKE_SPEED = Config.NORMAL_SPEED;
            if (this._windLayer) this._windLayer.removeFromParent();
        } else {
            this.timeLabel.setString("" + this.timeN);
            this.timeN = this.timeN - 1;
            this.timeLabel.runAction(cc.sequence(cc.scaleTo(0.1, 1.2), cc.scaleTo(0.1, 1.0)));
        }
    },
    setTimeN: function (t) {
        this.timeN = t;
        if (t > 0) {
            this.timeLabel.setVisible(true);
        } else {
            this.timeLabel.setVisible(false);
        }

    },
    initSnake: function () {
        var snakHead = SnakeHelper.createSnake(5, this);
        SnakeHelper.snakeHead = snakHead;
    },
    update: function (dt) {
        if (!this.isGaming) return;

        this.updateSnake(dt);
        this.updateGoodsLayer(dt);
        this.updateHoleRect(dt);

        if (this.testLabelSpeed) {
            this.testLabelSpeed.setString("当前速度:" + SnakeHelper.gameSpeed);
        }
    },
    updateSnake: function (dt) {
        if (!this.isSnakeRuning) return;
        // 先减再增
        if (!SnakeHelper.snakeHead) return;
        SnakeHelper.adjustP();
        SnakeHelper.addPath(cc.p(0, SnakeHelper.gameSpeed/*Config.SNAKE_SPEED*/));
    },
    updateHoleRect: function (dt) {
        if (this.holeRect) {
            this.holeRect.y = this.holeRect.y - SnakeHelper.gameSpeed;//Config.SNAKE_SPEED;
            this.holeHideSnake();
            if (this.holeRect.y <= -this.holeRect.height) {
                this.holeRect = null;
                var node = SnakeHelper.snakeHead;
                do {
                    if (!node) break;
                    node.setVisible(true);
                    node = node.getNextSnakeNode();
                } while (true);
            }
        }
    },
    updateGoodsLayer: function (dt) {
        if (!this.isGoodsRuning) return;
        this._moveLayer1.update(dt);
        this._moveLayer2.update(dt);
    },
    getCurrentGood: function (p) {
        var goods = this._moveLayer1.getCurrentGood(p);
        if (!goods) return this._moveLayer2.getCurrentGood(p);
        return goods;
    },
    gameOver: function () {
        Tool.saveBestScore(this.getCScore());
        SceneManger.showReviveLayer();
    },
    flushCScoreLabel: function (num) {
        var n = 1;
        if (num) n = num;
        var sum = this.getCScore() + n;
        this.cScoreLabel.setString(sum);
        Logic.changeGPer();
        Logic.coinScore = Logic.coinScore + n;
        Logic.checkGetCoinMode();

        var snakeConfig = Logic.getSnakeConfigBySocre(sum);
        if (snakeConfig != null) {
            Config.SNAKE_SPEED = Config.NORMAL_SPEED + snakeConfig.speedAdd;
            Config.FROZEN_SPEED = Config.SNAKE_SPEED - 2;
            if (this.isGetCoin == false) {
                if (this.isFrozen == true) {
                    SnakeHelper.gameSpeed = Config.FROZEN_SPEED;
                } else {
                    SnakeHelper.gameSpeed = Config.SNAKE_SPEED;
                }
            }
        }
        // Config.NORMAL_SPEED
        //if(!this.isFrozen && !this.isGetCoin){
        //    Logic.addSnakeSpeed(this.getCScore());
        //}
    },
    getCScore: function () {
        return parseInt(this.cScoreLabel.getString());
    },
    setGoodsSpecialType: function (type) {
        this._moveLayer1.setGoodsSpecialType(type);
        this._moveLayer2.setGoodsSpecialType(type);
    },

    holeHideSnake: function () {
        var snakeHeade = SnakeHelper.snakeHead;
        var node = snakeHeade.getNextSnakeNode();
        do {
            if (!node) break;
            // 隐藏
            if (cc.rectContainsPoint(this.holeRect, node.getPosition())) node.setVisible(false);
            else node.setVisible(true);
            node = node.getNextSnakeNode();
        } while (true);

        // 从洞口钻出
        if (snakeHeade.getPositionY() > this.holeRect.y + this.holeRect.height) {
            snakeHeade.setVisible(true);
            // 可移动
            SnakeHelper.bkLayer.isMoveEnable = true;
            SnakeHelper.isHoleing = false;
        } else {
            snakeHeade.setVisible(false);
        }
    },
    showToast: function (type) {
        //cc.log("showToast" + type);
        this.toastLabel.stopAllActions();
        this.toastLabel.setString("");
        this.toastLabel.setOpacity(255);


        var action = null;
        var action1 = cc.sequence(cc.scaleTo(0.08, 1.2),
            cc.scaleTo(0.08, 1.0),
            cc.delayTime(2),
            cc.fadeOut(1)
        );

        switch (type) {
            case SpecialType.Ice:
                this.toastLabel.setString("冰冻");
                this.toastLabel.setColor(cc.color(85, 148, 232));
                action = action1;
                break;
            case SpecialType.Shield:
                this.toastLabel.setString("护盾");
                this.toastLabel.setColor(cc.color(225, 152, 58));
                action = action1;
                break;
            case SpecialType.Coin:
                this.toastLabel.setString("+1");
                this.toastLabel.setColor(cc.color(236, 215, 35));
                action = cc.sequence(cc.scaleTo(0.05, 1.2), cc.scaleTo(0.05, 1.0), cc.fadeOut(0.5));
                break;
            case SpecialType.CoinTip:
                var label = new cc.LabelTTF("获取星星吧!", res.Hk7_font, 75);
                label.setPosition(cc.p(Config.CENTER_P.x, Config.WINSIZEF().height - 230));
                label.setColor(cc.color(255, 157, 0));
                this.addChild(label, 10);
                label.runAction(cc.sequence(cc.blink(2, 8), cc.removeSelf()));
                action = null;
                break;
            case SpecialType.Hole:
                this.toastLabel.setString("虫洞");
                this.toastLabel.setColor(cc.color(62, 147, 243));
                action = action1;
                break;
        }

        if (action) {
            this.toastLabel.setVisible(true);
            this.toastLabel.runAction(action);
        }
    },
    showGuide: function () {
        if (Tool.isFirstPlay()) {
            var gudieLayer = new GuideLayer();
            this.addChild(gudieLayer, 11);
        }
    },
    resumeGame: function () {
        if (this.isFrozen) {
            SnakeHelper.gameSpeed = Config.FROZEN_SPEED;
        } else if (this.isGetCoin) {
            SnakeHelper.gameSpeed = Config.GETSTART_SPEED;
        } else {
            SnakeHelper.gameSpeed = Config.SNAKE_SPEED;
        }
    }
});
