/**
 * Created by cc on 2017/12/21.
 */

var FireBlock = cc.Node.extend({
    _spriteBody:null,
    _bodySize:null,
    _size:null,
    _labelHp:null,
    _Hp:0,
    _rect:null,
    _blockDelgate:null,
    _color:null,
    ctor:function(){
        this._super();

        this._rect = cc.rect(0,0,FireConfig.BlockImgSize.width,FireConfig.BlockImgSize.height);
        this._size = cc.size(this._rect.width,this._rect.height);
        //this._anchorPoint = cc.p(0.5,0.5);
    },
    setData:function(data){
        this._Hp = data.Hp;
        var color = data.Color;
        this._color = color;

        var size = data.Size;
        this._rect = cc.rect(0,0,size.width,size.height);
        this._size = cc.size(this._rect.width,this._rect.height);
        this._bodySize = size;

        this._spriteBody = new cc.Sprite(resFireup.fireBlock);
        this._spriteBody.setPosition(this._bodySize.width/2,this._bodySize.height/2);
        this.addChild(this._spriteBody);
        this._spriteBody.setColor(color);
        this._spriteBody.setScale(size.width/FireConfig.BlockImgSize.width);

        this._labelHp = new cc.LabelTTF("0", res.Hk7_font, 50);
        this._labelHp.setPosition(this._bodySize.width/2,this._bodySize.height/2);
        this._labelHp.setColor(cc.color(35, 35, 35));
        this.addChild(this._labelHp, 1);
        this._labelHp.setString(this._Hp);

        if(data.MoveBy){
            var dataMoveBy = data.MoveBy;
            var moveBy = cc.moveBy(dataMoveBy.time,cc.p(dataMoveBy.x*size.width,dataMoveBy.y*size.height));
            this.runAction(cc.repeatForever(cc.sequence(moveBy,moveBy.reverse())));
        }
    },
    onEnter:function(){
        this._super();
    },
    moveBy:function(dPos){
        var winSize = cc.winSize;
        var curPos = this.getPosition();
        var nxtPos = cc.p(curPos.x,curPos.y + dPos.y);
        this.setPosition(nxtPos);
        if(nxtPos.y < -this._bodySize.height/2)
        {
            if(this._blockDelgate){
                //this._gameDelgate.removeBlock(this);
            }
        }
    },
    onHurt:function(bullet)
    {
        Tool.playEffect(res.bobo_mp3);
        var attack = bullet._attact;
        this._Hp = this._Hp - attack;
        this._blockDelgate.addScore(attack);
        if(this._Hp <= 0){
            this._blockDelgate.removeBlock(this);
        }else{
            this._labelHp.setString(this._Hp);
            var color = FireDeal.getBlockColorByHp(this._Hp);
            this._spriteBody.setColor(color);
        }
    },
    getBox:function(){
        var pos = this.getPosition();
        this._rect.x = pos.x/* - this._size.width / 2*/;
        this._rect.y = pos.y/* - this._size.height / 2*/;
        return this._rect;
        //return this.getBoundingBox();
    }
});
