/**
 * Created by cc on 2017/12/21.
 */

var FireBlockLayer = cc.Layer.extend({
    _blocksList:null,
    _gameDelgate:null,
    ctor:function(){
        this._super();

        this._blocksList = [];
    },
    onUpdate:function(dt){
        if(this._gameDelgate == null) return;

        var speed = this._gameDelgate._gameSpeed*dt;
        for(var i = 0; i < this._blocksList.length;i++)
        {
            var block = this._blocksList[i];
            block.y = block.y - speed;
            if(block.y < (-block._size.width))
            {
                this.removeChild(block);
                this._blocksList[i] = undefined;
                this._blocksList.splice(i,1);
                i = i - 1;
            }
        }
    },
    createBlocksTop:function(num,size){
        var winSize = cc.winSize;
        var dis = winSize.width/num;
        var probArry = FireDeal.randomHpListOfNum(num,this._gameDelgate._CntBlockRow);
        //重新排序
        probArry.sort(function(a,b){
           return (0.5 - Math.random());
        });
        for(var i = 0; i < num; i++)
        {
            var block = new FireBlock();
            block._blockDelgate = this;
            block.x = i*dis;// + dis/2;
            block.y = winSize.height;// + block._rect.height/2;
            this.addChild(block);
            this._blocksList.push(block);

            var data = probArry[i];
            data.Size = size;
            //var data = {Hp:probArry[i],Size:size};
            block.setData(data);
        }
    },
    createBlocksByMode:function(size){
        var winSize = cc.winSize;
        var bkWidth = size.width;
        var kbHeight = size.height;
        var blockMode = FireDeal.getRandomBlocksMode();
        if(blockMode == null) return 0;
        var blockList = blockMode._blockList;
        var rowNum = blockMode._rowNum;
        var num = blockList.length;
        var probArry = FireDeal.randomHpListOfExtNum(num,this._gameDelgate._CntBlockRow);
        //重新排序
        probArry.sort(function(a,b){
            return (0.5 - Math.random());
        });
        for(var i = 0; i < blockList.length; i++)
        {
            var blockData = blockList[i];
            var block = new FireBlock();
            block._blockDelgate = this;
            block.x = blockData._iPos.x * bkWidth;
            block.y = winSize.height + blockData._iPos.y * kbHeight;
            this.addChild(block);
            this._blocksList.push(block);

            var data = probArry[i];
            data.Size = size;
            data.MoveBy = blockData._moveBy;
            //var data = {Hp:probArry[i],size:size};
            block.setData(data);
        }
        return rowNum;
    },
    removeBlock:function(delBlock)
    {
        for(var i = 0; i < this._blocksList.length;i++)
        {
            var block = this._blocksList[i];
            if(delBlock == block){
                this.onCrashEffect(block);
                this.removeChild(block);
                this._blocksList[i] = undefined;
                this._blocksList.splice(i,1);
                break;
            }
        }
    },
    getBlocksList:function(){
        return this._blocksList;
    },
    addScore:function(hp){
        this._gameDelgate.addScore(hp);
    },
    onCrashEffect:function(block){
        var p = block.getPosition();
        p.x += block._bodySize.width/2;
        p.y += block._bodySize.height/2;
        var size = block._bodySize;

        var node = this.getParent();
        var totalN = 25;
        var maxL = cc.winSize.width;
        for (var i = 0; i < totalN; i++) {
            var x = Tool.randN(0, size.width) - size.width/2;
            var y = Tool.randN(0, size.height) - size.height/2;
            var bP = cc.p(p.x + x, p.y + y);
            var dotSp = new cc.Sprite(resFireup.fireBullet);
            dotSp.setColor(block._color);
            dotSp.setPosition(bP);
            dotSp.setScale(0.6);
            var moveP = cc.pAdd(p, cc.pMult(cc.pNormalize(cc.p(x, y)), maxL));

            var action = cc.sequence(cc.spawn(cc.moveTo(2, moveP).easing(cc.easeOut(1)), cc.scaleTo(2, 0.2)), cc.removeSelf());
            dotSp.runAction(action);
            node.addChild(dotSp);
        }
    }
});