/**
 * Created by cc on 2017/12/22.
 */
var FireData = {
    //存储的数据
    _Level: 1,
    _Score: 0,
    _FireSpeedLv: 1,
    _FireAtkLv: 1,
    _HighScore: 0,

    reviveNum: 0,
    init: function () {
        var level = cc.sys.localStorage.getItem("Fireup_Level");
        if (level) {
            FireData._Level = parseInt(level);
        }
        var score = cc.sys.localStorage.getItem("Fireup_Score");
        if (score) {
            FireData._Score = parseInt(score);
        }
        var highScore = cc.sys.localStorage.getItem("Fireup_HighScore");
        if (highScore) {
            FireData._HighScore = parseInt(highScore);
        }

        var fireSpeedLv = cc.sys.localStorage.getItem("Fireup_FireSpeedLv");
        if (fireSpeedLv) {
            FireData._FireSpeedLv = parseFloat(fireSpeedLv);
        }
        var fireAtkLv = cc.sys.localStorage.getItem("Fireup_FireAtkLv");
        if (fireAtkLv) {
            FireData._FireAtkLv = parseFloat(fireAtkLv);
        }
    },
    setLevel: function (tag) {
        FireData._Level = tag;
        cc.sys.localStorage.setItem("Fireup_Level", tag);
    },
    setScore: function (tag) {
        FireData._Score = tag;
        cc.sys.localStorage.setItem("Fireup_Score", tag);
    },
    setHighScore: function (tag) {
        if (tag > FireData._HighScore) {
            FireData._HighScore = tag;
            cc.sys.localStorage.setItem("Fireup_HighScore", tag);
        }
        // 上传分数
        wb.GameHelper.sumbitUserScore(parseInt(FireData._HighScore), 207);
        // 统计
        wbTool.tjEvent("game_ssdzzFire", "score_" + FireData._HighScore);
    },
    setFireSpeedLv: function (tag) {
        FireData._FireSpeedLv = tag;
        cc.sys.localStorage.setItem("Fireup_FireSpeedLv", tag);
    },
    setFireAtkLv: function (tag) {
        FireData._FireAtkLv = tag;
        cc.sys.localStorage.setItem("Fireup_FireAtkLv", tag);
    }
}

var FireDeal = {

    //随机生成道具
    getItemTypeRandom: function () {
        var sum = FireConfig.ItemSpeedUpProb + FireConfig.ItemHeavyAtkProb + FireConfig.ItemDoubleFirProb;
        var ranNum = Tool.randN(0, sum);
        if (ranNum < FireConfig.ItemSpeedUpProb) {
            return FireConfig.ItemSpeedUp;
        } else if (ranNum < (FireConfig.ItemHeavyAtkProb + FireConfig.ItemSpeedUpProb)) {
            return FireConfig.ItemHeavyAtk;
        } else {
            return FireConfig.ItemDoubleFir;
        }
    },
    //格式化输出分数K
    getStrOfKiloNum: function (num) {
        var tarValue = num;
        if (num > 1000) {
            tarValue = num / 1000.0;
            tarValue = tarValue.toFixed(2);
            tarValue = tarValue.toString();
            tarValue = tarValue + "K";
        }
        return tarValue;
    },
    //升级所需分数
    getSocreOfUpgrade: function () {
        var need = 0;
        var level = FireData._Level;
        if (level <= 2) {
            need = 5 * level * 30;
        } else if (level <= 8) {
            need = 30 * level * 60;
        } else if (level <= 15) {
            need = 45 * level * 80;
        } else {
            need = 64 * level * 100;
        }
        return need;
    },
    //武器升级
    weaponUpgrade: function () {
        FireData.setFireSpeedLv(FireData._FireSpeedLv + 0.5);
        FireData.setFireAtkLv(FireData._FireAtkLv + 0.5);
        var level = (FireData._FireAtkLv + FireData._FireSpeedLv * 2) / 2;
        level = Math.floor(level);
        FireData.setLevel(level);
    },
    //计算攻击速度（可根据障碍物的高度变化）
    getFireCDSecond: function (parmSize/*障碍物size*/) {
        var pram = parmSize;
        if (parmSize == undefined) {
            pram = FireConfig.BlockSize4;
        }
        var CDs = pram.height / FireConfig.FireGameSpeed;//FireBulletSpeed;
        var speedLv = FireDeal.getFireSpeedGrade();
        CDs = CDs / (speedLv);
        //CDs *= 2;
        return CDs;
    },
    getFireSpeedGrade: function () {
        var grade = 1;
        var level = FireData._Level;
        if (level <= 2) {
            grade = 1;
        } else if (level <= 8) {
            grade = 2;
        } else if (level <= 15) {
            grade = 3;
        } else {
            grade = 4;
        }
        return grade;
    },
    //子弹伤害
    getBulletDamage: function () {
        var level = FireData._Level;
        var lvIdx = FireDeal.getLevelIdx();
        return (level * lvIdx);
    },
    getBulletSpeed: function () {
        var speed = FireConfig.FireBulletSpeed;
        var level = FireData._Level;
        var levelGradeList = FireConfig.LevelGrade;
        var factor = 1;
        for (var i = 0; i < levelGradeList.length; i++) {
            var gradeData = levelGradeList[i];
            if (level <= gradeData._maxLV) {
                factor = gradeData._speedIntal + (level - gradeData._minLV) * gradeData._speedFactor / (gradeData._maxLV - gradeData._minLV + 1);
                break;
            }
        }
        speed *= factor;
        return speed;
    },
    getLevelIdx: function () {
        var level = FireData._Level;
        var idx = 1;
        if (level <= 2) {
            idx = 1;
        } else if (level <= 8) {
            idx = 2;
        } else if (level <= 15) {
            idx = 3;
        } else {
            idx = 4;
        }
        return idx;
    },
    getAverageDemageOfLv: function () {
        var level = FireData._Level;
        var idx = FireDeal.getLevelIdx();
        var averageDemage = level;
        if (idx == 1) {
            averageDemage *= 8;//5;
        } else if (idx == 2) {
            averageDemage *= 30;//30;
        } else if (idx == 3) {
            averageDemage *= 45;//45;
        } else {
            averageDemage *= 64;//64;
        }
        return averageDemage;
    },
    //随机生成方块血量HP
    randomHpListOfNum: function (num, row) {
        var hpBase = FireDeal.getAverageDemageOfLv();
        //hpBase*= 5;
        var randomList = [];
        var probArry = FireDeal.getHpProbByRow(row);
        for (var j = 0; j < probArry.length; j++) {
            var prob = probArry[j];
            var Hp = FireDeal.getHpProbFunc(prob, hpBase);
            //颜色
            var color = FireDeal.getBlockColorByHp(Hp);
            var data = {Hp: Hp, Color: color};
            randomList.push(data);
            if (randomList.length >= num) {
                break;
            }
        }
        return randomList;
    },
    randomHpListOfExtNum: function (num, row) {
        var hpBase = FireDeal.getAverageDemageOfLv();
        var randomList = [];
        var probArry = FireDeal.getHpProbByRow(row);
        for (var j = 0; j < probArry.length; j++) {
            var prob = probArry[j];
            var Hp = FireDeal.getHpProbFunc(prob, hpBase);
            //颜色
            var color = FireDeal.getBlockColorByHp(Hp);
            var data = {Hp: Hp, Color: color};
            randomList.push(data);
            if (randomList.length >= num) {
                break;
            }
        }
        while (randomList.length < num) {
            var randIdx = Tool.randN(0, probArry.length);
            randIdx = Math.min(randIdx, probArry.length - 1);
            var prob = probArry[randIdx];
            var Hp = FireDeal.getHpProbFunc(prob, hpBase);
            //颜色
            var color = FireDeal.getBlockColorByHp(Hp);
            var data = {Hp: Hp, Color: color};
            randomList.push(data);
        }
        return randomList;
    },
    getHpProbFunc: function (probPram, hpBase) {
        var min = probPram.minP;
        var max = probPram.maxP;
        var randP = Tool.randN(min, max);
        var Hp = hpBase;
        Hp = hpBase * (randP / 100.0);
        Hp = Math.floor(Hp);
        Hp = Math.max(Hp, 1);
        return Hp;
    },
    getHpProbByRow: function (row) {
        var probList = FireConfig.BlockGenerateProb;
        var probArry = null;
        for (var i = 0; i < probList.length; i++) {
            var dataData = probList[i];
            if (row <= dataData._rowLimt) {
                probArry = dataData._probArry;
                break;
            }
        }
        return probArry;
    },
    getBlockColorByHp: function (hp) {
        var hpBase = FireDeal.getAverageDemageOfLv();
        //颜色
        var probList = FireConfig.BlockGenerateProb;
        var minHp = hpBase * probList[0]._probArry[0].minP / 100;
        var maxHp = hpBase * probList[probList.length - 1]._probArry[4].maxP / 100;
        var colorIdx = Math.floor((hp - minHp) / (maxHp - minHp) * FireConfig.BlockColor.length);
        colorIdx = Math.min(colorIdx, FireConfig.BlockColor.length - 1);
        colorIdx = Math.max(colorIdx, 0);
        var color = FireConfig.BlockColor[colorIdx];
        return color;
    },
    getRandomBlocksMode: function () {
        var modeList = FireConfig.BlocksModeType;
        if (modeList.length == 0) return null;
        var sum = 0;//概率和
        for (var i = 0; i < modeList.length; i++) {
            sum += modeList[i]._prob;
        }
        var ranNum = Tool.randN(0, sum);
        var randIdx = 0;
        sum = 0;
        for (var i = 0; i < modeList.length; i++) {
            sum += modeList[i]._prob;
            if (ranNum < sum) {
                randIdx = i;
                break;
            }
        }
        //var randIdx = Tool.randN(0,modeList.length);
        //randIdx = Math.min(randIdx,modeList.length-1);
        return modeList[randIdx];
    }
}