/**
 * Created by cc on 2017/12/21.
 */

var FirePlan = cc.Node.extend({
    _spriteBody:null,
    _bodySize:null,
    _gameDelgate:null,
    _bodyBall2:null,
    _bodyBall3:null,
    _bodyList:null,
    _headRadius:0,
    _bodyRadius:0,

    _anchorX:0,
    _anchorY:0,
    _snakeSpeed:0,
    ctor:function(){
        this._super();

        this._bodySize = cc.size(58,66);;//cc.size(58,66);
        this._rect = cc.rect(0,0,this._bodySize.width-16,this._bodySize.height-20);
        this._contentSize = cc.size(0,0);
        this._anchorX = this._rect.width/2;
        this._anchorY = 17;

        this._spriteBody = new cc.Sprite(resFireup.fireupPlan);
        this._spriteBody.setAnchorPoint(0.5,this._anchorY/this._bodySize.height);
        //this._spriteBody.setVisible(false);
        //this._spriteBody.setPosition(this._bodySize.width/2,this._bodySize.height/2);
        this.addChild(this._spriteBody);
        this._headRadius = 29;
        this._bodyList = [];

        return true;
    },
    initM:function () {
       var pos = this.getPosition();
       var snakHead = SnakeHelper.createSnake(3, this._gameDelgate,pos);
       SnakeHelper.snakeHead = snakHead;
       snakHead._numLabel.setVisible(false);
       snakHead._image.setTexture(resFireup.fireupPlan);
       snakHead._image.setAnchorPoint(cc.p(0.5, this._anchorY/this._bodySize.height));
       this._snakeSpeed = Math.floor(this._gameDelgate._gameSpeed/60);
       SnakeHelper.gameSpeed = this._snakeSpeed;
       var nextNode = snakHead._nextNode;
       do {
           if (!nextNode) break;
           nextNode._image.setTexture(resFireup.fireBullet);
           nextNode._image.setColor(FireConfig.PLANE_COLOR);
           nextNode = nextNode.getNextSnakeNode();

       } while (true);
    },
    onUpdate:function(dt){
        SnakeHelper.adjustP();
        SnakeHelper.addPath(cc.p(0, this._snakeSpeed));
        this.x = SnakeHelper.snakeHead.x;
    },
    moveBy:function(dPos){
        var winSize = cc.winSize;
        var curPos = this.getPosition();
        //var curPos = SnakeHelper.snakeHead.getPosition();
        var nxtPos = cc.p(curPos.x+ dPos.x,curPos.y);
        if(nxtPos.x < this._bodySize.width/2){
            nxtPos.x = this._bodySize.width/2;
        }else if(nxtPos.x > (winSize.width - this._bodySize.width/2)){
            nxtPos.x = winSize.width - this._bodySize.width/2;
        }
        var touchObstacle = false;
        var obstacleList = this._gameDelgate._blocksLayer.getBlocksList();
        var rectBox = this.getBox();
        for(var j = 0; j < obstacleList.length; j++)
        {
            var block = obstacleList[j];
            rectBox.x = nxtPos.x - this._bodySize.width / 2;
            rectBox.y = nxtPos.y - this._bodySize.height / 2;
            if(this._gameDelgate.isCollision(rectBox,block.getBox()))
            {
                touchObstacle = true;
                break;
            }
        }
        if(touchObstacle == false){
            //this.setPosition(nxtPos);
            SnakeHelper.addPath(cc.p(nxtPos.x-curPos.x,0));
        }
        //cc.log("FirePlan::x="+nxtPos.x+",y="+nxtPos.y);
    },
    setSkill:function(type){
        if(this.getChildByTag(99)){
            this.removeChildByTag(99);
        }
        var spSkill = null;
        switch(type){
            case FireConfig.ItemSpeedUp:
                spSkill = new cc.Sprite(resFireup.itemSpeedUpSid);
                break;
            case FireConfig.ItemHeavyAtk:
                spSkill = new cc.Sprite(resFireup.itemHeavyAtkSid);
                break;
            case FireConfig.ItemDoubleFir:
                spSkill = new cc.Sprite(resFireup.itemDoubleSid);
                break;
        }
        if(spSkill){
            spSkill.x = this._spriteBody.x;
            spSkill.y = this._spriteBody.y;
            this.addChild(spSkill,1,99);
        }
    },
    removeSkill:function(){
        var spSkill = this.getChildByTag(99);
        if(spSkill){
            spSkill.removeFromParent();
        }
    },
    getBox:function(){
        var pos = this.getPosition();
        this._rect.x = pos.x - this._anchorX;//this._bodySize.width / 2;
        this._rect.y = pos.y - this._anchorY;//this._bodySize.height / 2;
        return this._rect;
        //return this.getBoundingBox()
    }
});
