/**
 * Created by 13075 on 2017/11/13.
 */


var FireReliveLayer = wb.BaseLayer.extend({
    timeNum: 10,
    isShowVideo: false,
    ctor: function () {
        this._super(res.reviveLayer_json);
        this.initData();
        this.initUI();
        return true;
    },
    onEnter: function () {
        this._super();

    },
    onExit: function () {
        this._super();
        this.timeNum = 10;
        this.isShowVideo = false;
        wb.EventManager.removeListener(this.listener);
    },
    initData: function () {

        this.timeNum = 10;
        this.schedule(this.timeDown, 1);

        this.listener = wb.EventManager.addCustomEventListener("jvigame_PaySucced", function () {
            var coin = wb.GameHelper.getCoin();
            this.diamondText.setString(coin);
            this.coin = coin;
        }.bind(this));
    },
    timeDown: function () {
        if (this.isShowVideo) return;
        this.timeNum--;
        this.timeText.setString(this.timeNum);

        if (this.timeNum <= 0) {
            FireSceneManger.showOverLayer();
            this.closeLayer();
        }

    },
    initUI: function () {
        this.timeText = wb.FW(this.rootNode, "timeText");
        this.timeText.setString(this.timeNum);

        var circleImage = wb.FW(this.rootNode, "circleImage");
        circleImage.setVisible(false);

        var circle = new cc.Sprite(res.circle_png);
        circle.setColor(cc.color(255, 92, 37));
        var loading = new cc.ProgressTimer(circle);
        loading.type = cc.ProgressTimer.TYPE_RADIAL;
        loading.setPosition(circleImage.getPosition());
        var to = cc.progressFromTo(10, 100, 0);
        loading.runAction(cc.sequence(to, cc.callFunc(function (tag) {
            //this._circlebg.runAction(cc.scaleTo(0.2, 1));
        }, this)));
        this.rootNode.addChild(loading);

        var coin = wb.GameHelper.getCoin();
        this.diamondText = wb.FW(this.rootNode, "diamondText");
        this.diamondText.setString(coin);

        wb.FW(this.rootNode, "closeBtn", function () {
            FireSceneManger.showOverLayer();
            this.closeLayer();
        }.bind(this));

        var thlbflag = wb.PayManager.getGiftCtrlFlagUse(2);
        var noAdlbflag = wb.PayManager.getGiftCtrlFlagUse(1);

        this.coin = coin;
        var coinBtn = wb.FW(this.rootNode, "coinBtn", function () {

            if (this.coin < 10) {
                if (noAdlbflag == 1 && wb.getADEnabled()) {
                    wb.showNoAdLayer();
                } else if (thlbflag == 2) {
                    wb.showThlbLayer();
                } else {
                    wb.showToast("钻石不足~");
                }
            } else {
                wb.GameHelper.subCoin(10);
                this.reLive();
                this.closeLayer();
            }
        }.bind(this));

        var videoBtn = wb.FW(this.rootNode, "videoBtn", function () {
            this.isShowVideo = true;
            videoBtn.setTouchEnabled(false);
            wbTool.openAdC("level_fail_mfzs", function (adSourceItem, result) {
                Tool.playMusic(res.bkmusic_mp3, true);
                videoBtn.setTouchEnabled(true);
                if (result == 0) {
                    this.reLive();
                    this.closeLayer();
                    wb.DataTJManager.event2("qqybk_ad", "video_win");
                } else {
                    wb.DataTJManager.event2("qqybk_ad", "video_lose");
                }
                this.isShowVideo = false;
                
                loading.stopAllActions();
                loading.runAction(cc.progressFromTo(this.timeNum, 100, 0));
                loading.setPercentage(this.timeNum * 10);
            }.bind(this));
        }.bind(this));

        var isReady = wb.ADManager.isAdReady("level_fail_mfzs");
        if (!isReady || FireData.reviveNum == 1) videoBtn.setVisible(false);
        //if (coin < 10) coinBtn.setVisible(false);
    },
    reLive: function () {
        this.closeLayer();
        FireSceneManger._gameScene.gameRelive();
    }
});