/**
 * Created by Zack on 2017/10/11.
 */

var GradientLayer = cc.Layer.extend({
    ctor: function () {
        this._super();
        var shadeLayer = new cc.LayerColor(cc.color(18, 18, 18));
        this.addChild(shadeLayer);
    }
});

var GameMainLayer = cc.Layer.extend({
    sprite: null,
    bkLayer: null,
    beganLayer: null,
    isTouching: false,
    ctor: function () {
        this._super();
        Config.ADFlag = true;
        cc.log("GameMainLayer ctor");
        SnakeHelper.gameMain = this;

        var gradientLayer = new GradientLayer();
        this.addChild(gradientLayer);

        this.bkLayer = new BkLayer();
        this.addChild(this.bkLayer);

        //this.beganLayer = new BeganLayer();
        //this.addChild(this.beganLayer);

        this.addTouchListener();
      //  this.addKeyBoard();

        if (Logic.dStartGame) this.beganLayer.remove();
       // else  wbTool.openAd("home");
        Tool.playMusic(res.bkmusic_mp3, true);

        //// 添加闪屏
        //var logoLayer = new LogoLayer();
        //this.addChild(logoLayer, 10);
        //this.scheduleOnce(function () {
        //    logoLayer.removeFromParent();
        //}.bind(this), 2.0);
        return true;
    },
    onEnter:function(){
        this._super();
        this.beganToolMode();
    },
    addKeyBoard: function () {
        // cc.eventManager.addListener({
        //     event: cc.EventListener.KEYBOARD,
        //     onKeyReleased: function (key, event) {
        //         if (key == cc.KEY.back) {
        //             var target = event.getCurrentTarget();
        //             if(target.getChildByTag(99)){
        //                 return;
        //             }
        //             if(SnakeHelper.bkLayer.isGaming == true){
        //                 SnakeHelper.bkLayer.showGamePause(null);
        //             }else{
        //                 var exitLayer = new GameExitLayer();
        //                 target.addChild(exitLayer,99,99);
        //             }
        //             //wbTool.openExitGame();
        //         }
        //     }
        // }, this);

    },
    addTouchListener: function () {

        cc.eventManager.addListener({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: this.onTouchBegan,
            onTouchMoved: this.onTouchMoved,
            onTouchEnded: this.onTouchEnded,
            onTouchCancelled: this.onTouchCancelled
        }, this);
    },
    onTouchBegan: function (touch, event) {
        //cc.log("onTouchBegan");
        if (this.isTouching) return false;
        var tag = event.getCurrentTarget();
        var pos = touch.getLocation();
        tag._startPoint = pos;
        this.isTouching = true;
        return true;
    },
    onTouchMoved: function (touch, event) {
        if (!SnakeHelper.bkLayer.isGaming) return;
        if (!SnakeHelper.bkLayer.isMoveEnable) return;
        var tag = event.getCurrentTarget();
        var pos = touch.getLocation();
        //  var dp = cc.p(pos.x - tag._startPoint.x, pos.y - tag._startPoint.y);
        var dp = cc.p(pos.x - tag._startPoint.x, 0);
        SnakeHelper.addPath(dp);
        tag._startPoint = pos;
    },
    onTouchEnded: function (touch, event) {
        var tag = event.getCurrentTarget();
        tag._startPoint = touch.getLocation();
        this.isTouching = false;
    },
    onTouchCancelled: function (touch, event) {
        var tag = event.getCurrentTarget();
        tag._startPoint = touch.getLocation();
        this.isTouching = false;
    },
    beganToolMode:function(){
        Config.GAME_MODEL = 1;
        SnakeHelper.bkLayer.isGaming = true;
        SnakeHelper.bkLayer.itemLayer.setVisible(true);
        SnakeHelper.bkLayer.showGuide();
    }
});

var GameMainScene = cc.Scene.extend({
    onEnter: function () {
        this._super();

        Tool.init();
        Logic.init();
        SnakeHelper.init();

        var layer = new GameMainLayer();
        this.addChild(layer);
        wbTool.openAd("banner");
        wbTool.setAwakenCallback();
    }
});
