/**
 * Created by 13075 on 2017/11/13.
 */


var GameReviveLayer = wb.BaseLayer.extend({
    isShowVideo: false,
    ctor: function () {
        this._super(res.reviveLayer_json);
        this.initData();
        this.initUI();
        return true;
    },
    onExit: function () {
        this._super();
        wb.EventManager.removeListener(this.listener);
        SceneManger.isGameOver = false;
    },
    onEnter: function () {
        this._super();
        SceneManger.isGameOver = true;
    },
    initData: function () {
        this.timeNum = 10;
        this.schedule(this.timeDown, 1);

        this.listener = wb.EventManager.addCustomEventListener("jvigame_PaySucced", function () {
            var coin = wb.GameHelper.getCoin();
            this.diamondText.setString(coin);
            this.coin = coin;
        }.bind(this));
    },
    timeDown: function () {
        if (this.isShowVideo) return;
        this.timeNum--;
        this.timeText.setString(this.timeNum);

        if (this.timeNum <= 0) {
            SceneManger.showOverLayer();
            this.closeLayer();
        }

    },
    initUI: function () {
        this.timeText = wb.FW(this.rootNode, "timeText");
        this.timeText.setString(this.timeNum);

        var circleImage = wb.FW(this.rootNode, "circleImage");
        circleImage.setVisible(false);

        var circle = new cc.Sprite(res.circle_png);
        circle.setColor(cc.color(255, 92, 37));
        var loading = new cc.ProgressTimer(circle);
        loading.type = cc.ProgressTimer.TYPE_RADIAL;
        loading.setPosition(circleImage.getPosition());
        var to = cc.progressFromTo(10, 100, 0);
        loading.runAction(cc.sequence(to, cc.callFunc(function (tag) {
            //this._circlebg.runAction(cc.scaleTo(0.2, 1));
        }, this)));
        this.rootNode.addChild(loading);

        var coin = wb.GameHelper.getCoin();
        this.diamondText = wb.FW(this.rootNode, "diamondText");
        this.diamondText.setString(coin);

        wb.FW(this.rootNode, "closeBtn", function () {
            SceneManger.showOverLayer();
            this.closeLayer();
        }.bind(this));

        var thlbflag = wb.PayManager.getGiftCtrlFlagUse(2);
        var noAdlbflag = wb.PayManager.getGiftCtrlFlagUse(1);
        cc.log("thlbflag " + thlbflag);
        //noAdlbflag = 1;
        this.coin = coin;
        //wb.showThlbLayer();
        // this.coin = 100;
        var coinBtn = wb.FW(this.rootNode, "coinBtn", function () {
            if (this.coin < 10) {
                if (noAdlbflag == 1 && wb.getADEnabled()) {
                    wb.showNoAdLayer();
                } else if (thlbflag == 2) {
                    wb.showThlbLayer();
                } else {
                    wb.showToast("钻石不足~");
                }
            } else {
                wb.GameHelper.subCoin(10);
                this.reLive();
                this.closeLayer();
            }
        }.bind(this));



        var videoBtn = wb.FW(this.rootNode, "videoBtn", function () {
            this.isShowVideo = true;
            videoBtn.setTouchEnabled(false);
            wbTool.openAdC("level_fail_mfzs", function (adSourceItem, result) {
                videoBtn.setTouchEnabled(true);
                if (result == 0) {
                    //wb.JDataTJManager.event1("ad_ball_level_fail_mfzs");
                    this.reLive();
                    this.closeLayer();
                     wb.DataTJManager.event2("qqybk_ad", "video_win");
                } else {
                     wb.DataTJManager.event2("qqybk_ad", "video_lose");
                }
                this.isShowVideo = false;
                Tool.playMusic(res.bkmusic_mp3, true);
                loading.stopAllActions();
                loading.runAction(cc.progressFromTo(this.timeNum, 100, 0));
                loading.setPercentage(this.timeNum * 10);
            }.bind(this));
        }.bind(this));

        var isReady = wb.ADManager.isAdReady("level_fail_mfzs");
        if (!isReady || Logic.reviveNum == 1) videoBtn.setVisible(false);
        // if (coin < 10) coinBtn.setVisible(false);
    },
    reLive: function () {
        Config.ADFlag = false;
        SnakeHelper.bkLayer.isGaming = true;
        for (var i = 0; i < 4; i++) SnakeHelper.snakeHead.addSnakeNode();
        if (SnakeHelper.gameOverLayer) SnakeHelper.gameOverLayer.removeFromParent();

        var shield = SnakeHelper.snakeHead.getChildByName("shield");
        if (shield) shield.removeFromParent();
        var shield = new cc.Sprite(res.Shield_png);
        SnakeHelper.snakeHead.addChild(shield, 1, "shield");
        SnakeHelper.snakeHead.haveShield = true;
    }
});