/**
 * Created by Zack on 2017/10/12.
 */

var Logic = {
    isFirstRowLine: true, // 第一次的第一行
    cGPercent: 80, // 生成物品的概率 max 100
    //goodsPe: [0, 21, 30, 40, 5, 4, 0, 0], // 食物, 方块, 线, 盾，雪花,星星, 洞, 概率
    goodsPeList: [
        [0, 21, 30, 0, 0, 0, 0, 0],
        [0, 21, 30, 40, 5, 4, 0, 0]
    ], // 食物, 方块, 线, 盾，雪花,星星, 洞, 概率
    dStartGame: false, // 直接开始游戏
    goodsTypeMap1: null,
    goodsTypeMap2: null,
    coinScore: 0, // 到达分数后，获取金币模式
    isHole: false,
    holeExitIndex: 0, // 虫洞出口下标

    reviveNum: 0, // 复活次数
    init: function () {
        // cc.audioEngine.preloadEffect(res.bobo_mp3);
        Config.SNAKE_SPEED = Config.NORMAL_SPEED;
        Config.FROZEN_SPEED = Config.SNAKE_SPEED - 2;
        Config.GETSTART_SPEED = Config.SNAKE_SPEED + 4;
        Config.DGETCoinScore = 60;
        this.coinScore = 0;
        this.cGPercent = 80;
        this.isFirstRowLine = true;
        this.isHole = false;
        this.goodsTypeMap1 = [];
        for (var i = 0; i < Config.MAP_H; i++) {
            this.goodsTypeMap1.push([]);
        }

        this.goodsTypeMap2 = [];
        for (var i = 0; i < Config.MAP_H; i++) {
            this.goodsTypeMap2.push([]);
        }

        for (var i = 0; i < 12; i++) {
            var tag = cc.sys.localStorage.getItem("skinlock" + i);
            if (tag && tag == 1) {
                Config.SkinLock[i] = 1;
            } else {
                Config.SkinLock[i] = 0;
            }
        }
    },
    getGoodsMapByIndex: function (layerIndex) {
        var goodsTypeMap = this.goodsTypeMap1;
        if (layerIndex == 2) goodsTypeMap = this.goodsTypeMap2;
        return goodsTypeMap;
    },
    // 随着分数改变概率
    changeGPer: function () {
        if (this.cGPercent < 10) return;
        this.cGPercent = this.cGPercent - 0.06;
        // cc.log("cGPercent " + this.cGPercent);
    },
    GoodsItem: function (type, num) {
        return {goodsType: type, goodsNum: num};
    },
    getPercentNum: function (num, percentMin, percentMax) {
        var n = Tool.randN(0, num);
        if (n >= percentMin && n <= percentMax) return true;
        return false;
    },
    createGoods: function () {
        for (var i = 0; i < Config.MAP_H - 1; i++) {
            this.createRowItemType(i);
        }
    },
    createGoodsByRow: function (row, layerIndex) {
        this.createRowItemType(row, layerIndex);
    },
    createLastRowItemType: function (layerIndex) {
        var goodsType = ItemType.Block;
        // var goodsType = ItemType.None;

        if (SnakeHelper.bkLayer.isGetCoin) goodsType = ItemType.Coin;
        // 计算范围值
        if (!this.isFirstRowLine) {
            var sum = 0;
            // 创建范围随机数
            var snakeLength = SnakeHelper.snakeHead.snakeLength;
            /*var dsum = snakeLength + sum;
            var rand1 = Tool.randN(1, snakeLength);
            var rand2 = Tool.randN(1, snakeLength);
            var rand3 = Tool.randN(1, Config.BLOCK_MAXNUM);
            var rand4 = Tool.randN(1, Config.BLOCK_MAXNUM);
            var rand5 = Tool.randN(1, Config.BLOCK_MAXNUM);
            var rowItemNum = [rand1, rand2, rand3, rand4, rand5];*/

            var rowItemNum = [];
            var curScore = SnakeHelper.bkLayer.getCScore();
            var snakeConfig = Logic.getSnakeConfigBySocre(curScore);
            if (snakeConfig) {
                for (var i = 0; i < snakeConfig.BlockNum.length; i++) {
                    var blockCfg = snakeConfig.BlockNum[i];
                    var numMin = blockCfg.blockMin;
                    var numMax = numMin;
                    if ("snakeLengthAdd" in blockCfg) {
                        numMax = snakeLength + blockCfg.snakeLengthAdd;
                    } else {
                        numMax = blockCfg.blockMax;
                    }
                    var rand = Tool.randN(numMin, numMax);
                    rowItemNum.push(rand);
                }
            }

            // 打乱顺序
            rowItemNum.sort(function (a, b) {
                return 0.5 - Math.random();
            });
            for (var i = 0; i < rowItemNum.length; i++) {
                this.pushToGoodsMap(Config.MAP_H - 1, i, goodsType, rowItemNum[i], layerIndex);
            }
        } else {
            // 第一次的直线行
            for (var i = 0; i < Config.MAP_W; i++) {
                this.pushToGoodsMap(Config.MAP_H - 1, i, goodsType, Tool.randN(1, 2), layerIndex);
            }
            this.isFirstRowLine = false;
        }
    },
    createRowItemType: function (row, layerIndex) {
        for (var i = 0; i < Config.MAP_W; i++) {
            var type = this.createItemType(row, i, layerIndex);
            var num = this.createLabelNumByType();
            this.pushToGoodsMap(row, i, type, num, layerIndex);
        }
    },
    pushToGoodsMap: function (i, j, type, num, layerIndex) {
        //cc.log("i " + i + " j " + j);
        var goodsTypeMap = this.goodsTypeMap1;
        if (layerIndex == 2) goodsTypeMap = this.goodsTypeMap2;

        if (goodsTypeMap[i][j]) {
            goodsTypeMap[i][j].goodsType = type;
            goodsTypeMap[i][j].goodsNum = num;
        } else {
            goodsTypeMap[i][j] = this.GoodsItem(type, num);
        }
    },
    getGoodsByPercent: function () {
        var goodsPe = this.goodsPeList[Config.GAME_MODEL];
        var randN = Tool.randN(0, 100);
        var sum = 0;
        for (var i = 0; i < goodsPe.length; i++) {
            if (randN <= sum + goodsPe[i]) {
                return i;
            }
            sum = sum + goodsPe[i];
        }
        return ItemType.None;
    },
    createLabelNumByType: function (type) {
        var maxN = 5;
        if (ItemType.Block == type) maxN = Config.BLOCK_MAXNUM;
        return Tool.randN(1, maxN);
    },
    createItemType: function (row, i, layerIndex) {

        //var type = this.isCreateHole(row, i, layerIndex);
        //if (type)  return type;
        //return ItemType.None;

        // 洞
        if ((!SnakeHelper.bkLayer.isGetCoin || this.isHole) && Config.GAME_MODEL == 1) {
            var type = this.isCreateHole(row, i, layerIndex);
            if (type) return type;
        }

        //return ItemType.None;
        var isRoad = this.getPercentNum(100, 0, this.cGPercent);
        // 可通过路径
        if (isRoad) return ItemType.None;
        var type = this.getGoodsByPercent();

        // 方块不能挨着一条直线方块
        if ((row == 0 || row == 7) && ItemType.Block == type) return ItemType.None;
        // 得金币
        if (SnakeHelper.bkLayer.isGetCoin) {
            if (type == ItemType.Line) return type;
            return ItemType.Coin;
        }
        return type;
    },
    isCreateHole: function (row, column, layerIndex) {
        // 洞
        if (row == 7 && !this.isHole) {

            var randN = Tool.randN(0, 100);
            if (randN < 5) {  // %6 的概率
                this.isHole = true;
                this.holeExitIndex = Tool.randN(0, Config.MAP_W - 1);
                SnakeHelper.bkLayer.holeExitGoods = null;
                return ItemType.Hole;
            }
        }
        if (row == 0 && this.isHole && column == this.holeExitIndex) {
            this.isHole = false;
            return ItemType.HoleExit;
        }
        return null;
    },
    checkGetCoinMode: function () {
        // 触发得金币模式
        if (Logic.coinScore >= Config.DGETCoinScore) {
            var bkLayer = SnakeHelper.bkLayer;
            bkLayer.isGetCoin = true;
            bkLayer.isFrozen = false;
            Logic.coinScore = 0;
            SnakeHelper.gameSpeed = Config.GETSTART_SPEED;//Config.SNAKE_SPEED = Config.GETSTART_SPEED;
            bkLayer.setTimeN(8);
            var windLayer = new WindLayer();
            bkLayer.addChild(windLayer, 0);
            bkLayer._windLayer = windLayer;
            bkLayer.showToast(SpecialType.CoinTip);
            Config.DGETCoinScore = Config.DGETCoinScore * 1.5;

            //Config.NORMAL_SPEED = 8;
        }
    },
    addSnakeSpeed: function (score) {

    },
    getSnakeConfigBySocre: function (score) {
        for (var i = 0; i < Config.SnakeLevel.length; i++) {
            var config = Config.SnakeLevel[i];
            if (score > config.scoreUp) {
                continue;
            }
            return config;
        }
        return null;
    }
};

