/**
 * Created by 13075 on 2017/11/13.
 */


var QQSceneLayer = wb.BaseLayer.extend({
    itemList: null,
    lockList: null,
    ctor: function () {
        this._super(res.qqSceneLayer_json);
        this.initData();
        this.initUI();
        this.flushUnlock();
    },
    initData: function () {
        this.itemList = [];
        this.lockList = [];

    },
    flushUnlock: function () {
        for (var i = 0; i < 6; i++) {
            var tag = wb.getItem("scenelock" + i, 0);
            //var tag = wb.GCUserDefault.getStringForKey("scenelock" + i, "0");

            if (i < 2) tag = "1";

            if (Config.isAllUnLock) tag = "1";

            this.lockList[i] = tag;

            var item = this.itemList[i];
            if (tag == 1) {
                wb.FW(item, "sceneImage").setOpacity(255);
                wb.FW(item, "lockImage").setVisible(false);
                item.islock = false;
            } else {
                wb.FW(item, "sceneImage").setOpacity(76);
                wb.FW(item, "lockImage").setVisible(true);
                item.islock = true;
            }
        }
    },
    initUI: function () {
        wb.FW(this.rootNode, "closeBtn", function () {
            this.closeLayer();
        }.bind(this));

        var itemPanel1 = wb.FW(this.rootNode, "itemPanel1");
        var itemPanel2 = wb.FW(this.rootNode, "itemPanel2");
        var scrollPanel = wb.FW(this.rootNode, "scrollPanel");

        var dh = itemPanel1.y - itemPanel2.y;

        this.listView = new ccui.ListView();
        this.listView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        this.listView.setTouchEnabled(true);
        this.listView.setBounceEnabled(true);
        // this.listView.setBackGroundImage("ccs-res/cocosui/green_edit.png");
        // this.listView.setBackGroundImageScale9Enabled(true);
        this.listView.setContentSize(scrollPanel.getContentSize());
        this.listView.setPosition(scrollPanel.getPosition());

        // this.listView.addEventListener(this.selectedItemEvent, this);
        scrollPanel.getParent().addChild(this.listView);

        for (var i = 0; i < BgSkinConfig.length; i++) {
            var item = itemPanel1.clone();
            item.skinIndex = i;
            item.frameImage = wb.FW(item, "frameImage");
            wb.FW(item, "sceneImage").loadTexture(res["scene" + i + "_png"], ccui.Widget.LOCAL_TEXTURE);

            item.addClickEventListener(function (tager) {
                cc.log("item.skinIndex " + tager.skinIndex);
                if (tager.islock) {
                    this.showLockLayer(tager);
                } else {
                    this.flushUI(tager);
                }
            }.bind(this));
            this.itemList.push(item);
            this.listView.addChild(item);
        }
        itemPanel1.setVisible(false);
        itemPanel2.setVisible(false);

        this.flushUI(this.itemList[BgSkinManger.skinIndex]);
    },
    flushUI: function (tager) {
        for (var i = 0; i < this.itemList.length; i++) {
            this.itemList[i].frameImage.setVisible(false);
        }
        BgSkinManger.skinIndex = tager.skinIndex;
        tager.frameImage.setVisible(true);
    },
    showLockLayer: function (tager) {
        this.selectTager = tager;
        var lockLayer = new SkinUnLockLayer(this.unlockScene, this);
        this.addChild(lockLayer, 100);
    },
    unlockScene: function () {
        // wb.GCUserDefault.setStringForKey("scenelock" + this.selectTager.skinIndex, "1");
        // wb.GCUserDefault.save();
        wb.setItem("scenelock" + this.selectTager.skinIndex, 1);
        this.flushUnlock();
        this.flushUI(this.selectTager);
    }
});