/**
 * Created by 13075 on 2017/11/13.
 */

var SetLayer = cc.Layer.extend({
    ctor: function () {
        this._super();

        var bkLayer = new cc.LayerColor(cc.color(0, 0, 0, 100));
        this.addChild(bkLayer);

        var bkSp9 = new cc.Scale9Sprite(res.framePopup_png, cc.rect(0, 0, 100, 100), cc.rect(25, 25, 50, 50));
        bkSp9.setPosition(cc.p(320, 560));
        bkSp9.width = 510;
        bkSp9.height = 760;
        this.addChild(bkSp9);

        var tiSp = new cc.Sprite(res.titlePopup_png);
        tiSp.setPosition(cc.p(320, 904));
        this.addChild(tiSp);

        var setIconSp = new cc.Sprite(res.voiceOpen_png);
        setIconSp.setPosition(cc.p(277, 914));
        this.addChild(setIconSp);

        var tileLabel = new cc.LabelTTF("声音", res.Hk7_font, 50);
        tileLabel.setAnchorPoint(cc.p(0, 0.5));
        tileLabel.setPosition(cc.p(313, 914));
        tileLabel.setColor(Config.BLACK_COLOR);
        this.addChild(tileLabel);

        var closeMenuItem = new cc.MenuItemImage(res.closeBtn_png, res.closeBtn_png, "",
            function () {
                this.removeFromParent();
            }, this);
        closeMenuItem.setPosition(cc.p(549, 933));
        //closeMenuItem.setScale(1.2);

        var effectMenuItem = new cc.MenuItemImage(res.setItemBtn_png, res.setItemBtn_png, "",
            function (target) {
                Tool.setEffect(!Tool.isEffectEnable);
                target.runAction(cc.sequence(cc.scaleTo(0.05, 1.1), cc.scaleTo(0.05, 1.0)));
                var node = target.getChildByName("effectIconSp");
                if (Tool.isEffectEnable) {
                    if (node) node.setTexture(res.voiceOpen_png);
                } else {
                    if (node) node.setTexture(res.voiceClose_png);
                }

            }, this);
        effectMenuItem.setPosition(cc.p(320, 760));

        var effectLabel = new cc.LabelTTF("游戏音效", res.Hk7_font, 36);
        effectLabel.setPosition(cc.p(180, 44));
        effectLabel.setColor(Config.BLACK_COLOR);
        effectMenuItem.addChild(effectLabel);

        var effectIconSp = new cc.Sprite(res.voiceOpen_png);
        effectIconSp.setPosition(cc.p(275, 44));
        effectMenuItem.addChild(effectIconSp, 0, "effectIconSp");

        if (Tool.isEffect()) effectIconSp.setTexture(res.voiceOpen_png);
        else effectIconSp.setTexture(res.voiceClose_png);

        var bkMenuItem = new cc.MenuItemImage(res.setItemBtn_png, res.setItemBtn_png, "",
            function (target) {
                Tool.setMusic(!Tool.isBackgroundEnable);
                target.runAction(cc.sequence(cc.scaleTo(0.05, 1.1), cc.scaleTo(0.05, 1.0)));
                var node = target.getChildByName("bkIconSp");
                if (Tool.isBackgroundEnable) {
                    if (node) node.setTexture(res.musicOpen_png);
                } else {
                    if (node) node.setTexture(res.musicClose_png);
                }

            }, this);
        bkMenuItem.setPosition(cc.p(320, 656));

        var bkLabel = new cc.LabelTTF("背景音乐", res.Hk7_font, 36);
        bkLabel.setColor(Config.BLACK_COLOR);
        bkLabel.setPosition(cc.p(180, 44));
        bkMenuItem.addChild(bkLabel);

        var bkIconSp = new cc.Sprite(res.musicOpen_png);
        bkIconSp.setPosition(cc.p(275, 44));
        bkMenuItem.addChild(bkIconSp, 0, "bkIconSp");

        if (Tool.isMusic()) bkIconSp.setTexture(res.musicOpen_png);
        else bkIconSp.setTexture(res.musicClose_png);

        var mu = new cc.Menu(closeMenuItem, effectMenuItem, bkMenuItem);
        mu.setPosition(cc.p(0, 0));
        this.addChild(mu);
    }
});
