/**
 * Created by 13075 on 2017/11/13.
 */
var SkinLayer = cc.Layer.extend({
    originP: cc.p(170, 762),
    touchRects: null,
    snakeHeads: null,
    selectBks: null,
    moveX: 2,
    selectIndex: 0,
    turnFlag: false,
    dx: 150,
    dy: 150,
    itemLockNode: [],
    ctor: function () {
        this._super();
        SnakeHelper.skinLayer = this;
        this.itemLockNode = [];
        this.selectBks = [];
        SnakeHelper.initSkin();
        var bkLayer = new cc.LayerColor(cc.color(0, 0, 0, 100));
        this.addChild(bkLayer);

        var bkSp9 = new cc.Scale9Sprite(res.framePopup_png, cc.rect(0, 0, 100, 100), cc.rect(25, 25, 50, 50));
        bkSp9.setPosition(cc.p(320, 560 + ScreenFixed.getCenterFixedDist()));
        bkSp9.width = 510;
        bkSp9.height = 760;
        this.addChild(bkSp9);

        var tiSp = new cc.Sprite(res.titlePopup_png);
        tiSp.setPosition(cc.p(320, 904 + ScreenFixed.getCenterFixedDist()));
        this.addChild(tiSp);

        var setIconSp = new cc.Sprite(res.skinBtn_png);
        setIconSp.setPosition(cc.p(277, 914 + ScreenFixed.getCenterFixedDist()));
        this.addChild(setIconSp);

        var tileLabel = new cc.LabelTTF("皮肤", res.Hk7_font, 60);
        //tileLabel.setAnchorPoint(cc.p(0, 0.5));
        tileLabel.setPosition(cc.p(320, 914 + ScreenFixed.getCenterFixedDist()));
        tileLabel.setColor(Config.BLACK_COLOR);
        this.addChild(tileLabel);

        var tipLabel = new cc.LabelTTF("点击观看视频后即可获得皮肤", res.Hk7_font, 22);
        tipLabel.setPosition(cc.p(320, 210 + ScreenFixed.getCenterFixedDist()));
        //tipLabel.setColor(Config.BLACK_COLOR);
        this.addChild(tipLabel);

        if (Config.isAllUnLock) tipLabel.setVisible(false);

        var closeMenuItem = new cc.MenuItemImage(res.closeBtn_png, res.closeBtn_png, "",
            function (target) {
                target.runAction(cc.sequence(cc.scaleTo(0.05, 1.1), cc.scaleTo(0.05, 1.0)));
                this.removeFromParent();
            }, this);
        closeMenuItem.setPosition(cc.p(549, 933 + ScreenFixed.getCenterFixedDist()));

        var mu = new cc.Menu(closeMenuItem);
        mu.setPosition(cc.p(0, 0));
        this.addChild(mu);

        this.createItems();
        this.createTouchRect();
        this.addTouchListener();
        this.scheduleUpdate();
        this.flushUnlock();

        this.selectBks[SnakeHelper.skinIndex].setVisible(true);
        // this.schedule(this.move, 0.02);
    },
    flushUnlock: function () {
        for (var i = 0; i < 12; i++) {
            //  var tag = wb.GCUserDefault.getStringForKey("skinlock" + i,"0");
           var tag = wb.getItem("skinlock" + i, "0");
            cc.log("flushUnlock tag " + tag + " i: " + i);
            if (i < 3) tag = "1";
            Config.SkinLock[i] = tag;

            if (Config.isAllUnLock) Config.SkinLock[i] = "1";
        }

        for (var i = 0; i < 12; i++) {
            if (Config.SkinLock[i] == "1") {
                this.itemLockNode[i].setVisible(false);
            } else {
                this.itemLockNode[i].setVisible(true);
            }
        }
    },
    createTouchRect: function () {
        this.touchRects = [];
        for (var i = 0; i < 4; i++) {
            for (var j = 0; j < 3; j++) {
                var p = cc.p(this.originP.x + j * this.dx - 60, this.originP.y - i * this.dy - 60 + ScreenFixed.getCenterFixedDist());
                var rect = cc.rect(p.x, p.y, 120, 120);
                this.touchRects.push(rect);
            }
        }
    },
    flushSelectBk: function (index) {
        for (var i = 0; i < this.selectBks.length; i++) {
            this.selectBks[i].setVisible(false);
        }
        this.selectBks[index].setVisible(true);
        SnakeHelper.skinIndex = index;
        SnakeHelper.snakeHead.setSnakeSkin(index);
    },
    addTouchListener: function () {
        cc.eventManager.addListener({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: this.onTouchBegan,
            onTouchEnded: this.onTouchEnded
        }, this);
    },
    onTouchBegan: function (touch, event) {
        return true;
    },
    onTouchEnded: function (touch, event) {
        var tag = event.getCurrentTarget();
        var touchRects = tag.touchRects;
        for (var i = 0; i < touchRects.length; i++) {
            if (cc.rectContainsPoint(touchRects[i], touch.getLocation())) {
                cc.log("touchRects " + i);

                if (tag.itemLockNode[i].isVisible()) {
                    tag.selectIndex = i;
                    var skinUnLockLayer = new SkinUnLockLayer(tag.getByVideo, tag);
                    tag.addChild(skinUnLockLayer, 100);
                } else {
                    tag.flushSelectBk(i);
                }
                //  cc.sys.localStorage.setItem("skinlock" + i,1);
                //  tag.itemLockNode[i].setVisible(false);
                // BgSkinManger.skinIndex = i;
            }
        }
    },
    getByVideo: function () {
        cc.log("video sucess skin " + this.selectIndex);
       wb.setItem("skinlock" + this.selectIndex, "1");
        // wb.GCUserDefault.setStringForKey("skinlock" + this.selectIndex,"1");
        // wb.GCUserDefault.save();
        this.flushUnlock();
        this.flushSelectBk(SnakeHelper.skinLayer.selectIndex);
    },
    createLock: function () {
        var img_lock = new cc.Sprite(res.img_lock);
        var frameSkin2_png = new cc.Sprite(res.frameSkin2_png);
        img_lock.setPosition(cc.p(60, 60));
        frameSkin2_png.addChild(img_lock);
        return frameSkin2_png;
    },
    createItems: function () {
        for (var i = 0; i < 4; i++) {
            for (var j = 0; j < 3; j++) {
                var node = this.createItem(i, j);

                var lock = this.createLock();
                lock.setName("lock");
                node.addChild(lock);
                this.addChild(node, 1);
                this.itemLockNode.push(lock)
            }
        }
    },
    createItem: function (i, j) {
        var node = new cc.Node();
        node.setPosition(cc.p(this.originP.x + j * this.dx, this.originP.y - i * this.dy));
        node.y += (ScreenFixed.getCenterFixedDist());

        var selectbk = new cc.Sprite(res.frameSkinSelect_png);
        selectbk.setVisible(false);
        node.addChild(selectbk, 0, "selectbk");
        this.selectBks.push(selectbk);

        var bk = new cc.Sprite(res.frameSkin_png);
        node.addChild(bk);

        var index = i * 3 + j;
        var snakeHead = SnakeHelper.createSnake(3, bk, cc.p(60, 90), true, index);
        snakeHead.setSnakeSkin(index);
        return node;
    },
    update: function (dt) {

        for (var i = 0; i < SnakeHelper.snakeSkinHeads.length; i++) {
            SnakeHelper.adjustP(true, i);
            SnakeHelper.addPath(cc.p(0, Config.SNAKE_SPEED), true, i);
        }
    },
    move: function (dt) {
        for (var i = 0; i < SnakeHelper.snakeSkinHeads.length; i++) {
            var head = SnakeHelper.snakeSkinHeads[i];
            var headPX = head.getPositionX();
            if (headPX >= 120) {
                this.moveX = -Config.SNAKE_SPEED;
            } else if (headPX <= 60) {
                this.moveX = Config.SNAKE_SPEED;
            }
            SnakeHelper.addPath(cc.p(this.moveX, 0), true, i);

        }
    }
});