/**
 * Created by 13075 on 2017/10/11.
 */

var ScreenFixed = {
    _scaleHeight: 0,
    getScaleHeight: function () {
        if (this._scaleHeight > 0) {
            return this._scaleHeight;
        }
        var scale = ((cc.view.getResolutionPolicy() == cc.ResolutionPolicy.FIXED_WIDTH) ? (cc.winSize.height / 1136) : (1));
        this._scaleHeight = scale;
        return scale;
    },
    getCenterFixedDist: function () {
        var dist = (cc.winSize.height - 1136) / 2;
        dist = Math.max(0, dist);
        return dist;
    },
    getTopFixedDist: function () {
        var dist = (cc.winSize.height - 1136);
        dist = Math.max(0, dist);
        return dist;
    }
};

var Tool = {
    isEffectEnable: true,
    isBackgroundEnable: true,
    isADEnable: true,
    init: function () {
        if (this.isEffect()) this.isEffectEnable = true;
        else this.isEffectEnable = false;

        if (this.isMusic()) this.isBackgroundEnable = true;
        else this.isBackgroundEnable = false;

        if (cc.sys.isNative) {
            this.isADEnable = wb.getItem("ADEnabled", true);
        }
    },
    isFirstPlay: function () {
        var firstPlay = wb.getItem("firstPlay", "0");

        if (firstPlay != "1") {
            wb.setItem("firstPlay", "1");
            return true;
        }
        return false;

        // var firstPlay = cc.sys.localStorage.getItem("firstPlay");
        // if (firstPlay || firstPlay == "yes") return false;
        // cc.sys.localStorage.setItem("firstPlay", "yes");
       // return true;
    },
    randN: function (min, max) {
        return Math.floor(Math.random() * (max - min + 1) + min);
    },
    randBool: function () {
        if (this.randN(1, 10) < 5) return true;
        return false;
    },
    getBlockColorIndex: function (num) {
        if (num <= 0) return 0;
        var index = Math.floor(num / 5);
        if (index > Config.BLOCK_COLOR.length - 1) return Config.BLOCK_COLOR.length - 1;
        return index
    },
    setBestScore: function (num) {
        // var n = parseInt(num);
        // wb.GCUserDefault.setIntegerForKey("bestScore", n);
        cc.sys.localStorage.setItem("bestScore", "" + num);
    },
    getBestScore: function () {
         var score = cc.sys.localStorage.getItem("bestScore");
       // var score = wb.GCUserDefault.getIntegerForKey("bestScore", 0);
        if (!score) score = 0;
        return parseInt(score);
    },
    saveBestScore: function (num) {
        var bestScore = this.getBestScore();
        if (num > bestScore) this.setBestScore(num);
        // 上传分数
        wb.GameHelper.sumbitUserScore(parseInt(this.getBestScore()), 206);
        // 统计
        wbTool.tjEvent("game_ssdzz", "score_" + this.getBestScore());

    },
    explosion: function (p, node) {
        p = cc.pAdd(p, cc.p(0, Config.SNAKE_RADIUS2));
        var totalN = 4;
        var maxL = 150;
        var skinObj = Config.Skin[SnakeHelper.skinIndex];

        for (var i = 0; i < totalN; i++) {
            var angle = Tool.randN(0, 360);
            var dP = cc.pRotateByAngle(cc.p(maxL, 0), cc.p(0, 0), angle);
            var moveP = cc.pAdd(dP, p);
            var dotSp = new cc.Sprite(res.SnakeDot_png);
            dotSp.setColor(skinObj.explosionColor);
            dotSp.setScale(0.4);
            var action = cc.sequence(cc.spawn(cc.moveTo(0.4, moveP), cc.scaleTo(0.4, 0.1)), cc.removeSelf());
            dotSp.setPosition(p);
            dotSp.runAction(action);
            node.addChild(dotSp);
        }
    },
    blockExplosion: function (p, node) {
        var totalN = 20;
        var maxL = Config.WINSIZEF().width;
        for (var i = 0; i < totalN; i++) {
            var x = Tool.randN(0, Config.BLOCK_WH) - Config.BLOCK_WH2;
            var y = Tool.randN(0, Config.BLOCK_WH) - Config.BLOCK_WH2;
            var bP = cc.p(p.x + x, p.y + y);
            var dotSp = new cc.Sprite(res.SnakeDot_png);
            dotSp.setPosition(bP);
            dotSp.setScale(0.2);
            var moveP = cc.pAdd(p, cc.pMult(cc.pNormalize(cc.p(x, y)), maxL));

            var action = cc.sequence(cc.spawn(cc.moveTo(2, moveP).easing(cc.easeOut(1)), cc.scaleTo(2, 0.2)), cc.removeSelf());
            dotSp.runAction(action);
            node.addChild(dotSp);
        }
    },

    playEffect: function (char, bool) {
        if (!this.isEffectEnable) return;
        cc.audioEngine.playEffect(char, bool);
    },
    setEffect: function (flag) {
        this.isEffectEnable = flag;
        if (cc.sys.isNative) {
            wb.setItem("sound", flag ? "1" : "0");
        }
    },
    playMusic: function (char, bool) {
        if (!this.isBackgroundEnable) return;
        cc.audioEngine.playMusic(char, bool);
    },
    setMusic: function (flag) {
        this.isBackgroundEnable = flag;
        if (this.isBackgroundEnable) {
            //Tool.playMusic(res.bkmusic_mp3, true);
        } else {
            cc.audioEngine.stopMusic();
        }
        if (cc.sys.isNative) {
            wb.setItem("music", flag ? "1" : "0");
           // wb.GCUserDefault.save();
        }
    },
    isEffect: function () {
        cc.log("isEffect");
        if (cc.sys.isNative) {
            var sound = wb.getItem("sound", "1") == "1" ? true : false;
            return sound;
        }
        return true;
    },
    isMusic: function () {
        if (cc.sys.isNative) {
            var music = wb.getItem("music", "1") == "1" ? true : false;
            return music;
        }
        return true;
    },

    setMusicVolume: function (volme) {
        cc.audioEngine.setMusicVolume(volme);
    },
    setEffectVolume: function (volme) {
        cc.audioEngine.setEffectsVolume(volme);
    },
    calljsbEnd: function () {
        jsb.reflection.callStaticMethod("org/cocos2dx/cpp/AppActivity", "endGame", "()V");
    }
};

var wbTool = {
    check: function () {
        if (!this.isNative()) return true;
        // return wb.JSignature.check();
    },
    openAdC: function (str, func) {
        cc.audioEngine.stopMusic();
     //   if (wb.ADManager.isAdReady(str)) {
            wb.ADManager.openAdC(str, func);
     //   }
    },
    closeAd: function (name) {
        if (!this.isNative()) return;
        wb.ADManager.closeAd(name);
    },
    initManger: function () {
        if (!this.isNative()) return;
        //wb.JMMChnlManager.init();
        //wb.ADManager.init();
        //wb.PayManager.init();
        //wb.JDataTJManager.init();
        //wb.JPushManager.init(true);
    },
    isNative: function () {
        if (cc.sys.isMobile) return true;
        return false;
    },
    openAd: function (name) {
        if (!this.isNative()) return;
        if (Tool.isADEnable == false) return;
        wb.ADManager.openAd(name);
    },
    closeAd: function (name) {
        if (!this.isNative()) return;
        wb.ADManager.closeAd(name);
    },
    playEffect: function (char, bool) {
        cc.audioEngine.playEffect(res.bobo_mp3);
    },

    setAwakenCallback: function () {
        // wb.ADManager.setAwakenCallback(function () {
        //     cc.log("AwakenCallback");
        //     this.openAd("game_awaken");
        // });
    },
    isExitGame: function () {
        if (!this.isNative()) return false;
        return wb.PayManager.isExitGame();
    },
    setOnGameExit: function () {
        wb.PayManager.setOnGameExit(function () {
            cc.director.end();
        })
    },
    openExitGame: function () {
        if (this.isExitGame()) {
            cc.log("openExitGame 1");
            this.setOnGameExit();
            wb.PayManager.openExitGame();
        } else {
            cc.director.end();
        }
    },
    isHotAssets: function () {
        if (!this.isNative()) return false;
        return true;
    },
    tjEvent: function (key, value) {
        if (value) wb.JDataTJManager.event2(key, value);
        else wb.JDataTJManager.event2(key, key);
    }
};

var SceneManger = {
    showReviveLayer: function () {
        // var coin = wb.GameHelper.getCoin();
        // var isReady = wb.ADManager.isAdReady("level_fail_mfzs");
        // if (coin < 10 && !isReady) {
        //     this.showOverLayer();
        // } else {
        //     cc.director.getRunningScene().addChild(new GameReviveLayer(), 10);
        // }
        if (Logic.reviveNum < 2) {
            cc.director.getRunningScene().addChild(new GameReviveLayer(), 10);
            Logic.reviveNum++;
        } else {
            this.showOverLayer();
        }
    },
    showOverLayer: function () {
        Logic.reviveNum = 0;
        cc.director.getRunningScene().addChild(new GameOverLayer(), 10);
    },
    backMain: function () {
        Logic.dStartGame = false;
        cc.director.runScene(new QQHomeScene());
    },
    rePlay: function () {
        Logic.dStartGame = false;
        cc.director.runScene(new GameMainScene());
    }
};